<?php
/**
 * @version		$Id: controller.php 115 2010-09-23 03:18:21Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class MyMuseController extends JController
{
	
	/**
	 * Custom Constructor
	 */

	function __construct($config = array())
	{
		
		parent::__construct($config);
		global $params;
	
		$db = &JFactory::getDBO();
		$query = "SELECT * FROM #__mymuse_store WHERE id=1";
		$db->setQuery($query);
		$store = $db->loadObject();

		
		$params	= &JComponentHelper::getParams( 'com_mymuse' );
		$params->merge( new JParameter( $store->params ) );

		$params->set('my_section_catalog',$store->my_section_catalog);
		$params->set('my_section_artists',$store->my_section_artists);
		$params->set('my_reviews_catid',$store->my_reviews_catid);
		$params->set('my_version',$store->version);
		
		$this->params= $params;
		$GLOBALS['params'] = $params;
		
	}

    /**
     * Method to add sample data
     *
     * @access    public
     */
    function addSampleData()
    {
        global $params;
        $db = JFactory::getDBO();
		
		?>
		<table width="700">
		<tr>
			<td valign="top" width="200"><img src="components/com_mymuse/assets/images/logo325.jpg"></td>
			<td>
			
			<ul>
		<?php

		//make a catelog category
        if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."images".DS."earth_phones.jpg",
		JPATH_ROOT.DS."images".DS."stories".DS."albums".DS."earth_phones.jpg")){
			echo "Could not copy image to albums image dir.";
		}
		$catalog_sec_id = $params->get('my_section_catalog');
		echo "<li><strong>".JText::_("Creating one Catalog Category.")."</strong><br />";
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."images".DS."earth_phones.jpg",
		JPATH_ROOT.DS."images".DS."stories".DS."albums".DS."earth_phones.jpg")){
			echo "Could not copy image to albums image dir.";
		}
		$query = "INSERT into #__mymuse_categories (title,alias,image,section,image_position,description,published,ordering) VALUES
		('World Music','world-music','albums/earth_phones.jpg','".  $catalog_sec_id ."','left','',1,0)
		";
		$db->setQuery($query);
		if(!$db->query()){
			echo JText::_("Problem with creating one catalog category: ").$db->_errorMsg;
		}else{
			echo JText::_("Created Catalog Category 'World Music'");
			$catalog_cat_id = $db->insertid();
		}
		echo "<br />";
		echo "</li>
		";


		// copy a preview to the preview dir
		$preview_dir = JPATH_ROOT.DS.$params->get('my_preview_dir');
    	echo "<li><strong>".JText::_("Copying one preview to directory.")."</strong><br />";
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."sister_preview.mp3",
		$preview_dir.DS."sister_preview.mp3")){
			echo JText::_("Could not copy preview to the preview directory.")."<br />";
		}
		
    	// copy files
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."images".DS."logo325.jpg",
		JPATH_ROOT.DS."images".DS."stories".DS."logo325.jpg")){
			echo JText::_("Could not copy image to albums image directory.")."<br />
			";
		}

		
		//create artist Iron Brew
		$artist_sec_id = $params->get('my_section_artists');
		echo "<li><strong>".JText::_("Creating one Artist.")."</strong><br />";
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."images".DS."ironbrew.jpg",
		JPATH_ROOT.DS."images".DS."stories".DS."artists".DS."ironbrew.jpg")){
			echo "Could not copy image to artists image dir.";
		}
		$query = "INSERT into #__mymuse_categories (title,alias,image,section,image_position,description,published,ordering) VALUES
		('Iron Brew','iron-brew','artists/ironbrew.jpg','".  $artist_sec_id ."','left','',1,0)
		";
		$db->setQuery($query);
		if(!$db->query()){
			echo JText::_("Problem with creating one artist: ").$db->_errorMsg;
		}else{
			echo JText::_("Created Artist 'Iron Brew'");
			$artist_cat_id = $db->insertid();
		}
		echo "</li>
		";
		
		//make download dir for Iron Brew
		echo "<li><strong>".JText::_("Making download directory for that artists albums.")."</strong> <br />";
		$dir =  JPATH_ROOT.DS."images".DS."A_MyMuseDownloads".DS."iron-brew";
		if(!file_exists($dir)){
			if(!JFolder::create($dir)){
				echo JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall")."<br />$dir";
				return false;
			}else{
				echo JText::_("Directory created")."<br />$dir";
			}
		}else{
			echo JText::_("Directory exists")."<br />$dir";
		}
		echo "<br />";
		echo "</li>
		";
		
		

		
		//insert one product
		echo "<li><strong>".JText::_("Adding one album.")."</strong><br />";
		$query ="INSERT INTO `jos_mymuse_product` ( `title`,`alias`,`introtext`,`fulltext`,`state`,
		`artistid`,`mask`,
		`created`,`created_by`,`checked_out`,`checked_out_time`,`publish_up`,`publish_down`,`image`,
		`attribs`,`version`,`ordering`,`metakey`,`metadesc`,`metadata`,`product_physical`,
		`product_downloadable`,`product_allfiles`,`product_sku`,`product_made_date`,`product_in_stock`,
		`product_discount` ) 
		VALUES 
		('Are You My Sister','are-you-my-sister','Iron Brew\'s latest combines hard driving rhythms, pipes and whistles, and heartfelt emotions. 
		Warning, contains Celtic Nuts.','','1','$artist_cat_id','0','2010-02-19 02:55:27','62','0','0','2010-02-18 00:00:00','0000-00-00 00:00:00','sister.jpg','created_by=62\ncreated_by_alias=\naccess=0\ncreated=2010-02-19 02:45:45\npublish_up=2010-02-19 02:45:45\npublish_down=Never','1','1','','','robots=\nauthor=','1','0','0','myartist001','','','' )
		";
		$db->setQuery($query);
		if(!$db->query()){
			echo JText::_("Problem with adding album: ").$db->_errorMsg."<br /><br />
			";
		}else{
			echo JText::_("Created album 'Are You My Sister'")."<br /><br />"
			;
			$product_id = $db->insertid();
		}
		
		//make download dir for Product
		echo "<li><strong>".JText::_("Making download directory for that album.")."</strong> <br />";
		$dir =  JPATH_ROOT.DS."images".DS."A_MyMuseDownloads".DS."iron-brew".DS."are-you-my-sister";
		if(!file_exists($dir)){
			if(!JFolder::create($dir)){
				echo JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall.")."<br />$dir";
				return false;
			}else{
				echo JText::_("Directory created")."<br />$dir";
			}
		}else{
			echo JText::_("Directory exists")."<br />$dir";
		}
		echo "<br />";
		echo "</li>
		";
		
		//copy images to album dir
		echo "<li><strong>".JText::_("Copying images for album.")."</strong> <br />";
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."images".DS."earth_phones.jpg",
		JPATH_ROOT.DS."images".DS."stories".DS."albums".DS."earth_phones.jpg")){
			echo JText::_("Could not copy image to albums image dir")."<br />";
		}
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."images".DS."sister.jpg",
		JPATH_ROOT.DS."images".DS."stories".DS."albums".DS."sister.jpg")){
			echo JText::_("Could not copy image to albums image dir")."<br />";
		}
		echo "<br />";
		echo "</li>
		";
		
		// set up product category references
		if($product_id){
			echo "<li><strong>".JText::_("Setting up product.")."</strong> <br />";
			$query = "INSERT INTO #__mymuse_product_category_xref (catid,product_id) VALUES (
			$artist_cat_id,$product_id)";
			$db->setQuery($query);
			if(!$db->query()){
				echo JText::_("Problem with entering album/artist cross reference")."< br/>".$db->_errorMsg;
			}
			
			$query = "INSERT INTO #__mymuse_product_category_xref (catid,product_id) VALUES (
			$catalog_cat_id,$product_id)";
			$db->setQuery($query);
			if(!$db->query()){
				echo JText::_("Problem with entering catalog/artist cross reference")."< br/>".$db->_errorMsg;
			}
			
			$datenow =& JFactory::getDate();
            $created = $datenow->toMySQL();
			$query = "INSERT INTO #__mymuse_product_price (product_id,product_price,created,shopper_group_id) VALUES (
			$product_id,'20.00','$created',1)";
			$db->setQuery($query);
			if(!$db->query()){
				echo JText::_("Problem with entering price for album")."< br/>".$db->_errorMsg;
			}
			//add a track for download
			echo "<li><strong>".JText::_("Adding track for album.")."</strong><br />";
			$query = "INSERT INTO `jos_mymuse_product` (`title`, `alias`, `title_alias`, `introtext`,
			`fulltext`, `state`, `sectionid`, `artistid`, `mask`, `created`, `created_by`, `created_by_alias`, 
			`modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, 
			`images`, `image`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, 
			`access`, `hits`, `metadata`, `product_physical`, `product_downloadable`, `product_allfiles`, 
			`product_sku`, `product_made_date`, `product_in_stock`, `product_special`, `product_discount`, 
			`reservation_fee`, `product_package_ordering`, `product_package`, `file_length`, `file_name`, 
			`file_preview`, `file_downloads`, `file_contents`, `file_type`) VALUES
			('Are You My Sister', 'are-you-my-sister', '', '', 'Are You My Sister', 1, 0, 0, 0, 
			'2010-09-01 15:48:27', 62, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', 
			'2010-09-01 00:00:00', '0000-00-00 00:00:00', '', '', '', '', 1, $product_id, 2, '', '', 0, 0, '', 0, 1, 
			0, 'ayms02', '', 0, NULL, 0.00, 0.00, 0, 0, '3494653', '1_-_Are_You_My_Sister_.mp3', 
			'sister_preview.mp3', 0, '', 'audio/mpeg')";
			$db->setQuery($query);
			if(!$db->query()){
				echo JText::_("Problem with entering track for album")."< br/>".$db->_errorMsg;
			}
			$track_id = $db->insertid();
			$query = "INSERT INTO #__mymuse_product_price (product_id,product_price,created,shopper_group_id) VALUES (
			$track_id,'2.00','$created',1)";
			$db->setQuery($query);
			if(!$db->query()){
				echo JText::_("Problem with entering price for track")."< br/>".$db->_errorMsg;
			}
		}
		echo "<br />";
		echo "</li>
		";
		
		
		
		
		
		
	
		//add a shopper
		echo "<li><strong>".JText::_("Adding test shopper.")."</strong><br />";
		$query = "INSERT INTO `#__users` ( `name`, `username`, `email`, `password`, `usertype`, `block`, `sendEmail`, `gid`, `registerDate`, `lastvisitDate`, `activation`, `params`) VALUES 
('Gord Fisch', 'buyer', 'buyertest@gordfisch.net', '3e302cacbfd94989ee71983bf8d0f1f5:sfmJ2Ts5OOHDm5IkbDb2fKjVhJYjr6Vs', 'Registered', 0, 0, 18, '2010-03-28 18:26:48', '2010-03-31 01:07:23', '', '\n');";
		$db->setQuery($query);
		if(!$db->query()){
			echo JText::_("Problem with adding a joomla user: ").$db->_errorMsg."<br /><br />
			";
		}else{
			

			$next_user = $db->insertid();
			$query = "INSERT INTO `#__mymuse_shopper` (`id`, `user_id`, `address_type`, `address_type_name`, `shopper_group_id`, `company`, `title`, `last_name`, `first_name`, `middle_name`, `phone_1`, `phone_2`, `fax`, `address_1`, `address_2`, `city`, `state`, `country`, `zip`, `terms_of_service`, `comments`, `perms`, `created`, `modified`) VALUES
			(1, '$next_user', 'bt', NULL, 1, NULL, NULL, 'Fisch', 'Gord', NULL, '514-123-1234', NULL, NULL, '123 4th St.', NULL, 'Montreal', 'QC', 'CAN', 'H4A 1W2', '1', NULL, 'shopper', '0000-00-00 00:00:00', '0000-00-00 00:00:00');";
			$db->setQuery($query);
			if(!$db->query()){
				echo JText::_("Problem with adding a MyMuse shopper: ").$db->_errorMsg;
			}else{
				echo JText::_("Added a MyMuse shopper")."<br />";
				$query = "INSERT INTO `#__core_acl_aro` (`section_value`,`value`,`name`) VALUES
				('users','$next_user','Gord Fisch');";
				$db->setQuery($query);
				if(!$db->query()){
					echo JText::_("Problem with adding a MyMuse shopper: ").$db->_errorMsg;
				}else{
					$aro_id = $db->insertid();
					$query = "INSERT INTO `#__core_acl_groups_aro_map` (`group_id`,`aro_id`) VALUES
					('18','$aro_id');";
					$db->setQuery($query);
					if(!$db->query()){
						echo JText::_("Problem with adding a MyMuse shopper: ").$db->_errorMsg;
					}else{
						echo JText::_("Added a joomla User")."<br />";
						echo JText::_("Updated #__core_acl_aro ")."<br />";
						echo JText::_("Updated #__core_acl_groups_aro_map ")."<br />";
						echo JText::_("Added shopper username 'buyer', password 'buyer'");
					}
				}
			}
		}
		echo "<br /><br />";
		echo "</li>
		</ul>
		</td>
		</tr>
		</table>
		";
		
    }

    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }
	
}
?>