<?php
/**
 * @version		$Id: attributesku.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class myMuseControllerAttributesku extends myMuseController
{

	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'attributesku' );
		parent::__construct();
		
		// Register Extra tasks
		$this->registerTask( 'addattribute', 'editattribute' );
		$this->registerTask( 'apply', 'save' );
		

	}
	
	function listattribute(){

		parent::display();
	}

	/**
	 * Add/edit attribute
	 * 
	 * @param boolean $edit True if edit, False if new attribute
	 * @global $mainframe
	 */
	function editattribute(){
		global $mainframe;
		JRequest::setVar( 'view', 'attributesku' );
		JRequest::setVar( 'layout', 'attribute_form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'addattribute'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'editattribute'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		$model = $this->getModel('attributesku');
		$model->checkout();

		parent::display();
		
	}
	
	/**
	 * store the attribute to the database
	 * @return void
	 */
    function save()
    {
    	
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $model = $this->getModel('attributesku');
        $pid	= JRequest::getVar( 'product_parent_id', null, 'post', 'int' );
		$task = JRequest::getVar('task', null, 'default', 'cmd');
        if ($model->store($post)) {
        	switch ( $task)
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE ATTRIBUTE CHANGES SAVED' ); 
					$this->setRedirect( 'index.php?option=com_mymuse&controller=attributesku&parentid='.$pid.'&task=editattribute&cid[]='. $post['id'], $this->msg );

					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE ATTRIBUTE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=attributesku&parentid='.$pid.'', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING ATTRIBUTE' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=attributesku&task=edit&parentid='.$pid.'&cid[]=', $this->msg );
        }

    }
	
    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('attributesku');
        $pid	= JRequest::getVar( 'product_parent_id', null, 'post', 'int' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=attributesku&parentid='.$pid.'' );
    }
    
    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT AN ATTRIBUTE TO DELETE' ) );
        }


        $model = $this->getModel('attributesku');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
        }
        $pid	= JRequest::getVar( 'parentid', null, '', 'int' );
        $this->msg = JText::_( 'MYMUSE ATTRIBUTE DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=attributesku&parentid='.$pid, $this->msg );
    }
}