<?php
/**
 * @version		$Id: category.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class MyMuseControllerCategory extends MyMuseController
{

	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'category' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'category' );
		JRequest::setVar( 'layout', 'category_form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		$model = $this->getModel('category');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * store the item to the database
	 * @return void
	 */
    function save()
    {
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
        if($post['image'] != ''){
        	$post['image'] = "artists/".$post['image'];
        }
        $model = $this->getModel('category');

        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO CATEGORY SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=category&task=edit&cid[]='. $post['id'], $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE CATEGORY SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=category', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING CATEGORY' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=category&task=add&cid[]=', $this->msg );
        }
        $model->checkin();
    }
    
    function apply()
    {
        $this->save();
    }

    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A CATEGORY TO DELETE' ) );
        }
        $model = $this->getModel('category');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
            }
        $this->msg = JText::_( 'MYMUSE CATEGORY DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category', $this->msg  );
    }

    function publish()
    {

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A CATEGORY TO PUBLISH' ) );
        }
        $model = $this->getModel('category');
        if(!$model->publish($cid, 1)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
        }
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category' );
    }

    function unpublish()
    {

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A CATEGORY TO UNPUBLISH' ) );
        }
        $model = $this->getModel('category');
        if(!$model->publish($cid, 0)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
        }
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category' );
    }

    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('category');
        $model->checkin();
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category' );
    }

    function orderup()
    {
        $model = $this->getModel('category');
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category');
    }
    
    function orderdown()
    {
        $model = $this->getModel('category');
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category');
    }
    
    function saveorder()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        $order = JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel('category');
        $model->saveorder($cid, $order);
        $msg = JText::_('MYMUSE NEW ORDERING SAVED');
        $this->setRedirect( 'index.php?option=com_mymuse&controller=category', $msg );
    }
    
    function accesspublic()
    {
    	$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
    	$model = $this->getModel('category');
		if(!$model->accessMenu( $cid[0], 0 )){
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
		}else{
			$msg = JText::_('MYMUSE NEW ACCESS SAVED');
			$this->setRedirect( 'index.php?option=com_mymuse&controller=category', $msg );
			
		}
    }

	function accessregistered()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
    	$model = $this->getModel('category');
		if(!$model->accessMenu( $cid[0], 1 )){
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
		}else{
			$msg = JText::_('MYMUSE NEW ACCESS SAVED');
			$this->setRedirect( 'index.php?option=com_mymuse&controller=category', $msg );
			
		}
	}

	function accessspecial()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
    	$model = $this->getModel('category');
		if(!$model->accessMenu( $cid[0], 2 )){
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
		}else{
			$msg = JText::_('MYMUSE NEW ACCESS SAVED');
			$this->setRedirect( 'index.php?option=com_mymuse&controller=category', $msg );
			
		}
	}
	
	
	
    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }

	
}
?>