<?php
/**
 * @version		$Id: order.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class myMuseControllerOrder extends myMuseController
{



	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'order' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'order' );
		JRequest::setVar( 'layout', 'order_form');
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		$model = $this->getModel('order');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * store the item to the database
	 * @return void
	 */
    function save()
    {
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $post['note'] = JRequest::getVar( 'note', '', 'post', 'string', JREQUEST_ALLOWRAW );
        $model = $this->getModel('order');

        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO ORDER SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=order&task=edit&cid[]='. $this->id, $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE ORDER SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=order', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING ORDER' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=order&task=edit&cid[]=', $this->msg );
        }
        $model->checkin();
    }
    
    function apply()
    {
        $this->save() ;
    }

    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        //print_pre($cid); exit;
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT AN ORDER TO DELETE' ) );
        }
        $model = $this->getModel('order');
        //foreach($cid as $id){
        	if(!$model->delete($cid)) {
           	    echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>";
            	return false;
            }
        //}
        $this->msg = JText::_( 'MYMUSE ORDER DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=order',$this->msg );
    }


    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('order');
        $model->checkin();
        $this->msg = JText::_( 'MYMUSE ACTION CANCELLED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=order',$this->msg );
    }


	/**
	 * display the report
	 * @return void
	 */
	function report()
	{

		JRequest::setVar( 'view', 'order' );
		JRequest::setVar( 'layout', 'report');
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	
    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }

	



}
?>