<?php
/**
 * @version		$Id: product.php 155 2010-10-12 04:01:01Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class myMuseControllerProduct extends myMuseController
{

	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'product' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
        $this->registerTask( 'apply', 'save' );
        
        $this->registerTask( 'additem', 'edititem' );
        $this->registerTask( 'applyitem', 'saveitem' );
        
        $this->registerTask( 'addfile', 'edititem' );
        $this->registerTask( 'editfile', 'edititem' );
        $this->registerTask( 'savefile', 'saveitem' );
        $this->registerTask( 'applyfile', 'saveitem' );
        $this->registerTask( 'publishfile', 'publishitem' );
        $this->registerTask( 'unpublishfile', 'publishitem' );
        $this->registerTask( 'cancelfile', 'cancelitem' );
        $this->registerTask( 'removefile', 'removeitem' );
        
		$this->registerTask( 'new_allfiles', 'edititem' );
		$this->registerTask( 'edit_allfiles', 'edititem' );
		$this->registerTask( 'save_allfiles', 'saveitem' );
		$this->registerTask( 'apply_allfiles', 'saveitem' );
		
		$this->registerTask( 'addattribute', 'editattribute' );
		$task = JRequest::getVar( 'task' );

	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'product' );
		JRequest::setVar( 'layout', 'product_form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		$model = $this->getModel('product');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * store the product to the database
	 * @return void
	 */
    function save()
    {
    	
        $post = JRequest::get('post');
        
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
        $model = $this->getModel('product');
		$post['type'] = 'product';
		
        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO PRODUCT SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='. $model->_id, $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE PRODUCT SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING PRODUCT' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]=', $this->msg );
        }
        $model->checkin();
    }
    
    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A PRODUCT TO DELETE' ) );
        }


        $model = $this->getModel('product');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(null,true)."'); window.history.go(-1); </script>
            ";
            return false;
        }
        $this->msg = JText::_( 'MYMUSE PRODUCT DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=product', $this->msg );
    }

    function publish()
    {

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A PRODUCT TO PUBLISH' ) );
        }
        $model = $this->getModel('product');
        if(!$model->publish($cid, 1)) {
            echo "<script> alert('".$model->getError(null,true)."'); window.history.go(-1); </script>
            ";
            return false;
        }
        $this->setRedirect( 'index.php?option=com_mymuse&controller=product&cid[]='.$cid );
    }

    function unpublish()
    {

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A PRODUCT TO UNPUBLISH' ) );
        }
        $model = $this->getModel('product');
        if(!$model->publish($cid, 0)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
            return false;
        }
        $this->setRedirect( 'index.php?option=com_mymuse&controller=product&cid[]='.$cid );
    }

    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('product');
        $model->checkin();
        $this->setRedirect( 'index.php?option=com_mymuse&controller=product' );
    }

    function orderup()
    {
        $model = $this->getModel('product');
        $model->move(-1);
        $msg = 'Moved up one.';
        $type = JRequest::getVar('type',  0);
        if($type){
       		$parentid = JRequest::getVar( 'parentid', 0, '', 'int' );
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$parentid.'&type='.$type, $msg );
        }else{
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product');
        }
        
    }
    
    function orderdown()
    {
        $model = $this->getModel('product');
        $model->move(1);
    	$msg = 'Moved down one.';
        $type= JRequest::getVar('type',  0);
        if($type){
       		$parentid = JRequest::getVar( 'parentid', 0, '', 'int' );
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$parentid.'&type='.$type, $msg );
        }else{
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product');
        }
    }
    
    function saveorder()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        $order = JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel('product');
        $model->saveorder($cid, $order);
        $msg = 'New ordering saved';
        $type = JRequest::getVar('type',  0);
        if($type){
        	$parentid = JRequest::getVar( 'parentid', 0, '', 'int' );
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$parentid.'&type='.$type, $msg );
        }else{
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product', $msg );
        }
    }
    
    function accesspublic()
    {
    	$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
    	$model = $this->getModel('product');
		if(!$model->accessMenu( $cid[0], 0 )){
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
		}else{
			$msg = JText::_('MYMUSE NEW ACCESS SAVED');
			$this->setRedirect( 'index.php?option=com_mymuse&controller=product', $msg );
			
		}
    }

	function accessregistered()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
    	$model = $this->getModel('product');
		if(!$model->accessMenu( $cid[0], 1 )){
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
		}else{
			$msg = JText::_('New access saved');
			$this->setRedirect( 'index.php?option=com_mymuse&controller=product', $msg );
			
		}
	}

	function accessspecial()
	{
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
    	$model = $this->getModel('product');
		if(!$model->accessMenu( $cid[0], 2 )){
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
		}else{
			$msg = JText::_('MYMUSE NEW ACCESS SAVED');
			$this->setRedirect( 'index.php?option=com_mymuse&controller=product', $msg );
			
		}
	}
	/**
	 * 
	 * ITEMS & FILES 
	 */
	
	function edititem()
	{
		
		$model = $this->getModel('product');
		$model->checkout();
    	JRequest::setVar( 'view', 'product' );
    	
    	if($this->_task == 'edititem' || $this->_task == 'additem'){
    		$parentid = JRequest::getVar( 'parentid', array(), 'post', 'int' );
	    	if(!$model->checkAttributes()){
    			$this->msg = $model->getError();
    			$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='. $parentid, $this->msg );
    			return false;
    		}
    		JRequest::setVar( 'layout', 'product_item_form'  );
    	}elseif($this->_task == 'new_allfiles' || $this->_task == 'edit_allfiles'){
    		JRequest::setVar( 'layout', 'product_allfiles_form'  );
    	}else{
			JRequest::setVar( 'layout', 'product_file_form'  );
    	}
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
		
	}
	
	/**
	 * saveitem
	 * 
	 * store the item to the database
	 * @return void
	 */
    function saveitem()
    { 
    	
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $this->parentid = $post['parentid'];
        $model = $this->getModel('product');
		$post['fulltext'] = $post['title'];

		
    	// is this the special 'AllFiles'?
		if(isset($post['product_allfiles']) && $post['product_allfiles'] == 1){
			$post['type'] = 'allfiles';
		}elseif(!isset($post['type']) || $post['type'] == ""){
			$post['type'] = 'item';
		}

		if($post['type'] == "file" || $post['type'] == "allfiles"){
			if ($model->store($post)) {
				switch ( JRequest::getVar('task', null, 'default', 'cmd'))
				{
				case 'apply_allfiles':
					$this->msg = JText::_( 'MYMUSE CHANGES TO ALL FILE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit_allfiles&cid[]='. $post['id']."&type=".$post['type'], $this->msg );
					break;
				case 'save_allfiles':
					$this->msg = JText::_( 'MYMUSE ALL FILE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='. $this->parentid."&type=".$post['type'], $this->msg );
					break;
				case 'applyfile':
					$this->msg = JText::_( 'MYMUSE CHANGES TO FILE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=editfile&cid[]='. $post['id']."&type=".$post['type'], $this->msg );
					break;
				case 'savefile':
				default:
					$this->msg = JText::_( 'MYMUSE FILE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='. $this->parentid."&type=".$post['type'], $this->msg );
					break;
				}
			}else {
        		$this->msg = JText::_( 'MYMUSE ERROR SAVING FILE' ).": ".$model->getError();
        		$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$this->parentid."&type=".$post['type'], $this->msg );
        	}
 
			
		}elseif ($model->saveItem($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{

				case 'applyitem':
					$this->msg = JText::_( 'MYMUSE CHANGES TO ITEM SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edititem&cid[]='. $post['id']."&type=item", $this->msg );
					$this->edititem();
					break;

				case 'saveitem':
				default:
					$this->msg = JText::_( 'MYMUSE ITEM SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='. $this->parentid."&type=item", $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING ITEM ' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$this->parentid."&type=item", $this->msg );
        }
        $model->checkin();
    }
	
    function cancelitem()
    {
        // Checkin the item
        $model = $this->getModel('product');
        $model->checkin();
        $parentid = JRequest::getVar( 'parentid', '', 'post', 'int' );
        $type = JRequest::getVar( 'type', '', 'post' );
        $this->msg = JText::_( 'MYMUSE ITEM CANCELLED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$parentid.'&type='.$type,$this->msg );
    }
	

    function removeitem()
    {

        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT AN ITEM TO DELETE' ) );
        }
		$parentid = JRequest::getVar( 'parentid', '', 'post', 'int' );
		$type = JRequest::getVar( 'type', '', 'post' );
        $model = $this->getModel('product');

        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
            }
        $this->msg = JText::_( 'MYMUSE ITEM DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=product&task=edit&cid[]='.$parentid.'&type='.$type,$this->msg  );
    }
	
    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }

	
}
?>