<?php
/**
 * @version		$Id: shipping.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class mymuseControllerShipping extends mymuseController
{



	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'shipping' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'shipping' );
		JRequest::setVar( 'layout', 'shipping_form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		$model = $this->getModel('shipping');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * store the item to the database
	 * @return void
	 */
    function save()
    {
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $model = $this->getModel('shipping');

        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO SHIPPING SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=shipping&task=edit&cid[]='. $post['id'], $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE SHIPPING SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=shipping', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING SHIPPING RATE' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=shipping&task=edit&cid[]=', $this->msg );
        }
        $model->checkin();
    }
    
    function apply()
    {
        $this->save() ;
    }

    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A SHIPPING RATE TO DELETE' ) );
        }
        $model = $this->getModel('shipping');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
            }
        $this->msg = JText::_('MYMUSE SHIPPING RATE DELETE');
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shipping', $this->msg );
    }


    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('shipping');
        $model->checkin();
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shipping' );
    }

    function orderup()
    {
        $model = $this->getModel('shipping');
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shipping');
    }
    
    function orderdown()
    {
        $model = $this->getModel('shipping');
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shipping');
    }
    
    function saveorder()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        $order = JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel('shipping');
        $model->saveorder($cid, $order);
        $msg = JText::_('MYMUSE NEW ORDERING SAVED');
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shipping', $msg );
    }
	
	
	
    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }

}