<?php
/**
 * @version		$Id: shopper.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class mymuseControllerShopper extends mymuseController
{

	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'shopper' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
        $this->registerTask( 'apply', 'save' );

	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'shopper' );
		JRequest::setVar( 'layout', 'shopper_form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		$model = $this->getModel('shopper');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * store the shopper to the database
	 * @return void
	 */
    function save()
    {
    	
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $model = $this->getModel('shopper');
		$post['type'] = 'shopper';
		
        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO SHOPPER SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=shopper&task=edit&cid[]='. $post['shopper_id'], $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE SHOPPER SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=shopper', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING SHOPPER' ).' '.$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=shopper&task=edit&cid[]=', $this->msg );
        }
        $model->checkin();
    }
    
    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A SHOPPER TO DELETE' ) );
        }


        $model = $this->getModel('shopper');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
            return false;
        }
        $this->msg = JText::_( 'MYMUSE SHOPPER DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shopper', $this->msg );
    }


    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('shopper');
        $model->checkin();
        $this->setRedirect( 'index.php?option=com_mymuse&controller=shopper' );
    }

}
?>