<?php
/**
 * @version		$Id: store.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class MyMuseControllerStore extends MyMuseController
{

	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'store' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'store' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} break;
                
		}
		parent::display();
	}
	
	/**
	 * store the item to the database
	 * @return void
	 */
    function save()
    {
    	global $params;
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
        $model = $this->getModel('store');


        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO STORE SAVED' ).$query;
					$this->setRedirect( 'index.php?option=com_mymuse&controller=store&task=edit&cid[]='. $this->id, $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE STORE SAVED' ).$query;
					$this->setRedirect( 'index.php?option=com_mymuse', $this->msg );
					
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING STORE' );
        	
        }
        // Check the table in so it can be edited.... we are done with it anyway
        $model->checkin();
    }
    
    function apply()
    {
        $this->save() ;
    }

    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A STORE TO DELETE' ) );
        }
        $model = $this->getModel('store');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
            }
        $this->msg = JText::_( 'MYMUSE STORE DELETED' );
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store', $this->msg );
    }

    function publish()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A STORE TO PUBLISH' ) );
        }
        $model = $this->getModel('store');
        if(!$model->publish($cid, 1)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
        }
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store' );
    }

    function unpublish()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A STORE TO UNPUBLISH' ) );
        }
        $model = $this->getModel('store');
        if(!$model->publish($cid, 0)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
        }
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store' );
    }

    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('store');
        $model->checkin();
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store' );
    }

    function orderup()
    {
        $model = $this->getModel('store');
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store');
    }
    
    function orderdown()
    {
        $model = $this->getModel('store');
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store');
    }
    
    function saveorder()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        $order = JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel('store');
        $model->saveorder($cid, $order);
        $msg = 'New ordering saved';
        $this->setRedirect( 'index.php?option=com_mymuse&controller=store', $msg );
    }
    
    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }



}
?>