<?php
/**
 * @version		$Id: taxrate.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class myMuseControllerTaxRate extends myMuseController
{



	/**
	 * Custom Constructor
	 */

	function __construct()
	{
		JRequest::setVar( 'view', 'taxrate' );
		parent::__construct();
		
		// Register Extra tasks
        $this->registerTask( 'add', 'edit' );
		
	}

	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{

		JRequest::setVar( 'view', 'taxrate' );
		JRequest::setVar( 'layout', 'taxrate_form'  );
		JRequest::setVar('hidemainmenu', 1);
		switch($this->getTask()){
			case 'add'     :
			{
				JRequest::setVar( 'edit', false  );
			} 
			break;
			case 'edit'    :
			{
				JRequest::setVar( 'edit', true  );
			} 
			break;
                
		}
		$model = $this->getModel('taxrate');
		$model->checkout();
		parent::display();
	}
	
	/**
	 * store the item to the database
	 * @return void
	 */
    function save()
    {
        $post = JRequest::get('post');
        $cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        $post['id'] = (int)$cid[0];
        $this->id = $post['id'] ;
        $model = $this->getModel('taxrate');
        
        // See if it's a save or update
        $task = JRequest::getVar( 'task', '' );
        
        
        if($task == "save"){
        	$regex = TAX_REGEX;
        	$name = preg_replace("/$regex/","_",$post['tax_name']);
        	preg_match_all("/[^a-zA-Z_]/",$name,$m);

        	if (@$m[0]){
        		$this->msg = JText::_( 'MYMUSE ERROR SAVING TAX RATE' ).$m[0][0];
        		$this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate&task=edit&cid[]=', $this->msg );
        		return false;
        	}else{
        		$db = JFactory::getDBO();
        		$query = "ALTER TABLE `#__mymuse_order` ADD `$name` DECIMAL( 10, 2 ) NOT NULL DEFAULT '0.00'";
        		$db->setQuery($query);
        		$db->query();
        	}
        }elseif($post["old_tax_name"] != $post["tax_name"]){
        	$name = preg_replace("/['-\/\s\\\]/","_",$post['tax_name']);
        	preg_match_all("/[^a-zA-Z_]/",$name,$m);

        	if (@$m[0]){
        		$this->msg = JText::_( 'MYMUSE ERROR SAVING TAX RATE' ).$m[0][0];
        		$this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate&task=edit&cid[]=', $this->msg );
        		return false;
        	}else{
        		$db = JFactory::getDBO();
        		$query = "ALTER TABLE `#__mymuse_order` DROP `".$post["old_tax_name"]."` ";
        		$db->setQuery($query);
        		$db->query();
        		$query = "ALTER TABLE `#__mymuse_order` ADD `$name` DECIMAL( 10, 2 ) NOT NULL DEFAULT '0.00'";
        		$db->setQuery($query);
        		$db->query();
        	}
        	
        }
        

        if ($model->store($post)) {

        	switch ( JRequest::getVar('task', null, 'default', 'cmd'))
			{
				case 'apply':
					$this->msg = JText::_( 'MYMUSE CHANGES TO TAX RATE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate&task=edit&cid[]='. $post['id'], $this->msg );
					
					break;

				case 'save':
				default:
					$this->msg = JText::_( 'MYMUSE TAX RATE SAVED' );
					$this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate', $this->msg );
					break;
				}

        } else {
        	$this->msg = JText::_( 'MYMUSE ERROR SAVING TAX' ).$model->getError();
        	$this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate&task=edit&cid[]=', $this->msg );
        }
        $model->checkin();

    }
    
    function apply()
    {
        $this->save() ;
    }

    function remove()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        if (count( $cid ) < 1) {
            JError::raiseError(500, JText::_( 'MYMUSE SELECT A TAX RATE TO DELETE' ) );
        }
        $db = JFactory::getDBO();
        foreach($cid as $id){
        	$query = "SELECT tax_name FROM #__mymuse_tax_rate WHERE id='$id'";
        	$db->setQuery($query);
        	$name = $db->loadResult();
        	$query = "ALTER TABLE `#__mymuse_order` DROP `".$name."` ";
        	$db->setQuery($query);
        	$db->query();
        }
        $model = $this->getModel('taxrate');
        if(!$model->delete($cid)) {
            echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>
            ";
        }
        
        $query = "ALTER TABLE `#__mymuse_order` DROP `$name`";
        $this->msg = JText::_( 'MYMUSE TAX RATE WAS DELETED' ) ;
        
        $this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate', $THIS->MSG );
    }


    function cancel()
    {
        // Checkin the item
        $model = $this->getModel('taxrate');
        $model->checkin();
        $this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate' );
    }

    function orderup()
    {
        $model = $this->getModel('taxrate');
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate');
    }
    
    function orderdown()
    {
        $model = $this->getModel('taxrate');
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate');
    }
    
    function saveorder()
    {
        $cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
        $order = JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($cid);
        JArrayHelper::toInteger($order);
        $model = $this->getModel('taxrate');
        $model->saveorder($cid, $order);
        $msg = 'New ordering saved';
        $this->setRedirect( 'index.php?option=com_mymuse&controller=taxrate', $msg );
    }
	
	
	
    /**
     * Method to display the view
     *
     * @access    public
     */
    function display()
    {
        parent::display();
    }

	



}
?>