<?php
/**
 * @version		$Id: helper.php 169 2010-10-13 02:19:13Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');


/**
 * For debugging
 * 
 * @param $var
 * @return boolean
 */
function print_pre($var){
	echo "<pre>";
	print_r($var);
	echo "</pre>";
	return true;
}
define('TAX_REGEX',"[\'-\/\s\\\]");

class MyMuseHelper
{

	/**
	 * Log a message. Should only be done when SHOP_TEST is on
	 * 
	 * @param $message
	 * @return boolean
	 */
	function logMessage($message){
		$fh = fopen(JPATH_BASE.DS.'components'.DS.'com_mymuse'.DS.'log.php', "a");
		fwrite($fh,$message."\n");
		fclose($fh);
		return true;
	}

	
 	/**
 	 * Get Currency
 	 * 
 	 * @param string code
 	 * @return array
 	 */
	function getCurrency($code=0)
	{

		if(!$code){
			$MyMuseStore	=& MyMuse::getObject('store','models');
			$code 			= $MyMuseStore->_store->currency;
		}
		$db =& JFactory::getDBO();
		$query = "SELECT * from #__mymuse_currency WHERE currency_code = '".$code."'";
		$db->setQuery($query);
		$curr = $db->loadObject();

		$currency = array(
			'id'			=> $curr->id,
			'currency_name'	=> $curr->currency_name,
			'currency_code' => $curr->currency_code,
			'symbol'		=> $curr->symbol
		);
		return $currency;
	}
	
	/**
	 * getArtistAlias. alias from artist record
	 * 
	 * @param $id int
	 * @return string
	 */
	
	function getArtistAlias($id,$parent=0){
		global $params;
		
		$db	= & JFactory::getDBO();
		if($parent){
			$query = "SELECT artistid from #__mymuse_product
			WHERE id ='$id'";
			$db->setQuery($query);
   			$id = $db->loadResult();
		}
		$query = "SELECT alias FROM #__mymuse_categories 
   		WHERE id='".$id."'";
   		$db->setQuery($query);
   		$alias = $db->loadResult();

		return $alias;
		
	}
	
	/**
	 * getAlbumAlias get alias from parent
	 * 
	 * @param $id int
	 * @return string
	 */
	
	function getAlbumAlias($id){
		
		$db	= & JFactory::getDBO();
		$query = "SELECT alias FROM #__mymuse_product 
   			WHERE id='".$id."'";

   		$db->setQuery($query);
   		$alias = $db->loadResult();
		return $alias;
		
	}
	
	/**
	 * findExt get file extension
	 * 
	 * @param $string filename
	 * @return string
	 */
	function getExt ($filename) { 

		$filename = strtolower($filename); 
		$exts = preg_split("/\./", $filename); 
		$n = count($exts)-1; 
		$exts = $exts[$n]; 
		
		return $exts; 
	} 
	
	/**
	 * Get status name from one letter code
	 * 
	 * @param string $code
	 */
	function getStatusName($code){
		
		$db	= & JFactory::getDBO();
		$q = "SELECT name FROM #__mymuse_order_status WHERE ";
		$q .= "code = '".$code."' ";
		$db->setQuery($q);
		$status = $db->loadResult();	
		return $status;
		
	}

	/**
	 * @param	string	The link title
	 * @param	string	The order field for the column
	 * @param	string	The current direction
	 * @param	string	The selected ordering
	 * @param	string	An optional task override
	 */
	function sort2( $title, $order, $direction = 'asc', $selected = 0, $task=NULL )
	{
		$direction	= strtolower( $direction );
		$images		= array( 'sort_asc.png', 'sort_desc.png' );
		$index		= intval( $direction == 'desc' );
		$direction	= ($direction == 'desc') ? 'asc' : 'desc';

		$html = '<a href="javascript:tableOrdering2(\''.$order.'\',\''.$direction.'\',\''.$task.'\');" title="'.JText::_( 'Click to sort this column' ).'">';
		$html .= JText::_( $title );
		if ($order == $selected ) {
			$html .= JHTML::_('image.administrator',  $images[$index], '/images/', NULL, NULL);
		}
		$html .= '</a>';
		return $html;
	}
	
	
	function order2( $rows, $image='filesave.png', $task="saveorder" )
	{
		$image = JHTML::_('image.administrator',  $image, '/images/', NULL, NULL, JText::_( 'Save Order' ) );
		$href = '<a href="javascript:saveorder2('.(count( $rows )-1).', \''.$task.'\')" title="'.JText::_( 'Save Order' ).'">'.$image.'</a>';
		return $href;
	}
	
	/**
	 * Return the icon to move an item UP
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item up or a space
	 * @since	1.0
	 */
	function orderUpIcon2($i, $condition = true, $task = 'orderup', $alt = 'Move Up', $enabled = true, $limitstart = 0)
	{
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i > 0 || ($i + $limitstart > 0)) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask2(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '   <img src="images/uparrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="images/uparrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}

	/**
	 * Return the icon to move an item DOWN
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	int		$n The number of items in the list
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item down or a space
	 * @since	1.0
	 */
	function orderDownIcon2($i, $n, $condition = true, $task = 'orderdown', $alt = 'Move Down', $enabled = true, $limitstart=0, $total=0)
	{
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i < $n -1 || $i + $limitstart < $total - 1) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask2(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '  <img src="images/downarrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="images/downarrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}
	
	
	/**
	 * @param	string	The link title
	 * @param	string	The order field for the column
	 * @param	string	The current direction
	 * @param	string	The selected ordering
	 * @param	string	An optional task override
	 */
	function sort3( $title, $order, $direction = 'asc', $selected = 0, $task=NULL )
	{
		$direction	= strtolower( $direction );
		$images		= array( 'sort_asc.png', 'sort_desc.png' );
		$index		= intval( $direction == 'desc' );
		$direction	= ($direction == 'desc') ? 'asc' : 'desc';

		$html = '<a href="javascript:tableOrdering3(\''.$order.'\',\''.$direction.'\',\''.$task.'\');" title="'.JText::_( 'Click to sort this column' ).'">';
		$html .= JText::_( $title );
		if ($order == $selected ) {
			$html .= JHTML::_('image.administrator',  $images[$index], '/images/', NULL, NULL);
		}
		$html .= '</a>';
		return $html;
	}
	
	
	function order3( $rows, $image='filesave.png', $task="saveorder" )
	{
		$image = JHTML::_('image.administrator',  $image, '/images/', NULL, NULL, JText::_( 'Save Order' ) );
		$href = '<a href="javascript:saveorder3('.(count( $rows )-1).', \''.$task.'\')" title="'.JText::_( 'Save Order' ).'">'.$image.'</a>';
		return $href;
	}
	
	/**
	 * Return the icon to move an item UP
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item up or a space
	 * @since	1.0
	 */
	function orderUpIcon3($i, $condition = true, $task = 'orderup', $alt = 'Move Up', $enabled = true, $limitstart=0)
	{
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i > 0 || ($i + $limitstart > 0)) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask3(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '   <img src="images/uparrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="images/uparrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}

	/**
	 * Return the icon to move an item DOWN
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	int		$n The number of items in the list
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item down or a space
	 * @since	1.0
	 */
	function orderDownIcon3($i, $n, $condition = true, $task = 'orderdown', $alt = 'Move Down', $enabled = true, $limitstart=0, $total=0)
	{
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i < $n -1 || $i + $limitstart < $total - 1) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask3(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '  <img src="images/downarrow.png" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="images/downarrow0.png" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}
	
	
	/**
	 * 
	 * @param integer $id order id
	 * @param string $status the new status
	 * @return boolean
	 */
	function orderStatusUpdate($id, $status="P")
	{
		global $mainframe;
		
		require_once( MYMUSE_ADMIN_PATH.DS.'tables'.DS.'order.php' );
		$datenow 	=& JFactory::getDate();
		$params		=& $mainframe->getParams('com_mymuse');
		$db			= & JFactory::getDBO();
		$order 		= new TableOrder($db);
		$order->load( $id );
		$order->order_status = $status;
		$order->modified = $datenow->toMySQL();
		if (!$order->store()) {
			if($params->get('my_debug')){
        			MyMuseHelper::logMessage( "!!ERROR Order Status Update Failed!! id = $id status = $status");
        	}
			JError::raiseError( 500, $db->stderr() );
			return false;
		}
		
		return true;
	}
	 /**
     * ByteSize
     * 
     * @param int $bytes
     * @return string
     */
	function ByteSize($bytes) 
    {
    	$size = $bytes / 1024;
    	if($size < 1024)
    	{
    		$size = number_format($size, 2);
    		$size .= ' KB';
    	}
    	else
    	{
    		if($size / 1024 < 1024)
    		{
    			$size = number_format($size / 1024, 2);
    			$size .= ' MB';
    		}
    		else if ($size / 1024 / 1024 < 1024)
    		{
    			$size = number_format($size / 1024 / 1024, 2);
    			$size .= ' GB';
    		}
    	}
    	return $size;
    } 
    
	function fix_bite_size(){   
		require_once( JPATH_COMPONENT.DS.'tables'.DS.'product.table.php' );
		$db	= & JFactory::getDBO();
		
		$query = "SELECT * from #__mymuse_product WHERE product_downloadable=1";
		$db->setQuery($query);
		$prods = $db->loadObjectList();
		foreach($prods as $prod){
			if($prod->file_name != ''){
				$row = new JtableMyMuseProduct($db);
				$row->load($prod->id);
				$row->file_length = filesize(DOWNLOAD_DIR . DS . $prod->file_name);
				echo $row->file_name." : ".$row->file_length."<br />";
				if(!$row->store()){
					JError::raiseError( 500, $db->stderr() );
				}
			}
		}
		exit;
	}
	/**
	 * Check if email is valid
	 * 
	 * @param string $email
	 * @return unknown_type
	 */
	function is_email_valid($email) {
		if (!eregi("^([a-z]|[0-9]|\.|-|_)+@([a-z]|[0-9]|\.|-|_)+\.([a-z]|[0-9]){2,4}$", $email)) {
			return true;
		} else {
			return false;
		}
	}


	// Prevents SQL injection..
	function add_slashes($data) {
		if (get_magic_quotes_gpc()) {
			$data = stripslashes($data);
		}
		return mysql_real_escape_string($data);
	}


	// Define the client's browser type..
	function get_browser_type() {
		$USER_BROWSER_AGENT = "";

		if (ereg('OPERA(/| )([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
			$USER_BROWSER_AGENT = 'OPERA';
		} else if (ereg('MSIE ([0-9].[0-9]{1,2})',strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
			$USER_BROWSER_AGENT = 'IE';
		} else if (ereg('OMNIWEB/([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
			$USER_BROWSER_AGENT = 'OMNIWEB';
		} else if (ereg('MOZILLA/([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
			$USER_BROWSER_AGENT = 'MOZILLA';
		} else if (ereg('KONQUEROR/([0-9].[0-9]{1,2})', strtoupper($_SERVER["HTTP_USER_AGENT"]), $log_version)) {
			$USER_BROWSER_AGENT = 'KONQUEROR';
		} else {
			$USER_BROWSER_AGENT = 'OTHER';
		}

		return $USER_BROWSER_AGENT;
	}

	// Define MIME-TYPE according to target Browser..
	function get_mime_type() {
		$USER_BROWSER_AGENT = $this->get_browser_type();

		$mime_type = ($USER_BROWSER_AGENT == 'IE' || $USER_BROWSER_AGENT == 'OPERA')
		? 'application/octetstream'
		: 'application/octet-stream';

		return $mime_type;
	}
	
	
	
	
	
	/**
	 * treerecurse2 
	 * 
	 * @param $id
	 * @param $indent
	 * @param $list
	 * @param $children
	 * @param $maxlevel
	 * @param $level
	 * @param $type
	 * @return array
	 */
	function treerecurse2( $id, $indent, $list, &$children, $maxlevel=999, $level=0, $type=1 )
	{
		if (@$children[$id] && $level <= $maxlevel)
		{
			foreach ($children[$id] as $v)
			{
				$id = $v->id;

				if ( $type ) {
					$pre 	= '<sup>|_</sup>&nbsp;';
					$spacer = '.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
				} else {
					$pre 	= '- ';
					$spacer = '&nbsp;&nbsp;';
				}

				if ( $v->parent == 0 ) {
					$txt 	= $v->title;
				} else {
					$txt 	= $pre . $v->title;
				}
				$pt = $v->parent_id;
				$list[$id] = $v;
				$list[$id]->treename = "$indent$txt";
				$list[$id]->children = count( @$children[$id] );
				$list = MyMuseHelper::treerecurse2( $id, $indent . $spacer, $list, $children, $maxlevel, $level+1, $type );
			}
		}
		return $list;
	}
	
	function saveProductPrep( &$row )
	{
		// Get submitted text from the request variables
		$text = JRequest::getVar( 'text', '', 'post', 'string', JREQUEST_ALLOWRAW );

		// Clean text for xhtml transitional compliance
		$text		= str_replace( '<br>', '<br />', $text );

		// Search for the {readmore} tag and split the text up accordingly.
		$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
		$tagPos	= preg_match($pattern, $text);

		if ( $tagPos == 0 )
		{
			$row->introtext	= $text;
		} else
		{
			list($row->introtext, $row->fulltext) = preg_split($pattern, $text, 2);
		}

		// Filter settings
		jimport( 'joomla.application.component.helper' );
		$config	= JComponentHelper::getParams( 'com_mymuse' );
		$user	= &JFactory::getUser();
		$gid	= $user->get( 'gid' );

		$filterGroups	=  $config->get( 'filter_groups' );

		if (is_array($filterGroups) && in_array( $gid, $filterGroups ))
		{
			$filterType		= $config->get( 'filter_type' );
			$filterTags		= preg_split( '#[,\s]+#', trim( $config->get( 'filter_tags' ) ) );
			$filterAttrs	= preg_split( '#[,\s]+#', trim( $config->get( 'filter_attritbutes' ) ) );
			switch ($filterType)
			{
				case 'NH':
					$filter	= new JFilterInput();
					break;
				case 'WL':
					$filter	= new JFilterInput( $filterTags, $filterAttrs, 0, 0, 0);  // turn off xss auto clean
					break;
				case 'BL':
				default:
					$filter	= new JFilterInput( $filterTags, $filterAttrs, 1, 1 );
					break;
			}
			$row->introtext	= $filter->clean( $row->introtext );
			$row->fulltext	= $filter->clean( $row->fulltext );
		} elseif(empty($filterGroups) && $gid != '25') { // no default filtering for super admin (gid=25)
			$filter = new JFilterInput( array(), array(), 1, 1 );
			$row->introtext	= $filter->clean( $row->introtext );
			$row->fulltext	= $filter->clean( $row->fulltext );
		}
		return true;
	}

	
	function filterCategory($query, $active = NULL)
	{
		// Initialize variables
		$db	= & JFactory::getDBO();

		$categories[] = JHTML::_('select.option', '0', '- '.JText::_('Select Category').' -');
		$db->setQuery($query);
		$categories = array_merge($categories, $db->loadObjectList());

		$category = JHTML::_('select.genericlist',  $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $active);

		return $category;
	}

	function filterContent($query, $active = NULL)
	{
		// Initialize variables
		$db	= & JFactory::getDBO();

		$contents[] = JHTML::_('select.option', '0', '- '.JText::_('Select Review').' -');
		$db->setQuery($query);
		$contents = array_merge($contents, $db->loadObjectList());

		$content = JHTML::_('select.genericlist',  $contents, 'contentid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $active);

		return $content;
	}
	
    /**
     * dropdownDisplay()
     *
     * Print an HTML dropdown box named $name using $arr to
     * load the drop down.  If $value is in $arr, then $value
     * will be the selected option in the dropdown.
     *
     * @param string $name
     * @param string $value
     * @param array $arr
     * @return string
     */
     
   function dropdownDisplay($name, $value, $arr, $opt="") {

      
      $string =  "<select class=\"inputbox\" name=\"$name\"  id=\"$name\" $opt>\n";

      while (list($key, $val) = each($arr)) {
         if(strcmp($value, $key) == 0) {
            $string .= "<option value=\"$key\" SELECTED>$val\n";
         }
         else {
            $string .= "<option value=\"$key\">$val</option>\n";
         }
      }

      $string .= "</SELECT>\n";

      return $string;
   }


    /**
     * list_day
     * Print a select box
     *
     * @param string $list_name
     * @param string $val
     * @return bool
     */
   function list_day($list_name,$val="") {

       $list = array(JText::_("SElect day"),
                    "01" => "1",
                    "02" => "2",
                    "03" => "3",
                    "04" => "4",
                    "05" => "5",
                    "06" => "6",
                    "07" => "7",
                    "08" => "8",
                    "09" => "9",
                    "10" => "10",
                    "11" => "11",
                    "12" => "12",
                    "13" => "13",
                    "14" => "14",
                    "15" => "15",
                    "16" => "16",
                    "17" => "17",
                    "18" => "18",
                    "19" => "19",
                    "20" => "20",
                    "21" => "21",
                    "22" => "22",
                    "23" => "23",
                    "24" => "24",
                    "25" => "25",
                    "26" => "26",
                    "27" => "27",
                    "28" => "28",
                    "29" => "29",
                    "30" => "30",
                    "31" => "31");
       $res = MyMuseHelper::dropdownDisplay($list_name, $val, $list);
       return $res;
   }

    /**
     * list_month
     * Print a select box
     *
     * @param string $list_name
     * @param string $val
     * @return bool
     */
   function list_month($list_name,$val="") {
    global $language,$form_month;

    $list = array("$form_month",
                    "01" => JAN,
                    "02" => FEB,
                    "03" => MAR,
                    "04" => APR,
                    "05" => MAY,
                    "06" => JUN,
                    "07" => JUL,
                    "08" => AUG,
                    "09" => SEP,
                    "10" => OCT,
                    "11" => NOV,
                    "12" => JAN
    );
    $res = MyMuseHelper::dropdownDisplay($list_name, $val, $list);
    return $res;
   }


    /**
     * list_yes_no
     * Print a select box
     *
     * @param string $list_name
     * @param string $val
     * @return bool
     */
   function list_yes_no($list_name,$val="") {

    $list = array("",
          "0"    => JText::_( 'No' ),
          "1"    => JText::_( 'Yes' )
          );
    $res = MyMuseHelper::dropdownDisplay($list_name, $val, $list);
    return $res;
   }

   
    /**
     * list_year
     * Print a select box of this year plus 5
     *
     * @param string $list_name
     * @param string $val
     * @return bool
     */
   function list_year($list_name,$val="") {
    global $form_year;
        $this_year = date("Y");
        $this_plus_1 = $this_year + 1;
        $this_plus_2 = $this_year + 2;
        $this_plus_3 = $this_year + 3;
        $this_plus_4 = $this_year + 4;
        $this_plus_5 = $this_year + 5;

       $list = array("$form_year",

                    "$this_year" => "$this_year",
                    "$this_plus_1" => "$this_plus_1",
                    "$this_plus_2" => "$this_plus_2",
            "$this_plus_3" => "$this_plus_3",
            "$this_plus_4" => "$this_plus_4",
            "$this_plus_5" => "$this_plus_5");
       $res = MyMuseHelper::dropdownDisplay($list_name, $val, $list);
       return $res;
   }


    /**
     * list_weight_uom
     * Print a select box of weight types
     *
     * @param string $list_name
     * @param string $val
     * @return bool
     */
   function list_weight_uom($list_name,$val="") {
       $list = array("-",
                    "LBS" => "Pounds",
                    "KGS" => "Kilograms",
                    "G" => "Grams");
       $res = MyMuseHelper::dropdownDisplay($list_name, $val, $list);
       return $res;
   }



    /**
     * listCountryState
     * Print a select box
     *
     * @param string $list_name
     * @param string $value
     * @return bool
     */
   function listCountryState(&$lists, $country_select='', $state_select='', $store_country='') {

		$db	= & JFactory::getDBO();
		//echo "country = $country_select state = $state_select"; exit;
		$javascript = "onchange=\"changeDynaList( 'state', countrystates, document.adminForm.country.options[document.adminForm.country.selectedIndex].value, 0, 0);\"";
		
		$countries[] = JHTML::_('select.option', '0', '- '.JText::_('Select Country').' -');
		if($store_country != ''){
			$query = "SELECT country_name from #__mymuse_country WHERE country_3_code='$store_country'";
			$db->setQuery($query);
			$country_name = $db->loadResult();
			$countries[] = JHTML::_('select.option', $store_country, $country_name);
		}
		$query = "SELECT id, country_3_code as value, country_name as text from #__mymuse_country ORDER BY country_name ASC";
		$db->setQuery($query);
		$dbcountries = $db->loadObjectList();
		$countries = array_merge($countries, $dbcountries);
		$lists['country'] = JHTML::_('select.genericlist',  $countries, 'country', 'class="inputbox" size="1" '.$javascript, 'value', 'text', $country_select);

	
		foreach ($dbcountries as $country)
		{
			$country_list[] = (int) $country->id;

			if ($country_select != '') {
				if ($country->value == $country_select) {
					$contentCountry = $country->text;
				}
			} 
		}

		$countrystates = array ();
		$countrystates[-1] = array ();
		$countrystates[-1][] = JHTML::_('select.option', '-1', JText::_( 'Select Country' ), 'id', 'title');
		$country_list = implode('\', \'', $country_list);

		$query = 'SELECT #__mymuse_state.id as code, state_name as title, state_2_code as id, country_3_code, country_id' .
				' FROM #__mymuse_state,#__mymuse_country' .
				' WHERE country_id IN ( \''.$country_list.'\' )' .
				' AND #__mymuse_state.country_id=#__mymuse_country.id' .
				' ORDER BY country_id,state_name';

		$db->setQuery($query);
		$state_list = $db->loadObjectList();
		
		foreach ($dbcountries as $country)
		{

			$countrystates[$country->value] = array ();
			$rows2 = array ();
			foreach ($state_list as $state)
			{
				if ($state->country_3_code == $country->value) {
					$rows2[] = $state;
				}
			}
			foreach ($rows2 as $row2) {
				$countrystates[$country->value][] = JHTML::_('select.option', $row2->id, $row2->title, 'id', 'title');
			}
		}

		$countrystates['-1'][] = JHTML::_('select.option', '-1', JText::_( 'Select State' ), 'id', 'title');
		$states = array();
		$country_id = 0;
		if($country_select != ''){
			$query = "SELECT id from #__mymuse_country WHERE country_3_code='".$country_select."' ";
			$db->setQuery($query);
			$country_id = $db->loadResult();
			
		}
		$states[] = JHTML::_('select.option', '-1', JText::_( 'Select State' ), 'id', 'title');
		foreach ($state_list as $state) {
			if($state->country_3_code == $country_select)
				$states[] = $state;
		}

		
		$lists['state'] = JHTML::_('select.genericlist',  $states, 'state', 'class="inputbox" size="1"', 'id', 'title', $state_select);
		
		return $countrystates;
		
   }
   
    /**
     * list_currency
     * Print a select box
     *
     * @param string $list_name
     * @param string $value
     * @return bool
     */
   function list_currency($list_name, $value="") {
     $db	= & JFactory::getDBO();
     $str = '';
     $q = "SELECT * from currency ORDER BY currency_name ASC";
     $db->query($q);
     $str .= "<SELECT class='input' name=$list_name>\n";
     $str .= "<option value=\"\"> - </option>\n";
     while ($db->next_record()) {
       $str .= "<option value=" . $db->f("currency_code");
       if ($value == $db->f("currency_code")) {
     	$str .= " SELECTED";
       }
       $str .= ">" . $db->f("currency_name") . " ".$db->f("currency_symbol") . "</option>\n";
     }
     $str .= "</SELECT>\n";
     return $str;
   }

   
     /**
     * printOrderStatus
     * Print the string for a status letter
     *
     * @param string $status
     * @return string
     */
    function printOrderStatus($status) {
        $db	= & JFactory::getDBO();

        $q = "SELECT name from #__mymuse_order_status WHERE code='$status'";
        
        $db->setQuery($q);
        $res = $db->loadResult();
        return $res;
   }
   
   /**
    * 
    */

    function getLimitBox($selected=5){
   		// Initialize variables
		$limits = array ();
		$limits[] = JHTML::_('select.option', '5');
		$limits[] = JHTML::_('select.option', '10');
		$limits[] = JHTML::_('select.option', '12');
		$limits[] = JHTML::_('select.option', '15');
		$limits[] = JHTML::_('select.option', '20');
		$limits[] = JHTML::_('select.option', '25');
		$limits[] = JHTML::_('select.option', '30');
		$limits[] = JHTML::_('select.option', '50');
		$limits[] = JHTML::_('select.option', '100');
		$limits[] = JHTML::_('select.option', '0', JText::_('all'));
		
		$html = JHTML::_('select.genericlist',  $limits, 'limit', 'class="inputbox" size="1" onchange="this.form.submit()"', 'value', 'text', $selected);
		return $html;
    
    }
}
