<?php
/**
 * @version		$Id: attributesku.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class myMuseModelAttributesku extends Jmodel
{
	function __construct()
	{
		parent::__construct();
		
		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		$this->_product_parent_id = JRequest::getVar('parentid', null, '', 'int');
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}
		
		global $mainframe, $option;
 		// Get the pagination request variables
  		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
  		
 		$this->setState('limit', $limit);
  		$this->setState('limitstart', $limitstart);
  		
	}
	
	/**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
     
	/**
  	 * Pagination object
	 *
	 * @var object
	 */
     var $_pagination = null;
  
     /**
  	 * product_parent_id
	 *
	 * @var integer
	 */
     var $_product_parent_id = null;
     
 	/**
  	* stores total
  	*
  	* @var integer
  	*/
  	var $_total = null;
  	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if (isset($this->_id))
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}
	
   /**
     * Retrieves the store data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {

        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {

        	$parentid = JRequest::getVar( 'parentid', 0, 'post', 'int' );
        	if($this->_task == "" || $this->_task == "listattribute")
        	{	
        		
        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query );
        	}
        	else
        	{
        		if (isset($this->_id))
        		{
        			$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObject();

        		}else{
        			$this->_data  =& $this->getTable('attributesku');
        			
        		}
        		
        		if(isset($this->_data) && !isset($this->_data->product_parent_id)){
        			$this->_data->product_parent_id =& $this->_product_parent_id;
        		}
        		
        	}
        }
 
        return $this->_data;
    }
    /**
  	* Method to get the total number of mymuse_product items
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the total number of products if it doesn't already exist
  		if (empty($this->_total))
  		{
  			if(!$query = $this->_buildQueryAll()){
  				return false;
  			}
  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  
    /**
     * Method to set the product identifier
     *
     * @access    public
     * @param    int Product identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data    = null;
    }

    
    /**
     * Method to get a pagination object for categories
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
    
    /**
     * Returns the query
     * @return string The query to be used to retrieve a row from the database
     */
    function _buildQueryOne()
    {
        $query = ' SELECT * '
            . ' FROM #__mymuse_product_attribute_sku WHERE id ='
            .$this->_id;
        return $query;
    }
    
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {

		// Get the attributes
		
		$pid	= JRequest::getVar( 'parentid', null, '', 'int' );
		if(!$pid){
			$this->setError(JText::_("MYMUSE NO PARENT ID"));
            return false;
		}

		$query = "SELECT pa.*,  p.title
		from #__mymuse_product_attribute_sku as pa,
		#__mymuse_product as p
		WHERE pa.product_parent_id=p.id
		AND product_parent_id=$pid";

        return $query;
    }
    
    	/**
	* Method to store the attribute
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store(&$data)
	{
        $row =& $this->getTable();
        $user=& JFactory::getUser();

		$name				= JRequest::getVar( 'name', null, 'post', 'string' );
		$product_parent_id	= JRequest::getVar( 'product_parent_id', null, 'post', 'int' );
		$ordering			= JRequest::getVar( 'ordering', null, 'post', 'int' );
		
	    // Bind the form fields to the item table
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        
	    // Store the item table to the database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        $data['id'] = $row->id;
        
        return true;
		
	}
	
	/**
	* Method to remove a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );

            $query = 'DELETE FROM #__mymuse_product_attribute_sku'
            . ' WHERE id IN ( '.$cids.' )';
            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
}