<?php
/**
 * @version		$Id: category.php 153 2010-10-10 23:58:05Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class MyMuseModelCategory extends Jmodel
{
	function __construct()
	{
		parent::__construct();

		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}

	}

	/**
     * Store task
     *
     * string
     */
     var $_task = null;
     
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
  
 	/**
  	* stores total
  	*
  	* @var integer
  	*/
  	var $_total = null;
     
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	// Get the WHERE and ORDER BY clauses for the query
  		$where = $this->_buildContentWhere();
  		$orderby = $this->_buildContentOrderBy();
        $query = ' SELECT c.*, g.name AS groupname, s.title as section_name '
            . ' FROM #__mymuse_categories as c'
            . ' LEFT JOIN #__groups AS g ON g.id = c.access'
            . ' LEFT JOIN #__sections AS s ON s.id = c.section '
            . $where
            . $orderby;
        return $query;
    }
 
    function _buildContentOrderBy()
    {
    	global $mainframe, $option;
    	
    	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
    	$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word' );

    	$good_sort = array('c.title','c.published','c.ordering','groupname','section_name','c.id');
		if(!in_array($filter_order,$good_sort)){
			$filter_order = 'c.ordering';
		}
    	if($filter_order != '' )
    	{
    		$orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'  ';
    	}
    	return $orderby;
    }

    function _buildContentWhere()
    {
    	global $mainframe, $option;
    	
    	$filter_state = $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
    	$filter_section	  = $mainframe->getUserStateFromRequest( $option.'filter_section',	'filter_section', 0, 'int' );
    	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
    	$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

    	$search = $mainframe->getUserStateFromRequest( $option.'search', 'search', '', 'string' );
    	$search = JString::strtolower( $search );
    	$where = array();

    	if ($filter_section) {
    		$where[] = "s.id = '$filter_section'";
    	}
    	if ($search) {
    		$where[] = 'LOWER(c.title) LIKE '.$this->_db->Quote('%'.$search.'%');
    	}
    	if ( $filter_state ) {
    		if ( $filter_state == 'P' ) {
    			$where[] = 'c.published = 1';
    		} else if ($filter_state == 'U' ) {
    			$where[] = 'c.published = 0';
    		}
    	}
    	$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
    	return $where;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryOne()
    {
        $query = ' SELECT * '
            . ' FROM #__mymuse_categories WHERE id ='
            .$this->_id;
        return $query;
    }
     
    
    /**
     * Add product number to data row
     * @return true
     */
    function _addProduct()
    {
        if($this->_data){
    	   foreach($this->_data as $row)
    	   {
                $query = ' SELECT count(*) as num_prod FROM #__mymuse_product_category_xref WHERE catid='.$row->id;
		  	    $this->_db->setQuery($query);
		  	    $row->num_prod = $this->_db->loadResult();
    	   }
     }   
        return true;
    }
    
    /**
     * Retrieves the store data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {

        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	if($this->_task == "")
        	{	

        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query );
            	$this->_addProduct();
        	}
        	else
        	{
        		if (isset($this->_id) && $this->_id > 0)
        		{
        			$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObject();
        		}
        		else
        		{
        			$this->_initData();
        		}
        	}
        }
 
        return $this->_data;
    }
    /**
  	* Method to get the total number of mymuse_category items
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the content if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();

  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  
    /**
     * Method to set the store identifier
     *
     * @access    public
     * @param    int Store identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data    = null;
    }

    /**
     * Method to get a pagination object for categories
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
  
    /**
     * Method to set the category lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $mainframe, $option;
    	$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		if (isset($this->_data) && JRequest::getInt('sectionid')) {
			$this->_data->section = JRequest::getInt('sectionid');
		}

		$filter_section	  = $mainframe->getUserStateFromRequest( $option.'filter_section',	'filter_section', 0, 'int' );
		
		// list of sections
		$query = 'SELECT s.id AS value, s.title AS text'
		. ' FROM #__sections AS s'
		. ' WHERE scope="com_mymuse" '
		. ' ORDER BY s.ordering'
		;
		$this->_db->setQuery( $query );

		$sec[] = JHTML::_('select.option', '0', '- '.JText::_('MYMUSE SELECT SECTION').' -');
		$sec = array_merge($sec, $this->_db->loadObjectList());

		if(isset($this->_id) || $this->_task == "add"){
			
			$lists['section'] = JHTML::_('select.genericlist',   $sec, 'section', 'class="inputbox" size="1"', 'value', 'text', $this->_data->section );
			
					
			// build the html select list for ordering
			$query = 'SELECT ordering AS value, title AS text'
			. ' FROM #__mymuse_categories'
			. ' ORDER BY ordering'
			;
			if (isset($cid[0]) ) {
				$lists['ordering'] 			= JHTML::_('list.specificordering',  $this->_data, $cid[0], $query );
			}
			else {
				$lists['ordering'] 			= JHTML::_('list.specificordering',  $this->_data, '', $query );
			}

			// build the select list for the image positions
			$active =  ( isset($this->_data->image_position) ? $this->_data->image_position : 'left' );
			$lists['image_position'] 	= JHTML::_('list.positions',  'image_position', $active, NULL, 0, 0 );

			// Imagelist
			$image = ( isset($this->_data->image)? $this->_data->image : '' );
			$root_image = preg_replace("#artists/#",'',$image);
			$lists['image'] = JHTML::_('list.images', 'image', $root_image, NULL, "/images/stories/artists" );

			// build the html select list for the group access
			$lists['access'] = JHTML::_('list.accesslevel',  $this->_data );

			// build the html radio buttons for published
			$published = (isset($this->_data->published)) ? $this->_data->published : 1;
			$lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $published );
		}else{
			$lists['filter_section'] = JHTML::_('select.genericlist',   $sec, 'filter_section', 'onchange="document.adminForm.submit();"', 'value', 'text', $filter_section );
			
		}
		
		
		return $lists;
    }
    
	/**
	* Tests if item is checked out
	*
	* @access public
	* @param int A user id
	* @return boolean True if checked out
	
	*/
	function isCheckedOut( $uid=0 )
	{
        if ($this->_loadData())
        {
            if ($uid) {
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            } else {
                return $this->_data->checked_out;
            }
        }
	}
	/**
	* Method to checkin/unlock the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function checkin()
	{
	   if ($this->_id)
	   {
	       $item = & $this->getTable();
	       if(! $item->checkin($this->_id)) {
	           $this->setError($this->_db->getErrorMsg());
	           return false;
	       }
	   }
	   return false;
	}
	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if (isset($this->_id) && $this->_id > 0)
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}
	
	/**
	* Method to store the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store(&$data)
	{
		global $params;
        $row 		=& $this->getTable();
        $user		=& JFactory::getUser();
        $old_alias	= JRequest::getVar('old_alias', null);
        
        // Bind the form fields to the item table
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }


        // if new item, order last in appropriate group
        if (!$row->id) {
            $row->ordering = $row->getNextOrder( 'id' );
        }
        $isNew = true;
        // Are we saving from an item edit?
        if ($row->id) {
            $isNew = false;

        }
   
        // Make sure the item table is valid
        if (!$row->check()) {
            $this->setError($row->getError());
            return false;
        }
	 
  
        // make a download dir for this artist
        if($row->section == $params->get('my_section_artists')){
        	jimport('joomla.filesystem.file');
        	jimport('joomla.filesystem.folder');
			if($old_alias && $old_alias != $row->alias){
				// move the old dir to the new name
				$src = $params->get('my_download_dir').DS.$old_alias;
				$dest = $params->get('my_download_dir').DS.$row->alias;
				$ret = JFolder::move($src, $dest);
				if(!$ret){
					$this->setError($ret." ".$src." ".$dest);
            		return false;
				}
			}
			$dir = $params->get('my_download_dir').DS.$row->alias;

			if(!file_exists($dir)){
				if(!JFolder::create($dir)){
					$this->setError(JText::_("MYMUSE COULD NOT MAKE DIR").$dir);
					return false;
				}
				if(!JFile::copy(JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."index.html",
					$dir.DS."index.html")){
					$this->setError(JText::_("MYMUSE COULD NOT COPY INDEX").$dir);
				}
			}
        }
        

        // Store the item table to the database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        $data['id'] = $row->id;
        return true;
	}
	
	/**
	* Method to remove a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            $query = 'DELETE FROM #__mymuse_categories'
            . ' WHERE id IN ( '.$cids.' )';

            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
	
	/**
	* Method to (un)publish a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function publish($cid = array(), $publish = 1)
	{
        $user =& JFactory::getUser();
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            $query = 'UPDATE #__mymuse_categories'
            . ' SET published = '.(int) $publish
            . ' WHERE id IN ( '.$cids.' )'
            . ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
            ;
            $this->_db->setQuery( $query );
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }
        return true;
	}
	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function move($direction)
	{
		
        $row =& $this->getTable();
        if (!$row->load($this->_id)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->move( $direction, ' published >= 0 AND section="'.$row->section.'"' )) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        return true;
	}
	
	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function saveorder($cid = array(), $order)
	{
        $row =& $this->getTable();
        $groupings = array();
        // update ordering values
        for( $i=0; $i < count($cid); $i++ )
        {
            $row->load( (int) $cid[$i] );

            if ($row->ordering != $order[$i])
            {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }
        return true;
	}
	
	/**
	* Method to change access
	*
	* @access public
	* @return boolean True on success
	
	*/
	function accessMenu($id, $access)
	{

		$row =& $this->getTable();
		$row->load( $id );
		$row->access = $access;

		if ( !$row->check() ) {
			$this->setError($this->_db->getErrorMsg());
            return false;
		}
		if ( !$row->store() ) {
			$this->setError($this->_db->getErrorMsg());
            return false;
		}
		return true;
	}
	
	/**
	* Method to load content item data
	*
	* @access private
	* @return boolean True on success
	
	*/
	function _loadData()
	{
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
            $query = 'SELECT c.*'.
            ' FROM #__mumuse_category AS c' .
            ' WHERE c.id = '.(int) $this->_id;
            $this->_db->setQuery($query);
            $this->_data = $this->_db->loadObject();
            return (boolean) $this->_data;
        }
        return true;
    }
        
        
    /**
    * Method to initialise the item data
    *
    * @access private
    * @return boolean True on success
    
    */
    function _initData()
    {
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
            $item = new stdClass();

            $item->id                 		= null;
            $item->parent_id		    	= null;
            $item->title              		= '';
            $item->name               		= '';
            $item->alias              		= '';
            $item->image              		= "blank.png";
            $item->section              	= '';
            $item->image_position     		= '';
            $item->description        		=  '';
            $item->published          		= 1;
            $item->checked_out        		= 0;
            $item->checked_out_time   		= 0;
            $item->editor   				= '';
            $item->ordering           		= '';
            $item->access             		= '';
            $item->params             		= null;
   
            $this->_data = $item;
            return (boolean) $this->_data;
        }
        return true;
	}
	

}
?>