<?php
/**
 * @version		$Id: order.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class myMuseModelOrder extends Jmodel
{
	function __construct(){
		parent::__construct();

		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}
		global $mainframe, $option;
 		// Get the pagination request variables
  		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
 		$this->setState('limit', $limit);
  		$this->setState('limitstart', $limitstart);

	}

	/**
     * Store id
     *
     * int
     */
     var $_id = null;
     
	/**
     * Store task
     *
     * string
     */
     var $_task = null;
     
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
  
 	/**
  	* stores total
  	*
  	* @var integer
  	*/
  	var $_total = null;
  	
  	/**
  	* stores shopper
  	*
  	* @var object
  	*/
  	var $_shopper = null;
     
    /**
     * Method to set the store identifier
     *
     * @access    public
     * @param    int Store identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id      = $id;
    	$this->_data    = null;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	// Get the WHERE and ORDER BY clauses for the query
  		$where = $this->_buildContentWhere();
  		$orderby = $this->_buildContentOrderBy();
        $query = 'SELECT c.*, u.first_name, u.last_name '
		. ' FROM #__mymuse_order AS c'
		. ' LEFT JOIN #__mymuse_shopper as u ON c.shopper_id = u.id'
            . $where
            . $orderby;
            
        return $query;
    }
 
    function _buildContentOrderBy()
    {
    	global $mainframe, $option;
    	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.id', 'cmd' );

        $good_sort = array('u.last_name','c.order_subtotal','c.created','c.order_status','c.id');
		if(!in_array($filter_order,$good_sort)){
			$filter_order = 'c.id';
		}
    	$filter_order_Dir = $mainframe->getUserStateFromRequest( 'filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );
    	if($filter_order_Dir == ""){
			$filter_order_Dir = "desc";
		}
    	
    	if($filter_order != '') {
    		$orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'  ';
    	}
    	return $orderby;
    }

    function _buildContentWhere()
    {
    	global $mainframe, $option;
    	
    	$filter_state 			= $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
     	$search 				= $mainframe->getUserStateFromRequest( $option.'search', 'search', '', 'string' );
    	$search 				= JString::strtolower( $search );
    	$filter_order_status	= JRequest::getVar( 'filter_order_status','',		'POST',		'word' );
    	$params			   		= JRequest::getVar( 'params', 'params','', 'array' );
    	$filter_date_start 		= isset($params['filter_date_start'])?$params['filter_date_start'] : '' ;
		$filter_date_end   		= isset($params['filter_date_end'])? $params['filter_date_end'] : '';
		
		$datenow =& JFactory::getDate();
		$now = $datenow->toFormat("%Y-%m-%d");
		if($filter_date_start == $now && $filter_date_end == $now ){
			$filter_date_start = '';
			$filter_date_end = '';
		}
		
    	$where = array();
		if($filter_date_start){
			$where[] = "c.created >= '$filter_date_start 00:00:00'";
		}
		if($filter_date_end){
			$where[] = "c.created <= '$filter_date_end 00:00:00'";
		}
		if ( $filter_order_status ) {
			$where[] = "c.order_status = '$filter_order_status'";
		}
		if ($search) {
			$where[] = '( LOWER(u.last_name) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false )
			.' OR LOWER(u.first_name) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
		}

		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

    	return $where;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryOne()
    {
        $query = 'SELECT *'
		. ' FROM #__mymuse_order  '
		. ' WHERE id='.$this->_id;
        return $query;
    }
     
    /**
     * Retrieves the store data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {

        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	if(!isset($this->_id))
        	{	
        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query,  $this->getState('limitstart'),$this->getState('limit') );
        	}
        	else
        	{
        		if($this->_id)
        		{
        			$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObjectList();
            		
        			$this->_data[0]->tax_array = array();
        			$q = "SELECT * FROM #__mymuse_tax_rate ORDER BY ordering";
        			$this->_db->setQuery($q);
        			$tax_rates = $this->_db->loadObjectList();
        			foreach($tax_rates as $rate){
        				$name = trim($rate->tax_name);
        				//$regex = TAX_REG_EX;
        				$name = preg_replace("/['-\/\s\\\]/","_",$name);
        				$this->_data[0]->tax_array[$name] = $this->_data[0]->$name;
        				$this->_data[0]->tax_total += $this->_data[0]->tax_array[$name];
        			}
					$this->getItems();
        			$this->_data[0]->order_total	= $this->_data[0]->order_total 
        			- ($this->_data[0]->coupon_discount*$this->_data[0]->order_subtotal/100) 
        			+ $this->_data[0]->order_shipping + $this->_data[0]->tax_total;
        			$this->_data[0]->order_total = sprintf("%.2f", $this->_data[0]->order_total);
            		
        		}

        	}
        }
 
        return $this->_data;
    }
    /**
  	* Method to get the total number of mymuse order items
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the content if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();
  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  

    /**
  	* Method to get the shopper and possible shiptto entries
  	*
  	* @access public
  	* @return object
  	*/
  	function getShopper()
  	{
  		// Lets load the shopper if it does not exist
  		if (empty($this->_shopper) && isset($this->_data[0]->id))
  		{
  			$query = "SELECT s.*,u.email FROM #__mymuse_shopper as s  
  				LEFT JOIN #__users as u ON u.id=s.user_id
  				WHERE s.id=".$this->_data[0]->shopper_id;
  			$this->_db->setQuery( $query );
  			$this->_shopper = $this->_db->loadObject();
  			
  			if($this->_data[0]->ship_info_id && ($this->_data[0]->ship_info_id != $this->_data[0]->shopper_id)){
  				$query = "SELECT s.*,u.email FROM #__mymuse_shopper as s  
  					LEFT JOIN #__users as u ON u.id=s.user_id
  					WHERE s.id=".$this->_data[0]->ship_info_id;
  				$this->_db->setQuery( $query );
  				$this->_shopper->shipto = $this->_db->loadObject();
  			}
  		}
 		return $this->_shopper;
  	}
  	
    /**
  	* Method to get the order items
  	*
  	* @access public
  	* @return objects
  	*/
  	function getItems()
  	{
  		// Lets load the items if they do not exist
  		if (empty($this->_data[0]->items))
  		{
  			$query = "SELECT * FROM #__mymuse_order_item 
  				WHERE order_id=".$this->_id;
  			$this->_db->setQuery( $query );
  			$this->_data[0]->items = $this->_db->loadObjectList();
  			$this->_data[0]->order_total = 0.00;
  		  	for($i = 0; $i < count($this->_data[0]->items); $i++){

				$this->_data[0]->items[$i]->subtotal = sprintf("%.2f", $this->_data[0]->items[$i]->product_item_price * $this->_data[0]->items[$i]->product_quantity);
				$this->_data[0]->order_total += $this->_data[0]->items[$i]->subtotal;
  			}
  			
  		}
  		$this->_data[0]->order_total = sprintf("%.2f", $this->_data[0]->order_total);
 		return $this->_data[0]->items;
  	}
  	


    /**
     * Method to get a pagination object for orders
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
  
    /**
     * Method to set the store lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $params;
    	
    	$filter_order_status	= JRequest::getVar( 'filter_order_status','','POST','word' );
		$rows =& $this->_data;
    	// order_status filter
		$count = count( $this->_data );
		$query = "SELECT * from #__mymuse_order_status";

		$order_status[] = JHTML::_('select.option', '0', '- '.JText::_('MYMUSE SELECT STATUS').' -', 'code', 'name');
		$this->_db->setQuery($query);
		$order_status = array_merge($order_status, $this->_db->loadObjectList());

		if($count == 1){
			$this->_data[0]->order_status_form = JHTML::_('select.genericlist',  $order_status, 'order_status', 'class="inputbox" size="1"', 'code', 'name', $this->_data[0]->order_status);
		}
		for($i=0;$i<$count;$i++){
			$this->_data[$i]->order_status = MyMuseHelper::printOrderStatus($this->_data[$i]->order_status);
		}
		
		$lists['order_status'] = JHTML::_('select.genericlist',  $order_status, 'filter_order_status', 
		'class="inputbox" size="1"', 'code', 'name', $filter_order_status);

		
    	// artists
    	$my_section_artists = $params->get('my_section_artists');
    	$chosen_artist	= JRequest::getVar( 'artistid','','POST','int' );
    	
		$query = 'SELECT id, title, section' .
			' FROM #__mymuse_categories' .
			' WHERE section ='.$my_section_artists.
			' ORDER BY ordering';

		$this->_db->setQuery($query);
		$res = $this->_db->loadObjectList();
		
		$artist[] = JHTML::_('select.option', '-1', JText::_( 'MYMUSE SELECT ARTIST' ), 'id', 'title');;
		for($i=0;$i<count($res);$i++){
			$artist[] = $res[$i];
		}
		$lists['artistid'] = JHTML::_('select.genericlist',  $artist, 'artistid', 'class="inputbox"', 'id', 'title', $chosen_artist);
		
		return $lists;
    }
 
    	/**
	* Method to store the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store($data)
	{
        $row =& $this->getTable();
        $row->load($data['id']);
        // Bind the form fields to the item table
      
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        // if new item, order last in appropriate group
        if (!$row->id) {
            $row->ordering = $row->getNextOrder( 'id' );
        }
        $isNew = true;
        // Are we saving from an item edit?
        if ($row->id) {
            $isNew = false;

        }

 

        // Make sure the item table is valid
        if (!$row->check()) {
            $this->setError($row->getError());
            return false;
        }
         
        // Store the item table to the database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        return true;
	}
	
	/**
	* Method to remove a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            $query = 'DELETE FROM #__mymuse_order'
            . ' WHERE id IN ( '.$cids.' )';

            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        	$query = 'DELETE FROM #__mymuse_order_item'
            . ' WHERE order_id IN ( '.$cids.' )';

            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
	
	/**
	* Tests if item is checked out
	*
	* @access public
	* @param int A user id
	* @return boolean True if checked out
	
	*/
	function isCheckedOut( $uid=0 )
	{
        if ($this->_loadData())
        {
            if ($uid) {
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            } else {
                return $this->_data->checked_out;
            }
        }
	}
	/**
	* Method to checkin/unlock the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function checkin()
	{
	   if ($this->_id)
	   {
	       $item = & $this->getTable();
	       if(! $item->checkin($this->_id)) {
	           $this->setError($this->_db->getErrorMsg());
	           return false;
	       }
	   }
	   return false;
	}
	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if ($this->_id)
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}

}
?>