<?php
/**
 * @version		$Id: product.php 169 2010-10-13 02:19:13Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class myMuseModelProduct extends Jmodel
{


	/**
     * Store task
     *
     * string
     */
     var $_task = null;
     
    /**
     * Store one id
     *
     * @$item->array
     */
     var $_id = null;
     
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
  
 	/**
  	* stores total
  	*
  	* @var integer
  	*/
  	var $_total = null;
     
  	/**
  	* stores _parent_product
  	*
  	* @var array
  	*/
  	var $_parent_product = null;
  	
  	/**
  	* stores _parentid
  	*
  	* @var array
  	*/
  	var $_parentid = null;
  	
  	/**
  	* stores _attribute_skus
  	*
  	* @var array
  	*/
  	var $_attribute_skus = null;
  	
  	/**
  	* stores _attributes
  	*
  	* @var array
  	*/
  	var $_attributes = null;
  	
	function __construct()
	{
		parent::__construct();
		
		global $nullDate;
		$nullDate = $this->_db->getNullDate();

		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		$array = JRequest::getVar('cid',  0, '', 'array');
		$type = JRequest::getVar('type',  0);
		$parentid = JRequest::getVar( 'parentid', 0, '', 'int' );
		$use_parentid = JRequest::getVar( 'use_parentid', 0, '', 'int' );
		if(!$array[0] && $use_parentid && $parentid){
			$array[0] = $parentid;
		}
		
		if($array[0]){
    		$this->setId((int)$array[0]);
		}

		if($parentid){
			$query = "SELECT * from #__mymuse_product WHERE id=".$parentid;
			$this->_db->setQuery($query);
			$this->_parent_product = $this->_db->loadObject();
			$this->_parentid = $parentid;
		}
		
		global $mainframe, $option;
 		// Get the pagination request variables
  		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
 		$this->setState('limit', $limit);
  		$this->setState('limitstart', $limitstart);
  		
	}
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	// Get the WHERE and ORDER BY clauses for the query
  		$where = $this->_buildContentWhere();
  		$orderby = $this->_buildContentOrderBy();
  		
		// Get the products
		$query = 'SELECT c.*, g.name AS groupname, ';
		if(preg_match("/cc/",$where)){
			$query .= 'cc.title AS name, ';
		}
		$query .= 'u.name AS editor, s.title AS section_name, v.name AS author' .
				' FROM #__mymuse_product AS c' .
				' LEFT JOIN #__sections AS s ON s.id = c.sectionid' .
				' LEFT JOIN #__groups AS g ON g.id = c.access' .
				' LEFT JOIN #__users AS u ON u.id = c.checked_out' .
				' LEFT JOIN #__users AS v ON v.id = c.created_by'  
            . $where
            . $orderby;
           //print_r($query);
        return $query;
    }
 
    function _buildContentOrderBy()
    {
    	global $mainframe, $option;
    	
    	$filter_order 		= $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
    	$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
		$catid				= $mainframe->getUserStateFromRequest( 'catid',	'catid', 0,	'int' );
    	
		$good_sort = array('c.title','c.state','c.ordering','groupname','cc.name','c.created','c.hits','c.id');
    	if(!in_array($filter_order,$good_sort)){
			$filter_order = 'c.ordering';
		}
		    	
    	$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', section_name, ';
		if($catid){
			$order .= 'cc.title, ';
		}
		$orderby.= 'c.ordering';
    	return $orderby;
    }

    function _buildContentWhere()
    {
    	global $mainframe, $option;
    	$filter_state = $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
    	$sectionid	  = $mainframe->getUserStateFromRequest( 'sectionid',		'sectionid',		0,				'int' );
    	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
    	$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );
		$filter_state	= $mainframe->getUserStateFromRequest( 'filter_state', 'filter_state', '', 'word' );
		$catid			= $mainframe->getUserStateFromRequest( $option.'filter_catid',	'filter_catid', 0,	'int' );
		$filter_sectionid	= $mainframe->getUserStateFromRequest( 'filter_sectionid',	'filter_sectionid',	-1,	'int' );
    	$search = $mainframe->getUserStateFromRequest( $option.'search', 'search', '', 'string' );
    	$search = JString::strtolower( $search );
    	$where = array();

    	if (!$filter_order) {
			$filter_order = 'c.ordering';
		}

		$all = 1;

		if ($filter_sectionid >= 0) {
			$filter = ' WHERE cc.section = '. (int) $filter_sectionid;
		}
		$section->title = 'All Products';
		$section->id = 0;

		// just get the parent products
		$where[] = 'c.parentid=0';

		/*
		 * Add the filter specific information to the where clause
		 */
		// Section filter
		if ($filter_sectionid >= 0) {
			$where[] = 'c.sectionid = ' . (int) $filter_sectionid;
		}
		// Category filter
		if ($catid > 0) {
			$prewhere = ' LEFT JOIN #__mymuse_product_category_xref AS pcx ON pcx.product_id = c.id' .
				' LEFT JOIN #__mymuse_categories AS cc ON cc.id = pcx.catid';
			$where[] = ' cc.id = ' . (int) $catid;
		}else{
			$prewhere = '';
		}

		// Product state filter
		if ($filter_state) {
			if ($filter_state == 'P') {
				$where[] = 'c.state = 1';
			} else {
				if ($filter_state == 'U') {
					$where[] = 'c.state = 0';
				} else if ($filter_state == 'A') {
					$where[] = 'c.state = -1';
				} else {
					$where[] = 'c.state != -2';
				}
			}
		}
		// Keyword filter
		if ($search) {    			
			$where[] = '(LOWER( c.title ) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false ) .
				' OR c.id = ' . (int) $search . ')';
		}

    	$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

    	return $prewhere . $where;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve a row from the database
     */
    function _buildQueryOne()
    {
        $query = ' SELECT * '
            . ' FROM #__mymuse_product WHERE id ='
            .$this->_id;
        return $query;
    }
     
     /**
     * Add categories to the product entries
     * @return true
     */
    function _addCategories()
    {
    	foreach($this->_data as $row)
    	{
        	// get related categories
        	$query = "SELECT cc.id as id, title FROM #__mymuse_categories as cc, #__mymuse_product_category_xref as pcx
			WHERE pcx.product_id='".$row->id."' 
			AND cc.id=pcx.catid ORDER BY section, name";
			$this->_db->setQuery($query);
			$catnames = $this->_db->loadObjectList();
			$row->categories ="";
			foreach($catnames as $catname){
				$row->categories .= '<a href="index.php?option=com_mymuse&controller=category&task=edit&cid[]='. $catname->id .
				'">' . $catname->title. "</a><br />";
				$row->catid[] = $catname->id;
			}
    	}
					
    }
    /**    
     * Retrieves the product data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {

        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	
        	if($this->_task == "" || $this->_task == "default")
        	{	
        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query, $this->getState('limitstart'),$this->getState('limit')  );
            	$this->_addCategories();
        	}
        	else
        	{
        		if (isset($this->_id))
        		{
        			$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObject();
            		$query = "SELECT product_price FROM #__mymuse_product_price
					WHERE product_id = ".$this->_id." ";
					$this->_db->setQuery($query);
					$this->_data->product_price = $this->_db->loadResult();
					if (trim($this->_data->images)) {
						$this->_data->images = explode("\n", $this->_data->images);
					} else {
						$this->_data->images = array ();
					}
        			if($this->_data->parentid){
        				$query = "SELECT * from #__mymuse_product WHERE id=".(int)$this->_data->parentid;
        				$this->_db->setQuery($query);
        				$this->_parent_product = $this->_db->loadObject();
        				$this->_parentid = $this->_parent_product->id;
        			}

        		}
        		else
        		{
        			$this->_initData();
        		}
        		$this->_data->parent_product =& $this->_parent_product;
        		if(!$this->_data->parentid){
        			$this->_data->parentid =& $this->_parentid;
        		}
        		
        	}
        }
        return $this->_data;
    }
    /**
  	* Method to get the total number of mymuse_product items
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the total number of products if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();
  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  
    /**
     * Method to set the product identifier
     *
     * @access    public
     * @param    int Product identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data    = null;
    }

    
    /**
     * Method to get a pagination object for categories
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
  
    /**
     * Method to set the product lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $params, $option, $mainframe;

    	$filter_state = $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
		$filter_catid = $mainframe->getUserStateFromRequest( $option.'filter_catid', 'filter_catid', 0, 'int' );
		$filter_artistid = $mainframe->getUserStateFromRequest( $option.'filter_artistid', 'filter_artistid', 0, 'int' );
		$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
		$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );
		
		$edit = JRequest::getVar('edit', 0);
		$my_section_catalog = $params->get('my_section_catalog');
		$my_section_artists = $params->get('my_section_artists');
		$my_reviews_catid 	= $params->get('my_reviews_catid');
		

		
		//categories
		$query = 'SELECT id, title, section' .
				' FROM #__mymuse_categories' .
				' WHERE section ='.$my_section_catalog.
				' ORDER BY ordering';
		$this->_db->setQuery($query);

		$categories = array ();
		$categories[] = JHTML::_('select.option', '-1', JText::_( 'MYMUSE SELECT CATEGORY' ), 'id', 'title');
		$categories = array_merge($categories, $this->_db->loadObjectList());
		
		// artists
		$query = 'SELECT id, title, section' .
			' FROM #__mymuse_categories' .
			' WHERE section ='.$my_section_artists.
			' ORDER BY ordering';

		$this->_db->setQuery($query);
		$res = $this->_db->loadObjectList();
		
		$artist[] = JHTML::_('select.option', '-1', JText::_( 'MYMUSE SELECT ARTIST' ), 'id', 'title');;
		$artists[] = JHTML::_('select.option', '-1', JText::_( 'MYMUSE SELECT OTHER ARTISTS' ), 'id', 'title');
		for($i=0;$i<count($res);$i++){
			$artist[] = $res[$i];
			if(isset($this->_data->artistid) && $res[$i]->id != $this->_data->artistid){
				$artists[] = $res[$i];
			}
		}
		if(isset($this->_id) || $this->_task == "add"){
			
			// section lists
			$sectionid		= 0;
			$javascript = "onchange=\"changeDynaList( 'catid', sectioncategories, document.adminForm.sectionid.options[document.adminForm.sectionid.selectedIndex].value, 0, 0);\"";
			
			$query = 'SELECT s.id, s.title' .
				' FROM #__sections AS s' .
				' WHERE scope = "com_mymuse"' .
				' ORDER BY s.ordering';
			$this->_db->setQuery($query);

			$sections[] = JHTML::_('select.option', '-1', '- '.JText::_('MYMUSE SELECT SECTION').' -', 'id', 'title');
			$sections = array_merge($sections, $this->_db->loadObjectList());
			$lists['sectionid'] = JHTML::_('select.genericlist',  $sections, 'sectionid', 'class="inputbox" size="1" ', 'id', 'title', intval($this->_data->sectionid));
			
			
			// get list of review articles for dropdown filter
			$selectedArticles = array();
			$contents = array();
			$query = 'SELECT content_id' .
			' FROM #__mymuse_product_content_xref' .
			' WHERE product_id='. $this->_data->id 
			;
			//echo  $query;
			$this->_db->setQuery($query);
			if($arts = $this->_db->loadObjectList()){

				foreach($arts as $art){
					$selectedArticles[] = $art->content_id;
				}
				
			}
			$query = 'SELECT c.id AS id, c.title AS title' .
				' FROM #__content AS c' .
				' WHERE c.catid ='.$my_reviews_catid.
				' ORDER BY c.ordering';
			$this->_db->setQuery($query);
			$contents[] = JHTML::_('select.option', '-1', JText::_( 'MYMUSE SELECT REVIEW' ), 'id', 'title');
			$contents = array_merge($contents, $this->_db->loadObjectList());

			
			$lists['contentid'] = JHTML::_('select.genericlist',  $contents, 'contentid[]', 'class="inputbox" size="4" MULTIPLE ', 'id', 'title', $selectedArticles);
		
			
			// find current cats
			$selectedCats = array();

			if(isset($this->_data->id)){
				$query = 'SELECT catid' .
			' FROM #__mymuse_product_category_xref' .
			' WHERE product_id='. $this->_data->id 
				;
				//echo  $query;
				$this->_db->setQuery($query);
				$cats = $this->_db->loadObjectList();

				foreach($cats as $cat){
					$selectedCats[] = $cat->catid;
				}
				$this->_data->cats = $selectedCats;
			}
			
			//artists

			$lists['artistid'] = JHTML::_('select.genericlist',  $artist, 'artistid', 'class="inputbox"', 'id', 'title', $this->_data->artistid);
			$lists['artistids'] = JHTML::_('select.genericlist',  $artists, 'artistids[]', 'class="inputbox" size="4" MULTIPLE ', 'id', 'title', $selectedCats);
			
			//categories
			$lists['catid'] = JHTML::_('select.genericlist',  $categories, 'catid[]', 'class="inputbox" size="4" MULTIPLE', 'id', 'title', $selectedCats);

			// Items, Attributes, Files
			$lists['items'] = array();
			$lists['attributes'] = array();
			$lists['files'] = array();
		
			
			//attributes
			$query = 'SELECT * from #__mymuse_product_attribute_sku WHERE 
			product_parent_id='.$this->_data->id.'
			ORDER BY ordering';
			$this->_db->setQuery($query);
			$lists['attribute_sku'] = $this->_db->loadObjectList();
			
			// items
			$query = "SELECT c.* from #__mymuse_product as c WHERE parentid=".$this->_data->id."
			AND product_downloadable=0 ORDER BY $filter_order $filter_order_Dir";
			$this->_db->setQuery($query);
			if($lists['items'] = $this->_db->loadObjectList()){
			
				foreach($lists['items'] as $item){
					foreach($lists['attribute_sku'] as $a_sku){
						$query = 'SELECT attribute_value from #__mymuse_product_attribute WHERE product_id='.$item->id.'
						AND product_attribute_sku_id='.$a_sku->id;
						$this->_db->setQuery($query);
						$item->attributes[$a_sku->name] = $this->_db->loadResult();
					}
					$query = 'SELECT * from #__mymuse_product_attribute WHERE product_id='.$item->id;
					//echo $query;
					$this->_db->setQuery($query);
					$lists['attributes'][$item->id] = $this->_db->loadObjectList();


					$query = "SELECT product_price FROM #__mymuse_product_price
					WHERE product_id = ".$item->id." ";
					$this->_db->setQuery($query);
					$item->product_price = $this->_db->loadResult();

				}
			}

				
			//tracks and other downloadables
			$query = "SELECT id,title,file_name,file_preview,file_length,file_type,ordering,checked_out from #__mymuse_product 
			as c WHERE parentid=".$this->_data->id."
			AND c.product_downloadable=1 ORDER BY $filter_order $filter_order_Dir";
			$this->_db->setQuery($query);
			$lists['files'] = $this->_db->loadObjectList();

			
			// Imagelist for albums
			$lists['image'] = JHTML::_('list.images', 'image', $this->_data->image, NULL, "/images/stories/albums" );
			
			//state
			$state = $this->_data->state;
			$lists['state'] = JHTML::_('select.booleanlist', 'state', '', $state);
		
			/*
		 	* We need to unify the introtext and fulltext fields and have the
		 	* fields separated by the {readmore} tag, so lets do that now.
		 	*/
			if (JString::strlen($this->_data->fulltext) > 1) {
				$this->_data->text = $this->_data->introtext . "<hr id=\"system-readmore\" />" . $this->_data->fulltext;
			} else {
				$this->_data->text = $this->_data->introtext;
			}
			
			//	build the html select list for ordering
			$query = 'SELECT ordering AS value, title AS text' .
				' FROM #__mymuse_product' .
				' WHERE state >= 0' .
				' ORDER BY ordering';
			if($edit){		
				$lists['ordering'] = JHTML::_('list.specificordering', $this->_data, $this->_data->id, $query, 1);
			}else{
				$lists['ordering'] = JHTML::_('list.specificordering', $this, '', $query, 1);
			}
			
		}else{
			
			$lists['filter_catid'] = JHTML::_('select.genericlist',  $categories, 'filter_catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'id', 'title', $filter_catid);
			$lists['filter_artistid'] = JHTML::_('select.genericlist',  $artists, 'filter_artistid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'id', 'title', $filter_artistid);
			$lists['filter_state'] = JHTML::_('grid.state', $filter_state, 'Published', 'Unpublished');
		}

		
		return $lists;
    }
    
    /**
     * Method to set the file lists
     *
     * @access    public
     * @return    array
     */
    function getFileLists()
    {
    	global $params;
    	
 		// file list for albums
		$directory = "/".$params->get('my_preview_dir');
		$javascript = "onchange=\"javascript:if (document.forms.adminForm.file_preview.options[selectedIndex].value!='') {document.imagelib.src='..$directory' + document.forms.adminForm.file_preview.options[selectedIndex].value} else {document.imagelib.src='../images/blank.png'}\"";

		jimport( 'joomla.filesystem.folder' );
		$files = JFolder::files( JPATH_SITE.DS.$directory );
		$previews 	= array(  JHTML::_('select.option',  '', '- '. JText::_( 'MYMUSE SELECT FILE' ) .' -' ) );
		foreach ( $files as $file ) {
		   if ( preg_match( "#mp3|mp4a#i", $file ) ) {
				$previews[] = JHTML::_('select.option',  $file );
			}
		}
		$lists['previews'] = JHTML::_('select.genericlist',  $previews, 'file_preview', 'class="inputbox" size="1" '. $javascript, 'value', 'text', $this->_data->file_preview );

		return $lists;
    	
    }
    
    
    
	/**
	* Tests if item is checked out
	*
	* @access public
	* @param int A user id
	* @return boolean True if checked out
	
	*/
	function isCheckedOut( $uid=0 )
	{
        if ($this->_loadData())
        {
            if ($uid) {
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            } else {
                return $this->_data->checked_out;
            }
        }
	}
	/**
	* Method to checkin/unlock the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function checkin()
	{
	   if ($this->_id)
	   {
	       $item = & $this->getTable();
	       if(! $item->checkin($this->_id)) {
	           $this->setError($this->_db->getErrorMsg());
	           return false;
	       }
	   }
	   return false;
	}
	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if (isset($this->_id))
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}
	
	/**
	* Method to store the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store(&$data)
	{
		global $params, $nullDate;
		
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');
		
        $row 			=& $this->getTable();
        $user			=& JFactory::getUser();
        $details		= JRequest::getVar( 'details', array(), 'post', 'array');
		$catids	    	= JRequest::getVar( 'catid', array(), 'post', 'array');
		$artistid		= JRequest::getVar( 'artistid', null, 'post', 'int');
		$artistids		= JRequest::getVar( 'artistids', array(), 'post', 'array');
		$contentids	    = JRequest::getVar( 'contentid', array(), 'post', 'array');
		$prod_params	= JRequest::getVar( 'params', null, 'post', 'array' );
		$product_price	= JRequest::getVar( 'product_price', 0, '', 'float' );
		$sectionid		= JRequest::getVar( 'sectionid', 0, '', 'int' );
		$type			= $data['type'];
		$old_alias		= JRequest::getVar('old_alias', null);
		$parentid		= JRequest::getVar( 'parentid', null, 'post', 'int');
		
		$artistids[]	= $artistid;
		$catids 		= array_merge($catids,$artistids);
        

        // Bind the form fields to the item table
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $isNew = true;
        $datenow =& JFactory::getDate();
        
        // if new item, order last in appropriate group
        if (!$row->id) {
            $row->created = $datenow->toMySQL();
        }
		if (!$row->ordering) {
            $row->ordering = $row->getNextOrder( 'id' );
        }

        // Are we saving from an item edit?
        if ($row->id) {
            $isNew = false;
            $row->modified 		= $datenow->toMySQL();
			$row->modified_by 	= $user->get('id');
        }
        $row->created_by 	= $row->created_by ? $row->created_by : $user->get('id');
		if ($row->created && strlen(trim( $row->created )) <= 10) {
			$row->created 	.= ' 00:00:00';
		}
 
		$config =& JFactory::getConfig();
		$tzoffset = $config->getValue('config.offset');
		$date =& JFactory::getDate($row->created, $tzoffset);
		
		// Append time if not added to publish date
		if (strlen(trim($row->publish_up)) <= 10) {
			$row->publish_up .= ' 00:00:00';
		}

		$date =& JFactory::getDate($row->publish_up, $tzoffset);
		$row->publish_up = $date->toMySQL();
		
		// Handle never unpublish date
		if (trim($row->publish_down) == JText::_('MYMUSE NEVER') || trim( $row->publish_down ) == '')
		{
			$row->publish_down = $nullDate;
		}
		else
		{
			if (strlen(trim( $row->publish_down )) <= 10) {
				$row->publish_down .= ' 00:00:00';
			}
			$date =& JFactory::getDate($row->publish_down, $tzoffset);
			$row->publish_down = $date->toMySQL();
		}
		// Get a state and parameter variables from the request
		$row->state	= JRequest::getVar( 'state', 0, '', 'int' );
		

		// Build parameter INI string
		if (is_array($prod_params))
		{
			$txt = array ();
			foreach ($prod_params as $k => $v) {
				$txt[] = "$k=$v";
			}
			$row->attribs = implode("\n", $txt);
		}
		
		// Get metadata string
		$metadata = JRequest::getVar( 'meta', null, 'post', 'array');
		if (is_array($metadata))
		{
			$txt = array();
			foreach ($metadata as $k => $v) {
				if ($k == 'description') {
					$row->metadesc = $v;
				} elseif ($k == 'keywords') {
					$row->metakey = $v;
				} else {
					$txt[] = "$k=$v";
				}
			}
			$row->metadata = implode("\n", $txt);
		}
		
			// Get submitted text from the request variables
		$text = JRequest::getVar( 'text', '', 'post', 'string', JREQUEST_ALLOWRAW );

		// Clean text for xhtml transitional compliance
		$text		= str_replace( '<br>', '<br />', $text );

		// Search for the {readmore} tag and split the text up accordingly.
		$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
		$tagPos	= preg_match($pattern, $text);

		if ( $tagPos == 0 )
		{
			$row->introtext	= $text;
		} else
		{
			list($row->introtext, $row->fulltext) = preg_split($pattern, $text, 2);
		}
		
		
		// set details from params
		$row->product_physical   	= isset($details['product_physical'])? $details['product_physical'] : 0;
		$row->product_downloadable 	= isset($details['product_downloadable'])? $details['product_downloadable']: 0;
		$row->product_made_date 	= isset($details['product_made_date'])? $details['product_made_date']: '';
		$row->product_in_stock 		= isset($details['product_in_stock'])? $details['product_in_stock'] : 0;
		
		MyMuseHelper::saveProductPrep($row);

	    // Make sure the item table is valid
        if (!$row->check()) {
            $this->setError($row->getError());
            return false;
        }
        
		// blob of the product file
		if(isset($_FILES['product_file']) && $_FILES['product_file']['size'] >  0){
			$row->file_name = $_FILES['product_file']['name'];
			$tmpName  = $_FILES['product_file']['tmp_name'];
			$row->file_length = $_FILES['product_file']['size'];
			$row->file_type = $_FILES['product_file']['type'];

			// do we save it to the database?
			if($params->get('my_use_database')){
				$fp      = fopen($tmpName, 'r');
				$row->file_contents = fread($fp, filesize($tmpName));
				fclose($fp);
				//echo "stored in DB";
				
			}else{
				// get artist alias
        		$artist_alias = MyMuseHelper::getArtistAlias($row->parentid, 1);
        		$album_alias = MyMuseHelper::getAlbumAlias($row->parentid);
        		
				// see if there is an old file to delete
				$old = $params->get('my_download_dir').DS.$artist_alias.DS.$album_alias.DS.$row->title_alias;
				if($row->title_alias && file_exists($old)){
					if(!JFile::delete($old)){
						$this->setError(JText::_("MYMUSE COULD NOT DELETE FILE").": ".$old);
					}
				}

			    // make name and copy it to the download dir
				if($params->get('my_encode_filenames')){
					$ext = MyMuseHelper::getExt($row->file_name);
					$name = md5($row->file_name . time()).'.'.$ext;
					$row->title_alias = $name;
				}else{
					$name = $row->file_name;
				}
				
				
        		$new = $params->get('my_download_dir').DS.$artist_alias.DS.$album_alias.DS.$name;
				
				if(!JFile::copy($tmpName, $new)){
					$this->setError(JText::_("MYMUSE COULD NOT MOVE FILE").": ".$tmpName." ".$new);
					echo ": ".$tmpName." ".$new; exit; 
            		return false;
				}
			}
			if(!get_magic_quotes_gpc())
			{
    			$row->file_name = addslashes($row->file_name);
    			$row->file_contents = addslashes($row->file_contents);
			}
		}

		// allfiles
		if(isset($data['product_allfiles'])){
			$row->file_length = strlen($row->file_contents);
			$row->file_type = 'application/zip';
		}
		
        // Increment the content version number
		$row->version++;

	    // Store the item to the database
        if (!$row->store()) {
            $this->setError(JText::_('MYMUSE COULD NOT SAVE PRODUCT').$this->_db->getErrorMsg());
            return false;
        }
        
        $this->_id = $row->id;
        $data['id'] = $row->id;

        // if it is the parent
        if(!isset($row->parentid) || !$row->parentid){
        	// make a download dir for this product
        	

        	// get artist alias
        	$artist_alias = MyMuseHelper::getArtistAlias($row->artistid);
        	$dir = $params->get('my_download_dir').DS.$artist_alias.DS.$row->alias;

        	if($old_alias && $old_alias != $row->alias){
        		// move the old dir to the new name
        		$src = $params->get('my_download_dir').DS.$artist_alias.DS.$old_alias;
        		$ret = JFolder::move($src, $dir);
        		if(!$ret){
        			$this->setError($ret." ".$src." ".$dir);
        			return false;
        		}
        	}

        	if(!file_exists($dir)){
        		if(!JFolder::create($dir)){
        			$this->setError(JText::_("MYMUSE COULD NOT MAKE DIR").$dir);
        			return false;
        		}
        		if(!JFile::copy(JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."index.html",
        		$dir.DS."index.html")){
        			$this->setError(JText::_("MYMUSE COULD NOT COPY INDEX").$dir);
        		}
        	}
        
        	// update product_category_xref
        	$query = "DELETE FROM #__mymuse_product_category_xref WHERE product_id=".$row->id;
        	$this->_db->setQuery($query);
        	$this->_db->query();

        	foreach($catids	as $catid){
        		$query = "INSERT INTO #__mymuse_product_category_xref
			(catid,product_id) VALUES (".$catid.",".$row->id.")";
        		$this->_db->setQuery($query);
        		if(!$this->_db->query()){
        			$this->setError(JText::_('MYMUSE COULD NOT SAVE PRODUCTCAT XREF').$this->_db->getErrorMsg());
        			return false;
        		}

        	}

        	// update product_content_xref
        	$query = "DELETE FROM #__mymuse_product_content_xref WHERE product_id=".$row->id;
        	$this->_db->setQuery($query);
        	$this->_db->query();

        	foreach($contentids	as $contentid){
        		$query = "INSERT INTO #__mymuse_product_content_xref
			(content_id,product_id) VALUES (".$contentid.",".$row->id.")";
        		$this->_db->setQuery($query);
        		if(!$this->_db->query()){
        			$this->setError(JText::_('MYMUSE COULD NOT SAVE PRODUCTREVIEW XREF').$this->_db->getErrorMsg());
        			return false;
        		}

        	}
        }
        
		// Checkin the product
		$row->checkin();
		$cache = & JFactory::getCache('com_mymuse');
		$cache->clean();
		
		// update the price
	    // see if there is an old price
	    $query = "SELECT * FROM #__mymuse_product_price WHERE product_id=".$row->id;
	    $this->_db->setQuery($query);
	    $price_array = $this->_db->loadAssoc();
	     
	    $price =& $this->getTable('price');

		//$price =& new JTablePrice($db);
		if(is_array($price_array)){
			$price->bind($price_array);
		}
		// sanitise id field
		$price->id = (int) $price->id;
		if(!$price->id){
			$price->created = date('Y-m-d h:i:s');
		}
		if(!$price->shopper_group_id){
			$price->shopper_group_id = 1;
		}
		$price->modified = date('Y-m-d h:i:s');
		$price->product_id = $row->id;
		$product_price = sprintf("%.2f",$product_price);
		$price->product_price = $product_price;

		if (!$price->store()) {
			JError::raiseError( 500, $db->stderr() );
			return false;
		}
		
		// Attributes
		if($type== "item"){
				
			$attribute_values		= JRequest::getVar( 'attribute_value', null, 'post', 'array' );
			$attribute_names		= JRequest::getVar( 'attribute_name', null, 'post', 'array' );
			//print_pre($attribute_values);
			//print_pre($attribute_names);

			$query = "DELETE FROM #__mymuse_product_attribute
			WHERE product_id='".$row->id."'";
			//echo $query;
			$this->_db->setQuery($query);
			$this->_db->query();

			while(list($key,$val) = each($attribute_values)){

				$query = "INSERT INTO #__mymuse_product_attribute
				(`product_id`,`product_attribute_sku_id`,`attribute_name`,`attribute_value`)
				VALUES 
				(".$row->id.",".$key.",'".$attribute_names[$key]."','".$val."')";
				$this->_db->setQuery($query);
				$this->_db->query();
				//echo $query;
			}
		}
		
        return true;
	}
	
	/**
	* Method to remove a product
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            // Check if it has children!
            foreach ($cid as $id){
            	$query = "SELECT title FROM #__mymuse_product WHERE parentid='$id'";
            	$this->_db->setQuery($query);
            	$row = $this->_db->loadObject();
            	if($row->title){
            		$this->setError(JText::_( 'MYMUSE PRODUCT HAS CHILDREN' ).$row->title );
            		return false;
            	}
            }

            // Let's get rid of associated entries

            // first the product_category_xref
            $cids = implode(',', $cid);
            $query = "DELETE FROM #__mymuse_product_category_xref WHERE"
            . " product_id IN (". $cids  .")";
            $this->_db->setQuery($query);
            if (!$this->_db->query())
            {
            	$this->setError($this->_db->getErrorMsg());
            	return false;
            }

            // then the product_content_xref
            $cids = implode(',', $cid);
            $query = "DELETE FROM #__mymuse_product_content_xref WHERE"
            . " product_id IN (". $cids  .")";
            $this->_db->setQuery($query);
            if (!$this->_db->query())
            {
            	$this->setError($this->_db->getErrorMsg());
            	return false;
            }

            // then the product_attribute
            $cids = implode(',', $cid);
            $query = "DELETE FROM #__mymuse_product_attribute WHERE"
            . " product_id IN (". $cids  .")";
            $this->_db->setQuery($query);
            if (!$this->_db->query())
            {
            	$this->setError($this->_db->getErrorMsg());
            	return false;
            }

            // then the product_price
            $cids = implode(',', $cid);
            $query = "DELETE FROM #__mymuse_product_price WHERE"
            . " product_id IN (". $cids  .")";
            $this->_db->setQuery($query);
            if (!$this->_db->query())
            {
            	$this->setError($this->_db->getErrorMsg());
            	return false;
            }
            
            
            // finally the product
            $query = 'DELETE FROM #__mymuse_product'
            . ' WHERE id IN ( '.$cids.' )';
            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
	
	/**
	* Method to (un)publish a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function publish($cid = array(), $state = 1)
	{
        $user =& JFactory::getUser();
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            $query = 'UPDATE #__mymuse_product'
            . ' SET state = '.(int) $state
            . ' WHERE id IN ( '.$cids.' )'
            . ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
            ;
            $this->_db->setQuery( $query );
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }
        return true;
	}
	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function move($direction)
	{

        $row =& $this->getTable();
        if (!$row->load($this->_id)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }


        if (!$row->move( $direction, ' state >= 0 ' )) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        return true;
	}
	
	/**
	* Method to save order of all
	*
	* @access public
	* @return boolean True on success
	
	*/
	function saveorder($cid = array(), $order)
	{

        $row =& $this->getTable();
        $groupings = array();
        // update ordering values
        for( $i=0; $i < count($cid); $i++ )
        {
            $row->load( (int) $cid[$i] );

            if ($row->ordering != $order[$i])
            {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }
        return true;
	}
	
	/**
	* Method to change access
	*
	* @access public
	* @return boolean True on success
	
	*/
	function accessMenu($id, $access)
	{

		$row =& $this->getTable();
		$row->load( $id );
		$row->access = $access;

		if ( !$row->check() ) {
			$this->setError($this->_db->getErrorMsg());
            return false;
		}
		if ( !$row->store() ) {
			$this->setError($this->_db->getErrorMsg());
            return false;
		}
		return true;
	}
	
	
	/**
	* Method to load content item data
	*
	* @access private
	* @return boolean True on success
	
	*/
	function _loadData()
	{
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
            $query = 'SELECT c.*'.
            ' FROM #__mumuse_product AS c' .
            ' WHERE c.id = '.(int) $this->_id;
            $this->_db->setQuery($query);
            $this->_data = $this->_db->loadObject();
            return (boolean) $this->_data;
        }
        return true;
    }
        
        
    /**
    * Method to initialise the item data
    *
    * @access private
    * @return boolean True on success
    
    */
    function _initData()
    {
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
        	global $nullDate;

        	$user =& JFactory::getUser();
            $uid = $user->get('id');
            $createdate =& JFactory::getDate();
            
            $item = new stdClass();

            $item->id                 		= null;
            $item->parentid		    		= null;
            $item->title              		= '';
            $item->alias              		= '';
            $item->title_alias              = '';
            
            $item->introtext             	= '';
            $item->fulltext              	= '';
            $item->state              		= 1;
            $item->sectionid              	= null;
            $item->artistid              	= null;
            $item->mask              		= null;
            $item->created              	= null;
            $item->created_by              	= $uid;
            $item->created_by_alias         = null;
            $item->modified              	= $uid;
            $item->modified_by              = null;
            $item->checked_out        		= 0;
            $item->checked_out_time   		= 0;
            $item->publish_up        		= $createdate->toUnix();
            $item->publish_down   			= JText::_('Never');
            $item->images        			= null;
            $item->image              		= "blank.png";
            $item->urls        				= null;
            $item->attribs        			= null;
            $item->version        			= null;
            $item->ordering           		= '';
            $item->metakey           		= '';
            $item->metadesc           		= '';
            $item->access             		= 0;
            $item->hits             		= 0;
            $item->metadata            		= '';
            $item->product_physical         = null;
            $item->product_downloadable     = null;
            $item->product_allfiles         = 0;
            $item->product_sku             	= '';
            $item->product_made_date         = null;
            $item->product_in_stock         = null;
            $item->product_special          = null;
            $item->product_discount         = null;
            $item->product_package_ordering = null;
            $item->product_package          = null;
            $item->file_length              = 0;
            $item->file_name             	= '';
            $item->file_preview             = '';
            $item->file_downloads           = 0;
            $item->product_price            = 0;
            
        	switch ($this->_task)
        	{
        		case 'additem'  :
        			{
					$item->introtext = "Item for product";
					$item->product_physical         = 1;
            		$item->product_downloadable     = 0;
        			} break;

        		case 'addfile'  :
        			{
					$item->introtext = "File for product";
					$item->product_physical         = 0;
            		$item->product_downloadable     = 1;
        			} break;
        			
        		case 'new_allfiles'  :
        			{
					$item->introtext = "All Files for product";
					$item->product_physical         = 0;
            		$item->product_downloadable     = 1;
            		$item->product_allfiles         = 1;
        			} break;
        	}
        	 
            $this->_data = $item;
            return (boolean) $this->_data;
        }
        return true;
	}
	

	/**
	 * ITEMS SECTION * ITEMS SECTION * ITEMS SECTION * ITEMS SECTION * ITEMS SECTION * ITEMS SECTION * ITEMS SECTION 
	 */

	/**
	 * Set item attributes
	 */
	function checkAttributes(){

		$pid	= JRequest::getVar( 'parentid', null, 'post', 'int' );
		if(!$pid){
			//see if we can get the parent from the item id
			if(isset($this->_id)){
				$query = "SELECT parentid from #__mymuse_product WHERE id=".$this->_id;
				$this->_db->setQuery($query);
				$pid = $this->_db->loadResult();
			}else{
				$this->setError(JText::_('MYMUSE COULD NOT FIND PARENT'));
            	return false;
			}
		}
		$query = "SELECT * FROM #__mymuse_product_attribute_sku
		WHERE product_parent_id = ".$pid;
		$this->_db->setQuery($query);
		$this->_attribute_skus = $this->_db->loadObjectList();

		if(count($this->_attribute_skus) < 1){
			$this->setError(JText::_('MYMUSE CREATE ATTRIBUTE FIRST'));
            return false;
		}
		
		return true;
	}
	
	function getAttributes(){
		if(!$this->_attribute_skus){
			$this->getAttributeskus();
		}
		foreach($this->_attribute_skus as $a_sku){
				$query = 'SELECT attribute_value from #__mymuse_product_attribute WHERE product_id='.$this->_id.'
				AND product_attribute_sku_id='.$a_sku->id;

				$this->_db->setQuery($query);
				$this->_data->attributes[$a_sku->name] = $this->_db->loadResult();
		}

		return $this->_data->attributes;

		
	}

	function getAttributeskus(){
		$pid	= JRequest::getVar( 'parentid', null, 'post', 'int' );
		if(!$pid){
			//see if we can get the parent from the item id
			if(isset($this->_id)){
				$query = "SELECT parentid from #__mymuse_product WHERE id=".$this->_id;
				$this->_db->setQuery($query);
				$pid = $this->_db->loadResult();
			}else{
				$this->setError(JText::_('MYMUSE COULD NOT FIND PARENT'));
            	return false;
			}
		}
		$query = 'SELECT * from #__mymuse_product_attribute_sku WHERE product_parent_id='.$pid;
		$this->_db->setQuery($query);
		$this->_attribute_skus = $this->_db->loadObjectList();
		 
		return $this->_attribute_skus;

	}
	
	/**
	 * Compiles information to add or edit the Item, a product with a parent
	 *
	 * @param boolean $edit True if is an existing Item, False if new
	 * @param string $type Type is either Item or File
	 * @global $mainframe
	 */
	function edititem($edit, $type)
	{
		global $mainframe;

		// Initialize variables
		$user			= & JFactory::getUser();
		$cid			= JRequest::getVar( 'cid', array(0), '', 'array' );
		JArrayHelper::toInteger($cid, array(0));

		$option			= JRequest::getCmd( 'option' );
		$nullDate		= $this->_db->getNullDate();
		$contentSection	= '';


		// Create and load the product table row
		$row = new JtableMyMuseProduct($this->_db);
		if($edit){
			$id				= JRequest::getVar( 'id', $cid[0], '', 'int' );
			$row->load($id);
			$query = "SELECT product_price FROM #__mymuse_product_price
			WHERE product_id = ".$id." ";
			$this->_db->setQuery($query);
			$row->product_price = $this->_db->loadResult();
			$parentid = $row->parentid;
			// is this the special 'allfiles'?
			if($row->product_allfiles == 1){
				$type = 'allfiles';
			}
		}else{
			// it is new, so the id of the parent product will be set
			$parentid = JRequest::getVar( 'parentid', 0, '', 'int' );

			$row->load($parentid);
			$row->version = 0;
			$row->parentid = $parentid;
			$row->title = '';
			$row->product_sku = '';
			$row->alias = '';
			$row->introtext = '';
			$row->fulltext = '';
			$row->id = null;
			$row->product_made_date = null;
			
			// is this a new_allfiles? see if one exists
			$query = "SELECT id from #__mymuse_product WHERE parentid='$parentid'
			AND product_allfiles ='1'";
			$this->_db->setQuery($query);
			$allfiles_id = $this->_db->loadResult();
			if($allfiles_id){
				$task       = JRequest::getCmd( 'task');
				if($task == 'new_allfiles'){
					$msg = JText::_('MYMUSE EDITING EXISTING ALLTRACKS');
					$mainframe->redirect('index.php?option=com_mymuse&module=product&task=edit_allfiles&cid[]='.$allfiles_id, $msg);
					
				}
			}
			
				
		}

		// get parent
		$parent = new JtableMyMuseProduct($this->_db);
		$parent->load($parentid);


		if($type == "item"){
			// get attributes
			$query = "SELECT * FROM #__mymuse_product_attribute_sku
			WHERE product_parent_id = ".$row->parentid." ORDER BY ordering";
			$this->_db->setQuery($query);
			$attribute_skus = $this->_db->loadObjectList();

			if(count($attribute_skus) < 1){
				$msg = JText::_('Please create an attribute first');
				$mainframe->redirect('index.php?option=com_mymuse&module=product&task=edit&cid[]='.$row->parentid, $msg);
			}

			$query = 'SELECT * from #__mymuse_product_attribute WHERE product_id='.$row->id;
			$this->_db->setQuery($query);
			$attributes = $this->_db->loadObjectList();
			$row->product_downloadable = 0;
			$row->product_physical = 1;
		}elseif($type == "file"){
			$row->product_downloadable = 1;
			$row->product_physical = 0;
		}elseif($type == "allfiles"){
			$row->product_downloadable = 1;
			$row->product_physical = 0;
			$row->product_allfiles = 1;
		}

		/*
		 * If the item is checked out we cannot edit it... unless it was checked
		 * out by the current user.
		 */
		if ( JTable::isCheckedOut($user->get ('id'), $row->checked_out ))
		{
			$msg = JText::sprintf('MYMUSE DESCBEINGEDITTED', JText::_('MYMUSE THE ITEM'), $row->title);
			$mainframe->redirect('index.php?option=com_mymuse', $msg);
		}

		if ($id)
		{
			$row->checkout($user->get('id'));

			$query = 'SELECT name' .
					' FROM #__users'.
					' WHERE id = '. (int) $row->created_by;
			$this->_db->setQuery($query);
			$row->creator = $this->_db->loadResult();

			// test to reduce unneeded query
			if ($row->created_by == $row->modified_by) {
				$row->modifier = $row->creator;
			} else {
				$query = 'SELECT name' .
						' FROM #__users' .
						' WHERE id = '. (int) $row->modified_by;
				$this->_db->setQuery($query);
				$row->modifier = $this->_db->loadResult();
			}

		}
		else
		{
			$row->catid = NULL;
			$createdate =& JFactory::getDate();
			$row->version = 0;
			$row->state = 1;
			$row->ordering = 0;
			$row->images = array ();
			$row->publish_up = $createdate->toUnix();
			$row->publish_down = JText::_('Never');
			$row->creator = '';
			$row->created = $createdate->toUnix();
			$row->modified = $nullDate;
			$row->modifier = '';
			$row->product_discount = '';
			$row->store();
		}
		$row->frontpage = 0;
		$active = (intval($row->created_by) ? intval($row->created_by) : $user->get('id'));
		$row->created_by = $active;

		if($type == "item"){
			ProductItemView::editItem($row, $option, $parent, $attribute_skus, $attributes);
		}elseif($type == "file"){
			ProductFileView::editFile($row, $option, $parent);
		}elseif($type == "allfiles"){
			ProductFileView::editAllFiles($row, $option, $parent);
		}
	}

	/**
	 * Saves the Item from an edit form submit
	 * 
	 * @global $mainframe
	 */
	function saveItem(&$data, $type="item")
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$user		= & JFactory::getUser();
		$dispatcher = & JDispatcher::getInstance();
		$option		= JRequest::getCmd( 'option' );
		$task		= JRequest::getCmd( 'task' );
		$nullDate	= $this->_db->getNullDate();

		$row =& $this->getTable('product');
		
		if ($row->id) {
			$row->load($id);
		}
		if (!$row->bind($data)) {
			JError::raiseError( 500, $this->_db->stderr() );
			return false;
		}
		// sanitise id field
		$row->id = (int) $row->id;
		
		// is this the special 'AllFiles'?
		if($row->product_allfiles == 1){
			$type = 'allfiles';
		}

		$isNew = true;
		// Are we saving from an item edit?
		if ($row->id) {
			$isNew = false;
			$datenow =& JFactory::getDate();
			$row->modified 		= $datenow->toMySQL();
			$row->modified_by 	= $user->get('id');
		}

		$row->created_by 	= $row->created_by ? $row->created_by : $user->get('id');

		if ($row->created && strlen(trim( $row->created )) <= 10) {
			$row->created 	.= ' 00:00:00';
		}

		$config =& JFactory::getConfig();
		$tzoffset = $config->getValue('config.offset');
		$date =& JFactory::getDate($row->created, $tzoffset);
		$row->created = $date->toMySQL();

		// Get a state and parameter variables from the request
		$row->state	= JRequest::getVar( 'state', 0, '', 'int' );
		$params		= JRequest::getVar( 'params', null, 'post', 'array' );

		// Build parameter INI string
		if (is_array($params))
		{
			$txt = array ();
			foreach ($params as $k => $v) {
				$txt[] = "$k=$v";
			}
			$row->attribs = implode("\n", $txt);
		}

		// Prepare the product for saving to the database
		MyMuseHelper::saveProductPrep( $row );

		// Increment the content version number
		$row->version++;

		//is this downloadable? Get the file size
		if($row->product_downloadable && $row->file_name){
			$row->file_length = filesize(DOWNLOAD_DIR . DS . $row->file_name);
		}

		// Store the product to the database
		if (!$row->store()) {
			JError::raiseError( 500, $this->_db->stderr() );
			return false;
		}

		// Checkin the product
		$row->checkin();

		$data['id'] = $row->id;

		// update the price
		$query = "SELECT id FROM #__mymuse_product_price WHERE product_id='".$row->id."'";
		$this->_db->setQuery($query);
		$price_id = $this->_db->loadResult();
	  
		require_once (JPATH_COMPONENT.DS.'tables'.DS.'price.php');
		$price = new TablePrice($this->_db);
		$price->bind($_POST,'id');
		$price->id = $price_id;
		// sanitise id field
		$price->id = (int) $price->id;
		if(!$price->id){
			$price->created = date('Y-m-d h:i:s');
		}
		if(!$price->shopper_group_id){
			$price->shopper_group_id = 1;
		}
		$price->modified = date('Y-m-d h:i:s');
		$price->product_id = $row->id;

		// Store the product to the database
		if (!$price->store()) {
			JError::raiseError( 500, $this->_db->stderr() );
			return false;
		}

		// Attributes
		if($type == "item"){
				
			$attribute_values		= JRequest::getVar( 'attribute_value', null, 'post', 'array' );
			$attribute_names		= JRequest::getVar( 'attribute_name', null, 'post', 'array' );

			$query = "DELETE FROM #__mymuse_product_attribute
			WHERE product_id='".$row->id."'";
			$this->_db->setQuery($query);
			$this->_db->query();

			while(list($key,$val) = each($attribute_values)){

				$query = "INSERT INTO #__mymuse_product_attribute
				(`product_id`,`product_attribute_sku_id`,`attribute_name`,`attribute_value`)
				VALUES 
				(".$row->id.",".$key.",'".$attribute_names[$key]."','".$val."')";
				$this->_db->setQuery($query);
				$this->_db->query();

			}
		}
		return true;

	}

	/**
	 * Removes the Item from the database
	 * 
	 * @param string $type Type is an Item or a File
	 * @global $mainframe
	 */
	function removeItem($type="item")
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$this->_db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$option		= JRequest::getCmd( 'option' );
		$parentid		= JRequest::getCmd( 'parentid' );
		$nullDate	= $this->_db->getNullDate();

		JArrayHelper::toInteger($cid);

		if (count($cid) < 1) {
			$msg =  JText::_('MYMUSE SELECT AN ITEM TO DELETE');
			$mainframe->redirect('index.php?option='.$option, $msg, 'error');
		}

		// Removed product gets put in the trash [state = -2] and ordering is always set to 0
		$state		= '-2';
		$ordering	= '0';

		// Get the list of product id numbers to send to trash.
		$cids = implode(',', $cid);

		// Update articles in the database
		$query = 'DELETE FROM #__mymuse_product' .
				' WHERE id IN ( '. $cids. ' )';

		$this->_db->setQuery($query);
		if (!$this->_db->query())
		{
			JError::raiseError( 500, $this->_db->getErrorMsg() );
			return false;
		}

		$cache = & JFactory::getCache('com_mymuse');
		$cache->clean();

		if($type == "item"){
			$msg = JText::sprintf('MYMUSE ITEMS DELETED', count($cid));
			$mainframe->redirect('index.php?option=com_mymuse&module=product&task=edit&cid[]='.$parentid, $msg);
		}else{
			$msg = JText::sprintf('MYMUSE FILES DELETED', count($cid));
			$mainframe->redirect('index.php?option=com_mymuse&module=product&task=edit&cid[]='.$parentid, $msg);
				
		}
	}

	/**
	 * Cancels an Item edit operation
	 * 
	 * @global $mainframe
	 */
	function cancelItem()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$this->_db	= & JFactory::getDBO();

		// Check the article in if checked out
		$row = new JTableMyMuseProduct($this->_db);
		$row->bind(JRequest::get('post'));
		$row->checkin();
		$parentid		= JRequest::getCmd( 'parentid' );
		
		$mainframe->redirect('index.php?option=com_mymuse&module=product&task=edit&cid[]='.$parentid);
	}

	/**
	 * Moves the order of a record
	 * 
	 * @param integer $direction The increment to reorder by
	 * @global $mainframe
	 */
	function orderItem($direction)
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$this->_db		= & JFactory::getDBO();

		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		if (isset( $cid[0] ))
		{
			$row = new JTableMyMuseProduct($this->_db);
			$row->load( (int) $cid[0] );
			$row->move($direction, 'catid = ' . (int) $row->catid . ' AND state >= 0' );

			$cache = & JFactory::getCache('com_mymuse');
			$cache->clean();
		}

		$mainframe->redirect('index.php?option=com_mymuse&module=product');
	}

	/**
	 * Save an Order Item
	 * 
	 * @global $mainframe
	 */
	function saveItemOrder()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$this->_db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$redirect	= JRequest::getVar( 'redirect', 0, 'post', 'int' );
		$rettask	= JRequest::getVar( 'returntask', '', 'post', 'cmd' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('product');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $this->_db->getErrorMsg() );
					return false;
				}
				// remember to updateOrder this group
				$condition = 'catid = '.(int) $row->catid.' AND state >= 0';
				$found = false;
				foreach ($conditions as $cond)
				if ($cond[1] == $condition) {
					$found = true;
					break;
				}
				if (!$found)
				$conditions[] = array ($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}

		$cache = & JFactory::getCache('com_mymuse');
		$cache->clean();

		$msg = JText::_('MYMUSE NEW ORDERING SAVED');
		switch ($rettask)
		{
			case 'showarchive' :
				$mainframe->redirect('index.php?option=com_mymuse&task=showarchive&sectionid='.$redirect, $msg);
				break;

			default :
				$mainframe->redirect('index.php?option=mymuse&module=product', $msg);
				break;
		}
	}

	/**
	 * Changes the state of one or more product items
	 *
	 * @param integer $state The state 0 for unpublished 1 for published
	 * @global $mainframe
	 */
	function changeItem( $state = 0 )
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$this->_db		= & JFactory::getDBO();
		$user	= & JFactory::getUser();

		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$option	= JRequest::getCmd( 'option' );
		$task	= JRequest::getCmd( 'task' );
		$rtask	= JRequest::getCmd( 'returntask', '', 'post' );
		if ($rtask) {
			$rtask = '&task='.$rtask;
		}

		if (count($cid) < 1) {
			$redirect	= JRequest::getVar( 'redirect', '', 'post', 'int' );
			$action		= ($state == 1) ? 'publish' : ($state == -1 ? 'archive' : 'unpublish');
			$msg		= JText::_('MYMUSE SELECT AN ITEM TO') . ' ' . JText::_($action);
			$mainframe->redirect('index.php?option='.$option.$rtask.'&sectionid='.$redirect, $msg, 'error');
		}

		// Get some variables for the query
		$uid	= $user->get('id');
		$total	= count($cid);
		$cids	= implode(',', $cid);

		$query = 'UPDATE #__mymuse_product' .
				' SET state = '. (int) $state .
				' WHERE id IN ( '. $cids .' ) AND ( checked_out = 0 OR (checked_out = '. (int) $uid .' ) )';
		$this->_db->setQuery($query);
		if (!$this->_db->query()) {
			JError::raiseError( 500, $this->_db->getErrorMsg() );
			return false;
		}

		if (count($cid) == 1) {
			$row = new JTableMyMuseProduct($this->_db);
			$row->checkin($cid[0]);
		}

		switch ($state)
		{

			case 1 :
				$msg = JText::sprintf('MYMUSE ITEMS PUBLISHED', $total);
				break;

			case 0 :
			default :

				$msg = JText::sprintf('MYMUSE ITEMS UNPUBLISHED', $total);

				break;
		}

		$cache = & JFactory::getCache('com_mymuse');
		$cache->clean();

		// Get some return/redirect information from the request
		$redirect	= JRequest::getVar( 'redirect', $row->sectionid, 'post', 'int' );

		$mainframe->redirect('index.php?option='.$option.$rtask.'&module=product', $msg);
	}

	


}
?>