<?php
/**
 * @version		$Id: reports.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class myMuseModelReports extends Jmodel
{
	function __construct(){
		parent::__construct();

		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}

	}

	/**
     * Store id
     *
     * int
     */
     var $_id = null;
     
	/**
     * Store task
     *
     * string
     */
     var $_task = null;
     
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
  
 	/**
  	* stores total
  	*
  	* @var integer
  	*/
  	var $_total = null;
  	
  	/**
  	* stores shopper
  	*
  	* @var object
  	*/
  	var $_shopper = null;
     
    /**
     * Method to set the store identifier
     *
     * @access    public
     * @param    int Store identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id      = $id;
    	$this->_data    = null;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	// Get the WHERE and ORDER BY clauses for the query
  		$where = $this->_buildContentWhere();
  		$orderby = $this->_buildContentOrderBy();
        $query = 'SELECT c.*, u.first_name, u.last_name '
		. ' FROM #__mymuse_order AS c'
		. ' LEFT JOIN #__mymuse_shopper as u ON c.shopper_id = u.id'
            . $where
            . $orderby;
            
        return $query;
    }
 
    function _buildContentOrderBy()
    {
    	global $mainframe, $option;
    	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.id', 'cmd' );

        $good_sort = array('u.last_name','c.order_subtotal','c.created','c.order_status','c.id');
		if(!in_array($filter_order,$good_sort)){
			$filter_order = 'c.id';
		}
    	$filter_order_Dir = $mainframe->getUserStateFromRequest( 'filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );
    	if($filter_order_Dir == ""){
			$filter_order_Dir = "desc";
		}
    	
    	if($filter_order != '') {
    		$orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.'  ';
    	}
    	return $orderby;
    }

    function _buildContentWhere()
    {
    	global $mainframe, $option;
    	
    	$filter_state 			= $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
     	$search 				= $mainframe->getUserStateFromRequest( $option.'search', 'search', '', 'string' );
    	$search 				= JString::strtolower( $search );
    	$filter_order_status	= JRequest::getVar( 'filter_order_status','',		'POST',		'word' );
    	$params			   		= JRequest::getVar( 'params', 'params','', 'array' );
    	$filter_date_start 		= isset($params['filter_date_start'])?$params['filter_date_start'] : '' ;
		$filter_date_end   		= isset($params['filter_date_end'])? $params['filter_date_end'] : '';
		$artistid				= $mainframe->getUserStateFromRequest( $option.'artistid','artistid','','int' );
		
		$datenow =& JFactory::getDate();
		$now = $datenow->toFormat("%Y-%m-%d");
		if($filter_date_start == $now && $filter_date_end == $now ){
			$filter_date_start = '';
			$filter_date_end = '';
		}
		
    	$where = array();
		if($filter_date_start){
			$where[] = "c.created >= '$filter_date_start 00:00:00'";
		}
		if($filter_date_end){
			$where[] = "c.created <= '$filter_date_end 00:00:00'";
		}
		if ( $filter_order_status ) {
			$where[] = "c.order_status = '$filter_order_status'";
		}
		if ($search) {
			$where[] = '( LOWER(u.last_name) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false )
			.' OR LOWER(u.first_name) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
		}

		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );

    	return $where;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryOne()
    {
        $query = 'SELECT *'
		. ' FROM #__mymuse_order  '
		. ' WHERE id='.$this->_id;
        return $query;
    }
     
    /**
     * Retrieves the store data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {

        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	$query = $this->_buildQueryAll();
            $this->_data = $this->_getList( $query,  $this->getState('limitstart'),$this->getState('limit') );
        }
 
        return $this->_data;
    }
    /**
  	* Method to get the total number of mymuse order items
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the content if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();
  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  
  	/**
  	* Method to get summary of orders for a period, status, shopper
  	*
  	* @access public
  	* @return object
  	*/
  	function getOrderSummary()
  	{ 	
  	    // Get the WHERE clauses for the query
  		$where = $this->_buildContentWhere();
  		
  		// query by shopper
  		$q_by_s = "SELECT SUM(c.order_subtotal) as total_subtotal, 
		SUM(c.order_shipping) as total_shipping, u.first_name, u.last_name
  		FROM jos_mymuse_order AS c LEFT JOIN jos_mymuse_shopper as u ON c.shopper_id = u.id "
  		. $where 
  		. " GROUP BY shopper_id";
  		
  		$q = "SELECT * FROM #__mymuse_tax_rate ORDER BY ordering";
        $this->_db->setQuery($q);
        $tax_rates = $this->_db->loadObjectList();
        $tax_array = array();
  		
        $query = 'SELECT SUM(c.order_subtotal) as total_subtotal, 
		SUM(c.order_shipping) as total_shipping, 
		SUM(c.discount) as total_discount ,
		SUM(c.coupon_discount) as total_coupon_discount, 
		SUM(c.reservation_fee) as total_reservation_fee
		';
        foreach($tax_rates as $rate){
        	$name = trim($rate->tax_name);
        	$name = preg_replace("/['-\/\s\\\]/","_",$name);
        	$query .= ", SUM(c.$name) as $name ";
        	$tax_array[] = $name;
        }
        
        
		$query .= ' FROM #__mymuse_order AS c'
        . $where;
            
        $this->_db->setQuery( $query );
        $res = $this->_db->loadObject();
        $res->tax_array = $tax_array;
        
        //echo "$query <br />";
        //print_pre($res);
        return $res;
  	
  	}
  	
  	
  	/**
  	* Method to get summary of order items for a period, status, shopper
  	*
  	* @access public
  	* @return object
  	*/
  	function getItemsSummary()
  	{ 	
  		global $mainframe,$option;
  		
  		$artistid				= $mainframe->getUserStateFromRequest( $option.'artistid','artistid','0','int' );
  		
  		$order_ids = "(";
  		foreach($this->_data as $order){
  		    $order_ids .= $order->id.",";
  		}
  		$order_ids = preg_replace("/,$/","",$order_ids);
  		$order_ids .= ")";
  		
  		$query = "SELECT sum(product_quantity) as quantity, sum(product_quantity * product_item_price) 
  		as total, i.product_name, a.title as artist_name, p.id as product_id
  		FROM #__mymuse_order_item as i
  		LEFT JOIN #__mymuse_product as p ON i.product_id=p.id
  		LEFT JOIN #__mymuse_categories as a ON p.artistid=a.id 
  		WHERE i.order_id IN $order_ids 
  		";
  		
  		if($artistid){
  			$query .= "AND a.id=$artistid ";
  		}
  		
  		$query .= "GROUP BY product_name ORDER BY total DESC";
  		//echo "$query <br />";
  		$this->_db->setQuery( $query );
        $res = $this->_db->loadObjectList();
        
        for($i=0;$i<count($res);$i++){
        	if($res[$i]->artist_name == ""){
        		$query = "SELECT a.title as artist_name FROM #__mymuse_categories as a, #__mymuse_product as p 
					LEFT JOIN #__mymuse_product as p2 ON p2.id=p.parentid
					WHERE  p.id='".$res[$i]->product_id."' AND p2.artistid=a.id"; 
        		$this->_db->setQuery( $query );
        		$res[$i]->artist_name = $this->_db->loadResult();
        		
        		
        	}
        }
        
  		//print_pre($res);
        return $res;;
  	}
  	
  	
    /**
  	* Method to get the shopper and possible shiptto entries
  	*
  	* @access public
  	* @return object
  	*/
  	function getShopper()
  	{
  		// Lets load the shopper if it does not exist
  		if (empty($this->_shopper) && isset($this->_data[0]->id))
  		{
  			$query = "SELECT s.*,u.email FROM #__mymuse_shopper as s  
  				LEFT JOIN #__users as u ON u.id=s.user_id
  				WHERE s.id=".$this->_data[0]->shopper_id;
  			$this->_db->setQuery( $query );
  			$this->_shopper = $this->_db->loadObject();
  			
  			if($this->_data[0]->ship_info_id && ($this->_data[0]->ship_info_id != $this->_data[0]->shopper_id)){
  				$query = "SELECT s.*,u.email FROM #__mymuse_shopper as s  
  					LEFT JOIN #__users as u ON u.id=s.user_id
  					WHERE s.id=".$this->_data[0]->ship_info_id;
  				$this->_db->setQuery( $query );
  				$this->_shopper->shipto = $this->_db->loadObject();
  			}
  		}
 		return $this->_shopper;
  	}
  	
    /**
  	* Method to get the order items
  	*
  	* @access public
  	* @return objects
  	*/
  	function getItems()
  	{
  		// Lets load the items if they do not exist
  		if (empty($this->_data[0]->items))
  		{
  			$query = "SELECT * FROM #__mymuse_order_item 
  				WHERE order_id=".$this->_id;
  			$this->_db->setQuery( $query );
  			$this->_data[0]->items = $this->_db->loadObjectList();
  			$this->_data[0]->order_total = 0.00;
  		  	for($i = 0; $i < count($this->_data[0]->items); $i++){

				$this->_data[0]->items[$i]->subtotal = sprintf("%.2f", $this->_data[0]->items[$i]->product_item_price * $this->_data[0]->items[$i]->product_quantity);
				$this->_data[0]->order_total += $this->_data[0]->items[$i]->subtotal;
  			}
  			
  		}
  		$this->_data[0]->order_total = sprintf("%.2f", $this->_data[0]->order_total);
 		return $this->_data[0]->items;
  	}
  	


    /**
     * Method to get a pagination object for orders
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
  
    /**
     * Method to set the store lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $params;
    	
    	$filter_order_status	= JRequest::getVar( 'filter_order_status','',		'POST',		'word' );
		$rows =& $this->_data;
    	// order_status filter
		$count = count( $this->_data );
		$query = "SELECT * from #__mymuse_order_status";

		$order_status[] = JHTML::_('select.option', '0', '- '.JText::_('MYMUSE SELECT STATUS').' -', 'code', 'name');
		$this->_db->setQuery($query);
		$order_status = array_merge($order_status, $this->_db->loadObjectList());

		if($count == 1){
			$this->_data[0]->order_status_form = JHTML::_('select.genericlist',  $order_status, 'order_status', 'class="inputbox" size="1"', 'code', 'name', $this->_data[0]->order_status);
		}
		for($i=0;$i<$count;$i++){
			$this->_data[$i]->order_status = MyMuseHelper::printOrderStatus($this->_data[$i]->order_status);
		}
		
		$lists['order_status'] = JHTML::_('select.genericlist',  $order_status, 'filter_order_status', 
		'class="inputbox" size="1"', 'code', 'name', $filter_order_status);

		
    	// artists
    	$my_section_artists = $params->get('my_section_artists');
    	$chosen_artist	= JRequest::getVar( 'artistid','','POST','int' );
    	
		$query = 'SELECT id, title, section' .
			' FROM #__mymuse_categories' .
			' WHERE section ='.$my_section_artists.
			' ORDER BY ordering';

		$this->_db->setQuery($query);
		$res = $this->_db->loadObjectList();
		
		$artist[] = JHTML::_('select.option', '0', JText::_( 'MYMUSE SELECT ARTIST' ), 'id', 'title');;
		for($i=0;$i<count($res);$i++){
			$artist[] = $res[$i];
		}
		$lists['artistid'] = JHTML::_('select.genericlist',  $artist, 'artistid', 'class="inputbox"', 'id', 'title', $chosen_artist);
		
		return $lists;
    }
 



}
?>
