<?php
/**
 * @version		$Id: shipping.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class myMuseModelShipping extends Jmodel
{
	function __construct()
	{
		parent::__construct();
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}
		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		global $mainframe, $option;
 		// Get the pagination request variables
  		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
 		$this->setState('limit', $limit);
  		$this->setState('limitstart', $limitstart);
	}
	
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
     /**
     * Store data total
     *
     * @$item->array
     */
     var $_total = null;
     
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
     
     /**
  	 * task string
	 *
	 * @string
	 */
     var $_task = null;


    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	// Get the WHERE and ORDER BY clauses for the query
  		$where = $this->_buildContentWhere();
  		$orderby = $this->_buildContentOrderBy();
        $query = ' SELECT * '
            . ' FROM #__mymuse_shipping as c  ';
            
        $query.= $where;
		$query.= $orderby;
        return $query;
    }
 
	function _buildContentOrderBy()
    {
    	global $mainframe;
    	$filter_order 		= $mainframe->getUserStateFromRequest( 'filter_order', 'filter_order', 'c.state desc, c.ordering', 'cmd' );
    	$filter_order_Dir 	= $mainframe->getUserStateFromRequest( 'filter_order_Dir', 'filter_order_Dir', 'desc', 'word' );
    	$good_sort = array('c.ship_carrier_name','c.ship_method_name','c.ship_handling_charge','c.ship_handling_additional','c.state','c.ordering','c.id');
		if(!in_array($filter_order,$good_sort)){
			$filter_order = 'c.state desc, c.ordering';
		}
    	$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .'';
    	return $orderby;
    }
    
    function _buildContentWhere()
    {
    	global $mainframe;

    	$search 		= $mainframe->getUserStateFromRequest( 'search', 'search', '', 'string' );
    	$search 		= JString::strtolower( $search );
    	
    	$where = array();

		
		if ( !empty($search) ) {
			$search = $this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
			$q = " (c.ship_carrier_name LIKE $search OR ";
			$q .= "c.ship_carrier_code LIKE $search OR ";
			$q .= "c.ship_method_name LIKE $search OR ";
			$q .= "c.ship_method_code LIKE $search ";
			$q .= ") ";
			$where[] = $q;
		}



    	$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
    	return $where;
    }
    
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryOne()
    {
        $query = ' SELECT * '
            . ' FROM #__mymuse_shipping as c WHERE id ='
            .$this->_id;
        return $query;
    }
     
    /**
     * Retrieves the store data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {
    	        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	
        	if($this->_task == "" || $this->_task == "default")
        	{	
        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query, $this->getState('limitstart'),$this->getState('limit'));
            	$this->_total = $this->_getListCount($query);
        	}
        	else
        	{
        		if(isset($this->_id))
        		{
					$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObject();
        		}
        		else
        		{
        			$this->_initData();
        		}
        	}
        }
 
        return $this->_data;
    }
    
    /**
     * Method to set the store identifier
     *
     * @access    public
     * @param    int Store identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data    = null;
    }

    
    /**
     * Method to set the store lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $mainframe;
    	
    	$task 	= JRequest::getVar('task', null, 'default', 'cmd');
    	$edit 	= JRequest::getVar('edit', null);
    	$lists = array();
    	
    	//state
    	if($edit){
    		$state = $this->_data->state;
    		$lists['state'] = JHTML::_('select.booleanlist', 'state', '', $state);
    	}	

    	
		return $lists;
    }
    
    /**
  	* Method to get the total number of mymuse_shipping s
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the content if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();

  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  	
    /**
     * Method to get a pagination object for categories
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
    
	/**
	* Tests if item is checked out
	*
	* @access public
	* @param int A user id
	* @return boolean True if checked out
	
	*/
	function isCheckedOut( $uid=0 )
	{
        if ($this->_loadData())
        {
            if ($uid) {
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            } else {
                return $this->_data->checked_out;
            }
        }
	}
	/**
	* Method to checkin/unlock the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function checkin()
	{
	   if ($this->_id)
	   {
	       $item = & $this->getTable();
	       if(! $item->checkin($this->_id)) {
	           $this->setError($this->_db->getErrorMsg());
	           return false;
	       }
	   }
	   return false;
	}
	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if (isset($this->_id))
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}
	
	/**
	* Method to store the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store(&$data)
	{
        $row =& $this->getTable();
        $user=& JFactory::getUser();
        // Bind the form fields to the item table
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        // if new item, order last in appropriate group
        if (!$row->id) {
            $row->ordering = $row->getNextOrder( 'id' );
        }
        $isNew = true;
        // Are we saving from an item edit?
        if ($row->id) {
            $isNew = false;

        }

 
            
        // Make sure the item table is valid
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        // Store the item table to the database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        $data['id'] = $row->id;
        return true;
	}
	
	/**
	* Method to remove a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            $query = 'DELETE FROM #__mymuse_shipping'
            . ' WHERE id IN ( '.$cids.' )';
            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
	

	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function move($direction)
	{
        $row =& $this->getTable();
        if (!$row->load($this->_id)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        if (!$row->move( $direction )) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        return true;
	}
	
	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function saveorder($cid = array(), $order)
	{
        $row =& $this->getTable();
        $groupings = array();
        // update ordering values
        for( $i=0; $i < count($cid); $i++ )
        {
            $row->load( (int) $cid[$i] );

            if ($row->ordering != $order[$i])
            {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }
        return true;
	}

	    /**
    * Method to initialise the item data
    *
    * @access private
    * @return boolean True on success
    
    */
    function _initData()
    {
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
        	$item = new stdClass();
            $item->id               		= null;
			$item->ship_carrier_code		= null;
			$item->ship_carrier_name		= null;
			$item->ship_method_code			= null;
			$item->ship_method_name			= null;
			$item->state					= null;
			$item->ordering					= null;
			$item->ship_handling_charge		= null;
			$item->ship_handling_additional	= null;
			$item->packaging_code			= null;
			$item->packaging_code_name		= null;
			$item->ordering					= null;
                    
        }
        $this->_data = $item;
        return true;

    }
        


}
	