<?php
/**
 * @version		$Id: shopper.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );
jimport( 'joomla.html.parameter');

class myMuseModelShopper extends Jmodel
{
	function __construct()
	{
		parent::__construct();

		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}

		global $mainframe, $option;
 		// Get the pagination request variables
  		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
 		$this->setState('limit', $limit);
  		$this->setState('limitstart', $limitstart);
	}
	/**
     * Store task
     *
     * string
     */
     var $_task = null;
     
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
  
 	/**
  	* stores total
  	*
  	* @var integer
  	*/
  	var $_total = null;
     
	/**
	 * Description
	 * @var string
	 */
	var $params			= null;

	/**
	 * User parameters
	 * @var object
	 */
	var $_params 	= null;
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	// Get the WHERE and ORDER BY clauses for the query
  		$where = $this->_buildContentWhere();
  		$orderby = $this->_buildContentOrderBy();
  		
		// Get the shoppers
		$query  = "SELECT c.*,s.id as shopper_id,s.perms, x.session_id 
		FROM #__mymuse_shopper AS s, #__users AS c 
		 LEFT JOIN #__session AS x ON x.userid = c.id ";

		$query  .= $where;
		$query  .= $orderby;

        return $query;
    }
 
    function _buildContentOrderBy()
    {
    	global $mainframe;
    	$filter_order 		= $mainframe->getUserStateFromRequest( 'filter_order', 'filter_order', 's.id', 'cmd' );
    	$filter_order_Dir 	= $mainframe->getUserStateFromRequest( 'filter_order_Dir', 'filter_order_Dir', 'ASC', 'word' );
    	$good_sort = array('c.name','c.username','s.perms','c.email','c.lastvisitDate','c.id');
		if(!in_array($filter_order,$good_sort)){
			$filter_order = 's.id';
		}
    	$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .'';
    	return $orderby;
    }

    function _buildContentWhere()
    {
    	global $mainframe, $option;


 		$filter_type 	= $mainframe->getUserStateFromRequest( $option.'filter_type', 'filter_type', '', 'int' );
    	$filter_logged 	= $mainframe->getUserStateFromRequest( $option.'filter_logged', 'filter_logged', '', 'int' );
   
    	$search 		= $mainframe->getUserStateFromRequest( 'search', 'search', '', 'string' );
    	$search 		= JString::strtolower( $search );
    	
    	$where = array();
		$where[] = "c.id=s.user_id ";
		$where[] = "(s.address_type='BT' OR s.address_type IS NULL) ";
    	if ($filter_type) {
			$where[] = "s.shopper_group_id = '$filter_type' ";
		}
    	if ( $filter_logged == 1 )
		{
			$where[] = 'x.userid = c.id';
		}
		else if ($filter_logged == 2)
		{
			$where[] = 'x.userid IS NULL';
		}
    	

		
		if ( !empty($search) ) {
			$search = $this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
			$q = " (c.username LIKE $search OR ";
			$q .= "c.usertype LIKE $search OR ";
			$q .= "c.email LIKE $search OR ";
			$q .= "s.perms LIKE $search OR ";
			$q .= "s.company LIKE $search OR ";
			$q .= "s.last_name LIKE $search OR ";
			$q .= "s.first_name LIKE $search OR ";
			$q .= "CONCAT( `s`.`first_name`, ' ', `s`.`last_name`) LIKE $search OR ";
			$q .= "s.phone_1 LIKE $search ";
			$q .= ") ";
			$where[] = $q;
		}



    	$where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
    	return $where;
    }
    /**
     * Returns the query
     * @return string The query to be used to retrieve a row from the database
     */
    function _buildQueryOne()
    {

        	$query = ' SELECT * '
            . ' FROM #__mymuse_shopper WHERE id ='
            .$this->_id;

        return $query;
    }
     
    /**    			$model->setAttributes();
     * Retrieves the store data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {

        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	
        	if($this->_task == "" || $this->_task == "default")
        	{	
        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query, $this->getState('limitstart'),$this->getState('limit'));
				for($i=0;$i<count($this->_data);$i++){
					if(isset($this->_data[$i]->session_id)){
						$this->_data[$i]->loggedin = 1;
					}else{
						$this->_data[$i]->loggedin = 0;
					}
				}
        	
        	}
        	else
        	{
        		if(isset($this->_id))
        		{
        			$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObject();

        		}
        		else
        		{
        			$this->_initData();
        		}
        	}
        }
        return $this->_data;
    }
    /**
  	* Method to get the total number of mymuse_shopper items
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the total number of shoppers if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();
  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  
    /**
     * Method to set the shopper identifier
     *
     * @access    public
     * @param    int Product identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data    = null;
    }

    /**
     * Method to get the shopper orders
     *
     * @access    public
     * @param    int Product identifier
     * @return    void
     */
    function getOrders()
    {
    	$query = "SELECT * FROM #__mymuse_order WHERE user_id='". $this->_data->user_id  ."'";

		$this->_db->setQuery($query);
		$orders = $this->_db->loadObjectList();
		return $orders;
    }
    
    
    /**
     * Method to get a pagination object for shoppers
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
    
    	/**
	* Method to store the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store(&$data)
	{
		global $mainframe;
		
		$otherlanguage =& JFactory::getLanguage();
		$otherlanguage->load( 'com_users', JPATH_ADMINISTRATOR );
		
		$cid 		= JRequest::getVar('cid',  0, '', 'array');
		$data['id'] = $cid;
		$id 		= JRequest::getVar('id',  0, '', 'int');
		$me			= & JFactory::getUser();
		$acl		= & JFactory::getACL();
		$MailFrom	= $mainframe->getCfg('mailfrom');
		$FromName	= $mainframe->getCfg('fromname');
		$SiteName	= $mainframe->getCfg('sitename');
		
		// Create a new JUser object
		$user = new JUser($cid[0]);
		$original_gid = $user->get('gid');
		
		$post 	= JRequest::get('post');
		$post['username']	= JRequest::getVar('username', '', 'post', 'username');
		$post['password']	= JRequest::getVar('password', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['password2']	= JRequest::getVar('password2', '', 'post', 'string', JREQUEST_ALLOWRAW);

		if (!$user->bind($post))
		{	
			$mainframe->enqueueMessage(JText::_('CANNOT BIND THE USER INFORMATION'), 'message');
			$mainframe->enqueueMessage($user->getError(), 'error');
			$mainframe->redirect( 'index.php?option=com_mymuse&controller=shopper', $user->getError() );
			return false;

		}

		$objectID 	= $acl->get_object_id( 'users', $user->get('id'), 'ARO' );
		$groups 	= $acl->get_object_groups( $objectID, 'ARO' );
		$this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );


		if ( $user->get('id') == $me->get( 'id' ) && $user->get('block') == 1 )
		{
			$msg = JText::_( 'You cannot block Yourself!' );
			$mainframe->redirect( 'index.php?option=com_mymuse&controller=shopper', $msg );
		}
		else if ( ( $this_group == 'super administrator' ) && $user->get('block') == 1 ) {
			$msg = JText::_( 'You cannot block a Super Administrator' );
			$mainframe->redirect( 'index.php?option=com_mymuse&controller=shopper', $msg );
		}
		else if ( ( $this_group == 'administrator' ) && ( $me->get( 'gid' ) == 24 ) && $user->get('block') == 1 )
		{
			$msg = JText::_( 'WARNBLOCK' );
			$mainframe->redirect( 'index.php?option=com_mymuse&controller=shopper', $msg );
		}
		else if ( ( $this_group == 'super administrator' ) && ( $me->get( 'gid' ) != 25 ) )
		{
			$msg = JText::_( 'You cannot edit a super administrator account' );
			$mainframe->redirect( 'index.php?option=com_mymuse&controller=shopper', $msg );
		}
		// Are we dealing with a new user which we need to create?
		$isNew 	= ($user->get('id') < 1);
		if (!$isNew)
		{
			// if group has been changed and where original group was a Super Admin
			if ( $user->get('gid') != $original_gid && $original_gid == 25 )
			{
				// count number of active super admins
				$query = 'SELECT COUNT( id )'
					. ' FROM #__users'
					. ' WHERE gid = 25'
					. ' AND block = 0'
				;
				$this->_db->setQuery( $query );
				$count = $this->_db->loadResult();

				if ( $count <= 1 )
				{
					// disallow change if only one Super Admin exists
					$this->setRedirect( 'index.php?option=com_mymuse&controller=shopper', JText::_('WARN_ONLY_SUPER') );
					return false;
				}
			}
		}

		/*
	 	 * Lets save the JUser object
	 	 */
		if (!$user->save())
		{	
			$msg = JText::_('MYMUSE ERROR SAVING THE USER INFORMATION'). $user->getError();
			$mainframe->redirect( 'index.php?option=com_mymuse&controller=shopper', $msg );
		}

		
		// MyMuse Shopper Info Section 
		$id  = JRequest::getVar( 'shopper_id', '' );
		
		$_POST['user_id'] = $user->get('id');
		$_POST['id'] = $id;
		$post 	= JRequest::get('post');

		$row =& $this->getTable();
		if (!$row->bind($post)) {
			$this->setError($row->getError());
            return false;
		}

		$now = date('Y-m-d h:i:s');
		if($id < 1){
			$row->created = $now;
		}
		$row->modified = $now;
		
		if (!$row->check()) {
			$this->setError($row->getError());
			
            return false;
		}
		
		
		if ( array_key_exists('params', $post) )
		{
			$params	= '';
			$this->_params->bind($array['params']);
			if ( is_array($array['params']) ) {
				$params	= $this->_params->toString();
			} else {
				$params = $array['params'];
			}

			$this->params = $params;
		}
		

		if (!$row->store()) {
			$this->setError($row->getError());
            return false;
		}
		$data['shopper_id'] = $row->id;
		return true;
		
	}

	/**
	* Method to remove a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );

            $query = 'DELETE FROM #__mymuse_shopper'
            . ' WHERE user_id IN ( '.$cids.' )';

            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
           $query = 'DELETE FROM #__users'
            . ' WHERE id IN ( '.$cids.' )';

            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
	


	/**
	* Method to load content item data
	*
	* @access private
	* @return boolean True on success
	
	*/
	function _loadData()
	{
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
            $query = 'SELECT c.*'.
            ' FROM #__mumuse_shopper AS c' .
            ' WHERE c.id = '.(int) $this->_id;
            $this->_db->setQuery($query);
            $this->_data = $this->_db->loadObject();
            return (boolean) $this->_data;
        }
        return true;
    }
    
  
	/**
	* Tests if item is checked out
	*
	* @access public
	* @param int A user id
	* @return boolean True if checked out
	
	*/
	function isCheckedOut( $uid=0 )
	{
        if ($this->_loadData())
        {
            if ($uid) {
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            } else {
                return $this->_data->checked_out;
            }
        }
	}
	/**
	* Method to checkin/unlock the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function checkin()
	{
	   if ($this->_id)
	   {
	       $item = & $this->getTable();
	       if(! $item->checkin($this->_id)) {
	           $this->setError($this->_db->getErrorMsg());
	           return false;
	       }
	   }
	   return false;
	}
	

	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if (isset($this->_id))
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}

	/**
    * Method to initialise the item data
    *
    * @access private
    * @return boolean True on success
    
    */
    function _initData()
    {
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
        	global $nullDate;

        	$user =& JFactory::getUser();
            $uid = $user->get('id');
            $createdate =& JFactory::getDate();
            
            $item = new stdClass();

            $item->id           		= null;
            $item->user_id				= null;
            $item->address_type			= 'BT';
            $item->address_type_name	= null;
            $item->shopper_group_id		= 1;
            $item->company				= null;
            $item->title				= null;
            $item->last_name			= null;
            $item->first_name			= null;
            $item->middle_name			= null;
            $item->phone_1				= null;
            $item->phone_2				= null;
            $item->fax					= null;
            $item->address_1			= null;
            $item->address_2			= null;
            $item->city					= null;
            $item->state				= null;
            $item->country				= null;
            $item->zip					= null;
            $item->terms_of_service		= 0;
            $item->comments				= null;
            $item->perms				= "shopper";
            $item->created				= $createdate->toMySql();
            $item->modified				= $createdate->toMySql();
            
           	$this->_data = $item;
            return (boolean) $this->_data;
        }
        return true;
    }
    
    /**
     * Method to set the store lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $mainframe,$option;
    	
    	if($this->_task != "" && $this->_task != "default"){
    		$query = "SELECT country FROM #__mymuse_store";
    		$this->_db->setQuery($query);
    		$store_country = $this->_db->loadResult();
    		$lists['country'] = array();
    		$lists['state'] = array();
    		$countrystates = myMuseHelper::listCountryState($lists,$this->_data->country, $this->_data->state, $store_country);
    		$lists['countrystates'] = $countrystates;
			if(isset($this->_id)){
    			$query = "SELECT * from #__mymuse_shopper WHERE user_id='".$this->_id."' AND address_type='ST'";
    			$this->_db->setQuery($query);

    			$lists['addresses'] = $this->_db->loadObjectList();
			}else{
				$lists['addresses'] = '';
			}
    	}
    	
    	$filter_type = $mainframe->getUserStateFromRequest( $option.'filter_type', 'filter_type', '', 'int' );
    	$filter_logged = $mainframe->getUserStateFromRequest( $option.'filter_logged', 'filter_logged', '', 'int' );
    					
		// get list of Groups for dropdown filter
		$query = 'SELECT id AS value, shopper_group_name AS text'
			. ' FROM #__mymuse_shopper_group'
		;
		$this->_db->setQuery( $query );
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_( 'MYMUSE SELECT SHOPPER GROUP' ) .' -' );
		foreach( $this->_db->loadObjectList() as $obj )
		{
			$types[] = JHTML::_('select.option',  $obj->value, JText::_( $obj->text ) );
		}
		$lists['type'] 	= JHTML::_('select.genericlist',   $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_type" );

		// get list of Log Status for dropdown filter
		$logged[] = JHTML::_('select.option',  0, '- '. JText::_( 'MYMUSE SELECT LOG STATUS' ) .' -');
		$logged[] = JHTML::_('select.option',  1, JText::_( 'Logged In' ) );
		$lists['logged'] = JHTML::_('select.genericlist',   $logged, 'filter_logged', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_logged" );
		
		return $lists;
    }
}
?>