<?php
/**
 * @version		$Id: taxrate.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class MyMuseModelTaxRate extends Jmodel
{
	function __construct()
	{
		parent::__construct();
		$array = JRequest::getVar('cid',  0, '', 'array');
		if($array[0]){
    		$this->setId((int)$array[0]);
		}
		$this->_task = JRequest::getVar('task', null, 'default', 'cmd');
		
		global $mainframe, $option;
 		// Get the pagination request variables
  		$limit = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
  		$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
 		$this->setState('limit', $limit);
  		$this->setState('limitstart', $limitstart);
	}
	
	/**
     * Store data id
     *
     * @int
     */
     var $_id= null;
     
    /**
     * Store data array
     *
     * @$item->array
     */
     var $_data = null;
 
     /**
     * Store data total
     *
     * @$item->array
     */
     var $_total = null;
     
    /**
     * Store lists array
     *
     * @array
     */
     var $_lists = array();
    
 	/**
  	 * Pagination object
	 *
	 * @$item->object
	 */
     var $_pagination = null;
     
     /**
  	 * task string
	 *
	 * @string
	 */
     var $_task = null;
  
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryAll()
    {
    	global $mainframe, $option;
    	
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'm.position',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

        $good_sort = array('c.tax_name','c.country','c.ordering','state','tax_applies_to','tax_rate','c.id');
		if(!in_array($filter_order,$good_sort)){
			$filter_order = 'c.ordering';
		}
		
		$where[] = '1 ';

		// used by filter
		if ( $search ) {
			$where[] = 'LOWER( c.tax_name ) LIKE '.$this->_db->Quote( '%'.$this->_db->getEscaped( $search, true ).'%', false );
		}


		$where 		= ' WHERE ' . implode( ' AND ', $where );
		$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', c.ordering ASC';

		
        $query = ' SELECT c.* '
            . ' FROM #__mymuse_tax_rate as c '
            . $where
            . $orderby ;
        
        return $query;
    }
 
    /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
    function _buildQueryOne()
    {
        $query = ' SELECT c.* '
            . ' FROM #__mymuse_tax_rate as c WHERE id ='
            .$this->_id;
        return $query;
    }
     
    /**
     * Retrieves the taxrate data
     * @return mixed Array of objects or one object containing the data from the database
     */
    function getData()
    {
    	        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
        	
        	if($this->_task == "" || $this->_task == "default")
        	{	
        		$query = $this->_buildQueryAll();
            	$this->_data = $this->_getList( $query,  $this->getState('limitstart'),$this->getState('limit') );
            	$this->_total = $this->_getListCount($query);
        	}
        	else
        	{
        		if($this->_id)
        		{
					$query = $this->_buildQueryOne();
        			$this->_db->setQuery( $query );
            		$this->_data = $this->_db->loadObject();
        		}
        		else
        		{
        			$this->_initData();
        		}
        	}
        }
        return $this->_data;
    }
    
    /**
     * Method to set the store identifier
     *
     * @access    public
     * @param    int Store identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data      = null;
    }

    
    /**
     * Method to set the store lists
     *
     * @access    public
     * @return    array
     */
    function getLists()
    {
    	global $mainframe,$option;
    	
    	$lists = array();
    	// build the html select list for ordering
		$query = 'SELECT ordering AS value, tax_name AS text'
		. ' FROM #__mymuse_tax_rate'
		. ' ORDER BY ordering'
		;
		
		$edit = JRequest::getVar('edit',0);

		if($edit){
			$lists['ordering'] 			= JHTML::_('list.specificordering',  $this->_data, $this->_data->id, $query );
			$query = "SELECT country FROM #__mymuse_store";
			$this->_db->setQuery($query);
			$store_country = $this->_db->loadResult();
			$lists['country'] = array();
			$lists['state'] = array();
			$lists['countrystates'] = myMuseHelper::listCountryState($lists,$this->_data->country, $this->_data->state, $store_country);


			$applies[] = JHTML::_('select.option', '0', '- '.JText::_('Select Country or State').' -', 'value', 'name');
			$applies[] = JHTML::_('select.option', 'C', '- '.JText::_('Country').' -', 'value', 'name');
			$applies[] = JHTML::_('select.option', 'S', '- '.JText::_('State').' -', 'value', 'name');

			$lists['tax_applies_to'] = JHTML::_('select.genericlist',  $applies, 'tax_applies_to', 'class="inputbox" size="1" title="'.JText::_( 'MYMUSE_TAXAPPLIESTO' ).'"', 'value', 'name', $this->_data->tax_applies_to);

			$compounded[] = JHTML::_('select.option', '0', '- '.JText::_('No').' -', 'value', 'name');
			$compounded[] = JHTML::_('select.option', '1', '- '.JText::_('Yes').' -', 'value', 'name');

			$lists['compounded'] = JHTML::_('select.genericlist',  $compounded, 'compounded',
			'class="inputbox" size="1" title="'.JText::_( 'MYMUSE_TAXCOMPOUND' ).'"', 'value', 'name', $this->_data->compounded);


		}else{
			//$lists['ordering'] 			= JHTML::_('list.specificordering',  $this->_data, '', $query );
		}
		
		return $lists;
    }
    
    /**
  	* Method to get the total number of mymuse_tax_rate s
  	*
  	* @access public
  	* @return integer
  	*/
  	function getTotal()
  	{
  		// Lets load the content if it doesn't already exist
  		if (empty($this->_total))
  		{
  			$query = $this->_buildQueryAll();

  			$this->_total = $this->_getListCount($query);
  		}
 		return $this->_total;
  	}
  	
    /**
     * Method to get a pagination object for categories
     *
     * @access public
     * @return object
     */
    function getPagination()
    {
    	// Lets load the pagination if it doesn't already exist
    	if (empty($this->_pagination))
    	{
    		jimport('joomla.html.pagination');
    		$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
    	}
    	return $this->_pagination;
    }
    
	/**
	* Tests if item is checked out
	*
	* @access public
	* @param int A user id
	* @return boolean True if checked out
	
	*/
	function isCheckedOut( $uid=0 )
	{
        if ($this->_loadData())
        {
            if ($uid) {
                return ($this->_data->checked_out && $this->_data->checked_out != $uid);
            } else {
                return $this->_data->checked_out;
            }
        }
	}
	/**
	* Method to checkin/unlock the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function checkin()
	{
	   if ($this->_id)
	   {
	       $item = & $this->getTable();
	       if(! $item->checkin($this->_id)) {
	           $this->setError($this->_db->getErrorMsg());
	           return false;
	       }
	   }
	   return false;
	}
	
	/**
	* Method to checkout/lock the item
	*
	* @access public
	* @param int $uid User ID of the user checking the article out
	* @return boolean True on success
	
	*/
	function checkout($uid = null)
	{
	   if ($this->_id)
	   {
            // Make sure we have a user id to checkout the article with
            if (is_null($uid)) {
                $user =& JFactory::getUser();
                $uid = $user->get('id');
            }
            // Lets get to it and checkout the thing...
            $item = & $this->getTable();
            if(!$item->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
	   }
	   return false;
	}
	
	/**
	* Method to store the item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function store(&$data)
	{
        $row =& $this->getTable();
        $user=& JFactory::getUser();
        // Bind the form fields to the item table
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        // if new item, order last in appropriate group
        if (!$row->id) {
            $row->ordering = $row->getNextOrder( 'id' );
        }
        $isNew = true;
        // Are we saving from an item edit?
        if ($row->id) {
            $isNew = false;

        }

 
            
        // Make sure the item table is valid
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        // Store the item table to the database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        $data['id'] = $row->id;
        return true;
	}
	
	/**
	* Method to remove a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function delete($cid = array())
	{
        $result = false;
        if (count( $cid ))
        {
            JArrayHelper::toInteger($cid);
            $cids = implode( ',', $cid );
            $query = 'DELETE FROM #__mymuse_tax_rate'
            . ' WHERE id IN ( '.$cids.' )';
            $this->_db->setQuery( $query );
            if(!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
            	return false;
            }
        }
        return true;
	}
	

	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function move($direction)
	{
        $row =& $this->getTable();
        if (!$row->load($this->_id)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->move( $direction)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        return true;
	}
	
	/**
	* Method to move a item
	*
	* @access public
	* @return boolean True on success
	
	*/
	function saveorder($cid = array(), $order)
	{
        $row =& $this->getTable();
        $groupings = array();
        // update ordering values
        for( $i=0; $i < count($cid); $i++ )
        {
            $row->load( (int) $cid[$i] );

            if ($row->ordering != $order[$i])
            {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }
        return true;
	}

	    /**
    * Method to initialise the item data
    *
    * @access private
    * @return boolean True on success
    
    */
    function _initData()
    {
        // Lets load the item if it doesn't already exist
        if (empty($this->_data))
        {
        	$item = new stdClass();
            $item->id                = null;
			$item->state			= null;
			$item->country			= null;
			$item->tax_rate			= null;
			$item->tax_applies_to	= null;
			$item->tax_name			= null;
			$item->tax_format		= null;
			$item->compounded		= null;
			$item->ordering			= null;
                    
        }
        $this->_data = $item;
        return true;

    }
        


}
