<?php
/**
 * @version		$Id: attributesku.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');

/**
 * Store attributesku
 */
class TableAttributesku extends JTable
{
	/** @var int Primary key */
	var $id				= null;
	/** @var string */
	var $name			= null;
	/** @var int */
	var $product_parent_id		= null;
	/** @var int */
	var $ordering		= null;


	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_product_attribute_sku', 'id', $db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{
		if(empty($this->name)) {
			$this->setError(JText::_('Must choose a name'));
			return false;
		}

		if(empty($this->product_parent_id)) {
			$this->setError(JText::_('Attribute must have a product'));
			return false;
		}
	}

}

class JTableAttribute extends JTable
{
	/** @var int Primary key */
	var $id				= null;
	/** @var int */
	var $product_id			= null;
	/** @var int */
	var $product_attribute_sku_id		= null;
	/** @var string */
	var $attribute_name		= null;
	/** @var string */
	var $attribute_value		= null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_product_attribute', 'id', $db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{
		if(empty($this->product_id)) {
			$this->setError(JText::_('No Attribute Product ID!'));
			return false;
		}

		if(empty($this->product_attribute_sku_id)) {
			$this->setError(JText::_('No Attribute SKU ID!'));
			return false;
		}
		if(empty($this->attribute_name)) {
			$this->setError(JText::_('No Attribute Name!'));
			return false;
		}
		if(empty($this->attribute_value)) {
			$this->setError(JText::_('No Attributer Value!'));
			return false;
		}
	}

}
