<?php
/**
 * @version		$Id: category.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');

/**
 * Category table
 */
class TableCategory extends JTable
{
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $parent_id			= null;
	/** @var string */
	var $title				= null;
	/** @var string */
	var $name				= null;
	/** @var string */
	var $alias		= null;
	/** @var string */
	var $image				= null;
	/** @var int */
	var $section			= null;
	/** @var string */
	var $image_position		= null;
	/** @var string */
	var $description		= null;
	/** @var int */
	var $published			= null;
	/** @var int */
	var $checked_out		= 0;
	/** @var datetime */
	var $checked_out_time	= 0;
	/** @var string */
	var $editor				= null;
	/** @var int */
	var $ordering			= null;
	/** @var int */
	var $access				= null;
	/** @var int */
	var $count				= null;
	/** @var int */
	var $params				= null;


	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_categories', 'id', $db );

	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{

		if(empty($this->title)) {
			$this->setError(JText::_('Category must have a title'));
			return false;
		}
		if(empty($this->section)) {
			$this->setError(JText::_('Category must have a section'));
			return false;
		}
	    if(empty($this->alias)) {
            $this->alias = $this->title;
        }
        $this->alias = JFilterOutput::stringURLSafe($this->alias);
        if(trim(str_replace('-','',$this->alias)) == '') {
            $datenow =& JFactory::getDate();
            $this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
        }
		return true;
	}

    /**
    * Overloaded bind function
    *
    * @access public
    * @param array $hash named array
    * @return null|string   null is operation was satisfactory, otherwise returns an error
    * @see JTable:bind
    * @since 1.5
    */
    function bind($array, $ignore = '')
    {
        if (isset( $array['params'] ) && is_array($array['params']))
        {
            $registry = new JRegistry();
            $registry->loadArray($array['params']);
            $array['params'] = $registry->toString();
        }

        return parent::bind($array, $ignore);
    }
}