<?php
/**
 * @version		$Id: config.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');

/**
 * Store table config
 */
class JTableMyMuseConfig extends JTable
{
	/** @var int Primary key */
	var $id				= null;
	/** @var string */
	var $name			= null;
	/** @var string */
	var $value			= null;
	/** @var string */
	var $code			= null;
	/** @var int */
	var $ordering		= null;
	/** @var string */
	var $description	= null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_config', 'id', $db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{

		if(empty($this->name)) {
			$this->setError(JText::_('No Config Name!'));
			return false;
		}
		
		if(empty($this->code)) {
			$this->setError(JText::_('No Config Code'));
			return false;
		}
		return true;

	}

}