<?php
/**
 * @version		$Id: order.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');

/**
 * Store table order
 */
class TableOrder extends JTable
{
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $user_id			= null;
	/** @var int */
	var $store_id			= null;
	/** @var string */
	var $order_number		= null;
	/** @var int */
	var $shopper_id			= null;
	/** @var int */
	var $ship_info_id		= null;
	/** @var float */
	var $order_subtotal		= null;
	/** @var float */
	var $order_shipping		= null;
	/** @var int */
	var $ship_method_id		= null;
	/** @var string */
	var $order_currency		= null;
	/** @var string */
	var $order_status		= null;
	
	/** @var string */
	var $coupon_name		= null;
	/** @var float */
	var $coupon_discount	= null;
	
	/** @varint */
	var $ReferenceNum		= null;
	/** @var int */
	var $TxnNumber			= null;
	/** @var datetime */
	var $created			= null;
	/** @var datetime */
	var $modified			= null;
	
	/** @var float */
	var $discount			= null;
	/** @var string */
	var $notes				= null;
	/** @var float */
	var $reservation_fee	= null;
	/** @var float */
	var $non_res_total		= null;
	/** @var float */
	var $pay_now			= null;
	/** @var string */
	var $extra				= null;
	

	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_order', 'id', $db );
		
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{

		if(empty($this->user_id)) {
			$this->setError(JText::_('No Order User ID!'));
			return false;
		}
		
		if(empty($this->shopper_id)) {
			$this->setError(JText::_('No Order shopper ID!'));
			return false;
		}
		
		if(empty($this->order_subtotal)) {
			$this->setError(JText::_('No Order Subtotal!'));
			return false;
		}
	return true;
	}

}

/**
 * Store table order_item
 */
class JTableMyMuseOrderItem extends JTable
{
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $order_id			= null;
	/** @var int */
	var $product_id			= null;
	/** @var int */
	var $product_quantity	= null;
	/** @var float */
	var $product_item_price	= null;
	/** @var string */
	var $product_sku		= null;
	/** @var string */
	var $product_name		= null;
	/** @var datetime */
	var $created			= null;
	/** @var datetime */
	var $modified			= null;
	

	
	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_order_item', 'id', $db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{

		if(empty($this->order_id)) {
			$this->setError(JText::_('No Order ID!'));
			return false;
		}
		if(empty($this->product_id)) {
			$this->setError(JText::_('No Item ID!'));
			return false;
		}
		if(empty($this->product_quantity)) {
			$this->setError(JText::_('No Item Quantity!'));
			return false;
		}
		if(empty($this->product_item_price)) {
			$this->setError(JText::_('No Item Price!'));
			return false;
		}
		if(empty($this->product_sku)) {
			$this->setError(JText::_('NoItem SKU!'));
			return false;
		}

	}

}
