<?php
/**
 * @version		$Id: price.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');

/**
 * Store table price
 */
class TablePrice extends JTable
{
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $product_id				= null;
	/** @var float */
	var $product_price				= null;
	/** @var datetime */
	var $created		= null;
	/** @var datetime */
	var $modified			= null;
	/** @var int */
	var $shopper_group_id			= null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_product_price', 'id', $db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{
		/*
		TODO: This filter is too rigorous,need to implement more configurable solution
		// specific filters
		$filter = & JFilterInput::getInstance( null, null, 1, 1 );
		$this->introtext = trim( $filter->clean( $this->introtext ) );
		$this->fulltext =  trim( $filter->clean( $this->fulltext ) );
		*/


		if(empty($this->product_id)) {
			$this->setError(JText::_('Must choose a product'));
			return false;
		}

		if(empty($this->product_price)) {
			$this->setError(JText::_('Product must have a price'));
			return false;
		}
		return true;
	}
	

}
