<?php
/**
 * @version		$Id: product.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */



// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');


class TableProduct extends JTable
{
	/** @var int Primary key */
	var $id						= null;
	/** @var string */
	var $title					= null;
	/** @var string */
	var $alias					= null;
	/** @var string */
	var $title_alias			= null;
	/** @var string */
	var $introtext				= null;
	/** @var string */
	var $fulltext				= null;
	/** @var int */
	var $state					= null;
	/** @var int The id of the artist category*/
	var $artistid				= null;
	/** @var int DEPRECATED */
	var $mask					= null;
	/** @var datetime */
	var $created				= null;
	/** @var int User id*/
	var $created_by				= null;
	/** @var string An alias for the author*/
	var $created_by_alias		= null;
	/** @var datetime */
	var $modified				= null;
	/** @var int User id*/
	var $modified_by			= null;
	/** @var boolean */
	var $checked_out			= 0;
	/** @var time */
	var $checked_out_time		= 0;
	/** @var datetime */
	var $frontpage_up			= null;
	/** @var datetime */
	var $frontpage_down			= null;
	/** @var datetime */
	var $publish_up				= null;
	/** @var datetime */
	var $publish_down			= null;
	/** @var string */
	var $images					= null;
	/** @var string */
	var $image					= null;
	/** @var string */
	var $urls					= null;
	/** @var string */
	var $attribs				= null;
	/** @var int */
	var $version				= null;
	/** @var int */
	var $parentid				= null;
	/** @var int */
	var $ordering				= null;
	/** @var string */
	var $metakey				= null;
	/** @var string */
	var $metadesc				= null;
	/** @var string */
	var $metadata				= null;
	/** @var int */
	var $access					= null;
	/** @var int */
	var $hits					= null;
	/** @var int */
	var $product_physical		= 0;
	/** @var int */
	var $product_downloadable	= 0;
	/** @var int */
	var $product_allfiles		= 0;
	/** @var string */
	var $product_sku			= null;
	/** @var string */
	var $product_made_date		= null;
	/** @var string */
	var $product_in_stock		= null;
	/** @var string */
	var $product_special		= null;
	/** @var string */
	var $product_discount		= null;
	/** @var string */
	var $reservation_fee		= null;
	/** @var string */
	var $product_package_ordering	= null;
	/** @var string */
	var $product_package		= null;
	/** @var string */
	var $file_length			= null;
	/** @var string */
	var $file_name				= null;
	/** @var string */
	var $file_preview			= null;
	/** @var int */
	var $file_downloads			= null;
	/** @var string */
	var $file_contents			= null;
	/** @var string */
	var $file_type				= null;

	/**
	* @param database A database connector object
	*/
	function __construct( &$db ) {
		parent::__construct( '#__mymuse_product', 'id', $db );
	}

	/**
	 * Overloaded check function
	 *
	 * @access public
	 * @return boolean
	 * @see JTable::check
	 * @since 1.5
	 */
	function check()
	{

		if(empty($this->title)) {
			$this->setError(JText::_('Product must have a title'));
			return false;
		}

		if(empty($this->alias)) {
			$this->alias = $this->title;
		}
		$this->alias = JFilterOutput::stringURLSafe($this->alias);

		if(trim(str_replace('-','',$this->alias)) == '') {
			$datenow =& JFactory::getDate();
			$this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
		}

		if (trim( str_replace( '&nbsp;', '', $this->fulltext ) ) == '') {
			$this->fulltext = '';
		}

		if(empty($this->introtext) && empty($this->fulltext)) {
			$this->setError(JText::_('Product must have some text'));
			return false;
		}

		// clean up keywords -- eliminate extra spaces between phrases
		// and cr (\r) and lf (\n) characters from string
		if(!empty($this->metakey)) { // only process if not empty
			$bad_characters = array("\n", "\r", "\"", "<", ">"); // array of characters to remove
			$after_clean = JString::str_ireplace($bad_characters, "", $this->metakey); // remove bad characters
			$keys = explode(',', $after_clean); // create array using commas as delimiter
			$clean_keys = array(); 
			foreach($keys as $key) {
				if(trim($key)) {  // ignore blank keywords
					$clean_keys[] = trim($key);
				}
			}
			$this->metakey = implode(", ", $clean_keys); // put array back together delimited by ", "
		}
		
		// clean up description -- eliminate quotes and <> brackets
		if(!empty($this->metadesc)) { // only process if not empty
			$bad_characters = array("\"", "<", ">");
			$this->metadesc = JString::str_ireplace($bad_characters, "", $this->metadesc);
		}

		return true;
	}

}