<?php
/**
 * @version		$Id: store.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is within the rest of the framework
defined('_JEXEC') or die('Restricted access');


class TableStore extends JTable
{
    /** @var int Primary key */
    var $id                 		= null;
    /** @var string The menu title for the section (a short name)*/
    var $title              		= null;
    /** @var string The full name for the section*/
    var $name               		= null;
    /** @var string The alias for the section*/
    var $alias              		= null;
    /** @var string */
    var $image              		= null;
    /** @var string */
    var $scope              		= null;
    /** @var int */
    var $image_position     		= null;
    /** @var string */
    var $description        		= null;
    /** @var boolean */
    var $published          		= null;
    /** @var boolean */
    var $checked_out        		= 0;
    /** @var time */
    var $checked_out_time   		= 0;
    /** @var int */
    var $ordering           		= null;
    /** @var int */
    var $access             		= null;
    /** @var string */
    var $params             		= null;
    
    /** @var string */
    var $contact_last_name    		= null;
    /** @var string */
    var $contact_first_name   		= null;
    /** @var string */
    var $contact_title        		= null;
    /** @var string */
    var $contact_email        		= null;
    /** @var string */
    var $phone             			= null;
    /** @var string */
    var $fax            			= null;
    /** @var string */
    var $address_1            		= null;
    /** @var string */
    var $address_2            		= null;
    /** @var string */
    var $city            			= null;
    /** @var string */
    var $state            			= null;
    /** @var string */
    var $country            		= null;
    /** @var string */
    var $zip             			= null;
    /** @var string */
    var $store_thumb_image          = null;
    /** @var string */
    var $store_full_image           = null;
    /** @var string */
    var $currency             		= null;
    /** @var string */
    var $player						= '';
    /** @var int */
    var $my_reviews_catid			= null;
    /** @var int */
    var $my_section_artists			= null;
    /** @var int */
    var $my_section_catalog			= null;



    /**
    * @param database A database connector object
    */
    function __construct( &$db ) {
        parent::__construct( '#__mymuse_store', 'id', $db );
    }

    /** Overloaded check function
     *
     * @access public
     * @return boolean
     * @see JTable::check
     * @since 1.5
     */
    function check()
    {
        // check for valid name
        if (trim( $this->title ) == '') {
            $this->setError( JText::_( 'SECTION MUST HAVE A TITLE') );
            return false;
        }

        // check for existing name
        /*$query = "SELECT id"
        . ' FROM #__sections "
        . ' WHERE title = '. $this->_db->Quote($this->title)
        . ' AND scope = ' . $this->_db->Quote($this->scope)
        ;
        $this->_db->setQuery( $query );

        $xid = intval( $this->_db->loadResult() );
        if ($xid && $xid != intval( $this->id )) {
            $this->_error = JText::sprintf( 'WARNNAMETRYAGAIN', JText::_( 'Section') );
            return false;
        }*/

        if(empty($this->alias)) {
            $this->alias = $this->title;
        }
        $this->alias = JFilterOutput::stringURLSafe($this->alias);
        if(trim(str_replace('-','',$this->alias)) == '') {
            $datenow =& JFactory::getDate();
            $this->alias = $datenow->toFormat("%Y-%m-%d-%H-%M-%S");
        }

        return true;
    }

    /**
    * Overloaded bind function
    *
    * @access public
    * @param array $hash named array
    * @return null|string   null is operation was satisfactory, otherwise returns an error
    * @see JTable:bind
    * @since 1.5
    */
    function bind($array, $ignore = '')
    {
        if (isset( $array['params'] ) && is_array($array['params']))
        {
            $registry = new JRegistry();
            $registry->loadArray($array['params']);
            $array['params'] = $registry->toString();
        }

        return parent::bind($array, $ignore);
    }
}
