<?php
/**
 * @version		$Id: view.html.php 169 2010-10-13 02:19:13Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );

class myMuseViewProduct extends Jview
{
	function display($tpl = null){
		global $mainframe, $nullDate, $params, $option;

		// Get data 
        $items  	=& $this->get( 'Data');
        $user		=& JFactory::getUser();
        $task 		= JRequest::getVar('task', null, 'default', 'cmd');
        $type 		= JRequest::getVar('type', null);

        $this->assignRef('params', $params);
        $this->assignRef('user', $user);
		$this->assignRef('nullDate', $nullDate);
		$this->assignRef('task', $task);

		switch ($task)
		{
			case "add":
			case "edit":
			{
				$isNew  = ($items->id < 1);
				if($isNew)
				{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE NEW PRODUCT' ).' ]</small></small>','addedit.png' );
					JToolBarHelper::save();
					JToolBarHelper::apply();
					JToolBarHelper::cancel();

				}else{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE EDIT PRODUCT' ).' ]</small></small>','addedit.png' );
					JToolBarHelper::save();
					JToolBarHelper::apply();
					JToolBarHelper::cancel( 'cancel', 'Close' );

				}
				JRequest::setVar('edit', true);
				$lists 	= & $this->get('Lists');
				$lists['isNew'] = $isNew;
				$lists['type'] = $type;

				// Create the form
				$form = new JParameter('', JPATH_COMPONENT.DS.'models'.DS.'product.xml');

				//Details Group
				$form->set('product_physical', $items->product_physical);
				$form->set('product_made_date', $items->product_made_date);
				$form->set('product_in_stock', $items->product_in_stock);
				
				
				// Authoring Group
				$active = (intval($items->created_by) ? intval($items->created_by) : $user->get('id'));
				$form->set('created_by', $active);
				$form->set('access', $items->access);
				$form->set('created_by_alias', $items->created_by_alias);

				$form->set('created', JHTML::_('date', $items->created, '%Y-%m-%d %H:%M:%S'));
				$form->set('publish_up', JHTML::_('date', $items->publish_up, '%Y-%m-%d %H:%M:%S'));
				if (JHTML::_('date', $items->publish_down, '%Y') <= 1969 || $items->publish_down == $nullDate) {
					$form->set('publish_down', JText::_('Never'));
				} else {
					$form->set('publish_down', JHTML::_('date', $items->publish_down, '%Y-%m-%d %H:%M:%S'));
				}

				// Advanced Group
				$form->loadINI($items->attribs);

				// Metadata Group
				$form->set('description', $items->metadesc);
				$form->set('keywords', $items->metakey);
				$form->loadINI($items->metadata);
				
				// for track/item ordering
				$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
				$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );
				$lists['order_Dir']	= $filter_order_Dir;
				$lists['order']		= $filter_order;

				$lists['limitstart'] = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );
		
				
				$this->assignRef( 'items', $items );
				$this->assignRef( 'tracks', $tracks );
				$this->assignRef( 'row', $items );
				$this->assignRef( 'lists', $lists );
				$this->assignRef( 'form', $form );
				
				
			} break;
			
        	case 'additem'  :
			case 'edititem'  :
			{
				
				$attribute_skus = $this->get('Attributeskus');
				$attributes = $this->get('Attributes');
				$isNew  = ($items->id < 1);

				if($isNew)
				{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE NEW PRODUCT ITEM' ).' ]</small></small>' );
					JToolBarHelper::save('saveitem');
					JToolBarHelper::apply('applyitem');
					JToolBarHelper::cancel( 'cancelitem', JText::_('Cancel') );

				}else{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE EDIT PRODUCT ITEM' ).' ]</small></small>' );
					JToolBarHelper::save('saveitem');
					JToolBarHelper::apply('applyitem');
					JToolBarHelper::cancel( 'cancelitem', JText::_('Close') );

				}
				

				
				
				$this->assignRef( 'attribute_skus', $attribute_skus );
				$this->assignRef( 'attributes', $attributes );
				$this->assignRef( 'row', $items );
				

			} break;
				
				
			case 'addfile'  :
			case 'editfile'  :
			{
				
				$isNew  = ($items->id < 1);
				if($isNew)
				{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE NEW PRODUCT FILE' ).' ]</small></small>' );
					JToolBarHelper::save('savefile');
					JToolBarHelper::apply('applyfile');
					JToolBarHelper::cancel( 'cancelitem', JText::_('Cancel') );

				}else{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE EDIT PRODUCT FILE' ).' ]</small></small>' );
					JToolBarHelper::save('savefile');
					JToolBarHelper::apply('applyfile');
					JToolBarHelper::cancel( 'cancelitem', JText::_('Close') );

				}
				
				$lists 	= & $this->get('FileLists');
				$artist_alias = MyMuseHelper::getArtistAlias($items->parentid,1);
        		$album_alias = MyMuseHelper::getAlbumAlias($items->parentid);
        		$lists['download_dir'] = $params->get('my_download_dir').DS.$artist_alias.DS.$album_alias;
				$this->assignRef( 'row', $items );
				$this->assignRef( 'lists', $lists );

			} 
			break;

			case 'new_allfiles'  :
			case 'edit_allfiles'  :
			{
				
				$isNew  = ($items->id < 1);
				if($isNew)
				{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE NEW ALL FILES' ).' ]</small></small>' );
					JToolBarHelper::save('save_allfiles');
					JToolBarHelper::apply('apply_allfiles');
					JToolBarHelper::cancel( 'cancelitem', JText::_('Cancel') );

				}else{
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE EDIT ALL FILES' ).' ]</small></small>' );
					JToolBarHelper::save('save_allfiles');
					JToolBarHelper::apply('apply_allfiles');
					JToolBarHelper::cancel( 'cancelitem', JText::_('Close') );

				}
				$lists 	= & $this->get('FileLists');
				$this->assignRef( 'row', $items );
				$this->assignRef( 'lists', $lists );

			} 
			break;
			
			default:
			{
				JToolBarHelper::title( JText::_( 'MYMUSE PRODUCTS' ), 'sections.png' );
				JToolBarHelper::deleteList();
				JToolBarHelper::editListX();
				JToolBarHelper::addNewX();
				 
				$filter_state = $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
				$filter_catid = $mainframe->getUserStateFromRequest( $option.'filter_catid', 'filter_catid', 0, 'int' );
				$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'c.ordering', 'cmd' );
				$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
				$search = $mainframe->getUserStateFromRequest( $option.'search', 'search', '', 'string' );
				$search = JString::strtolower( $search );
				$pagination = & $this->get( 'Pagination' );
				$lists 	= & $this->get('Lists');
				$lists['search']= $search;
				
				// table ordering
				$lists['order_Dir']	= $filter_order_Dir;
				$lists['order']		= $filter_order;

				$this->assignRef( 'items', $items );
				$this->assignRef('lists', $lists);
				$this->assignRef('pagination', $pagination);


			} break;
		}
        
        JToolBarHelper::help( 'product',true );
        

		
		parent::display($tpl);
	}

}
?>