<?php
/**
 * @version		$Id: view.html.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );

class myMuseViewShopper extends Jview
{
	function display($tpl = null){
		global $mainframe, $option;
		// Get data 
        $items  	=& $this->get( 'Data');
        $task 		= JRequest::getVar('task', null, 'default', 'cmd');
        $mymuse_params 	= &JComponentHelper::getParams( 'com_mymuse' );
        $this->assignRef('mymuse_params', $mymuse_params);
		$this->assignRef('nullDate', $nullDate);
		$this->assignRef('task', $task);

		switch ($task)
		{
			case "add":
			case "edit":
			{
				$isNew  = ($items->id < 1);
				if($isNew)
				{

					$user		=& JUser::getInstance();
					
					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE NEW SHOPPER' ).' ]</small></small>','addedit.png' );
					JToolBarHelper::save();
					JToolBarHelper::apply();
					JToolBarHelper::cancel();

				}else{

					$user		=& JUser::getInstance($items->user_id);

					JToolBarHelper::title(   JText::_( 'MyMuse' ).': <small><small>[ ' . JText::_( 'MYMUSE EDIT SHOPPER' ).' '. $user->name .']</small></small>','addedit.png' );
					JToolBarHelper::save();
					JToolBarHelper::apply();
					JToolBarHelper::cancel( 'cancel', 'Close' );

				}
	
				
				$user_params = $user->getParameters(true);

				$this->assignRef( 'user_params', $user_params );
				
				$acl		=& JFactory::getACL();
				$myuser		=& JFactory::getUser();
				$this->assignRef( 'myuser', $myuser );
				
				$lists 		=& $this->get('Lists');
				
				
				// Check for post data in the event that we are returning
				// from a unsuccessful attempt to save data
				$post = JRequest::get('post');
				if ( $post ) {
					$user->bind($post);
				}

				if ( $user->get('id'))
				{
					$contact = NULL;
				}
				else
				{
					$contact 	= NULL;
					// Get the default group id for a new user
					$config		= &JComponentHelper::getParams( 'com_users' );
					$newGrp		= $config->get( 'new_usertype' );
					$user->set( 'gid', $acl->get_group_id( $newGrp, null, 'ARO' ) );
				}

				$userObjectID 	= $acl->get_object_id( 'users', $user->get('id'), 'ARO' );
				$userGroups 	= $acl->get_object_groups( $userObjectID, 'ARO' );
				$userGroupName 	= strtolower( $acl->get_group_name( $userGroups[0], 'ARO' ) );

				$myObjectID 	= $acl->get_object_id( 'users', $myuser->get('id'), 'ARO' );
				$myGroups 		= $acl->get_object_groups( $myObjectID, 'ARO' );
				$myGroupName 	= strtolower( $acl->get_group_name( $myGroups[0], 'ARO' ) );;
				if ( $userGroupName == $myGroupName && $myGroupName == 'administrator' )
				{
					// administrators can't change each other
					$lists['gid'] = '<input type="hidden" name="gid" value="'. $user->get('gid') .'" /><strong>'. JText::_( 'MYMUSE ADMINISTRATOR' ) .'</strong>';
				}
				else
				{
					$gtree = $acl->get_group_children_tree( null, 'USERS', false );
					$lists['gid'] 	= JHTML::_('select.genericlist',   $gtree, 'gid', 'size="10"', 'value', 'text', $user->get('gid') );
				}

				// build the html select list
				$lists['block'] 	= JHTML::_('select.booleanlist',  'block', 'class="inputbox" size="1"', $user->get('block') );

				// build the html select list
				$lists['sendEmail'] = JHTML::_('select.booleanlist',  'sendEmail', 'class="inputbox" size="1"', $user->get('sendEmail') );
				
				$this->assignRef( 'lists', $lists );
				
				// MYMUSE ORDERS
				$orders = array();
				if($user->id){
					$orders  	=& $this->get( 'Orders');
				}
				$this->assignRef( 'orders', $orders );
					

				if ($user->get('lastvisitDate') == "0000-00-00 00:00:00") {
					$user->lvisit = JText::_( 'Never' );
				} else {
					$user->lvisit	= JHTML::_('date', $user->get('lastvisitDate'), '%Y-%m-%d %H:%M:%S');
				}

				$this->assignRef( 'shopper', $items );
				$this->assignRef( 'user', $user );
				JRequest::setVar('uid',$items->user_id);
			} break;
			
			default:
			{
				JToolBarHelper::title( JText::_( 'MyMuse Shoppers' ), 'sections.png' );
				JToolBarHelper::deleteList();
				JToolBarHelper::editListX();
				JToolBarHelper::addNewX();

				$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'a.ordering', 'cmd' );
				$filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
				$search = $mainframe->getUserStateFromRequest( $option.'search', 'search', '', 'string' );
				
				$search = JString::strtolower( $search );
				$total 		= & $this->get( 'Total');
				$pagination = & $this->get( 'Pagination' );
				$lists 		= & $this->get( 'Lists' );
				$lists['search']= $search;
				$lists['order_Dir']	= $filter_order_Dir;
				$lists['order']		= $filter_order;
				
				$this->assignRef( 'items', $items );
				$this->assignRef('lists', $lists);
				$this->assignRef('pagination', $pagination);

			} break;
		}
        
        JToolBarHelper::help( 'shopper',true );
        
			
		parent::display($tpl);

	}

}
?>