<?php
/**
 * @version		$Id: install.mymuse.php 132 2010-10-07 02:18:41Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author		Dioscouri Design
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca

 * Modified from Dioscouri Design, http://www.dioscouri.com
 * Tienda
 * install.php
 * Copyright (C) 2007 Dioscouri Design. Arboreta Internet Services - All rights reserved.
 * http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );


$VERSION = "1.0.100819-b";
$RELEASE = "100819";
$thisextension = strtolower( "com_mymuse" );
$thisextensionname = substr ( $thisextension, 4 );

JLoader::import( 'com_mymuse.helpers.dscinstaller', JPATH_ADMINISTRATOR.DS.'components' );

// load the component language file
$language = &JFactory::getLanguage();
$language->load( $thisextension );

$status = new JObject();
$status->modules = array();
$status->plugins = array();
$status->actions = array();


/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * MODULE INSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module)
	{
		$mname		= $module->attributes('module');
		$mpublish	= $module->attributes('publish');
		$mposition	= $module->attributes('position');
		$mclient	= JApplicationHelper::getClientInfo($module->attributes('client'), true);
		
		// Set the installation path
		if (!empty ($mname)) {
			$this->parent->setPath('extension_root', $mclient->path.DS.'modules'.DS.$mname);
		} else {
			$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.JText::_('Install Module File Missing'));
			return false;
		}
		
		/*
		 * fire the Installer with the foldername and folder entryType
		 */
		$pathToFolder = $this->parent->getPath('source').DS.$mname;
		$dscInstaller = new dscInstaller();
		if ($mpublish) {
			$dscInstaller->set( '_publishExtension', true );
		}
		$result = $dscInstaller->installExtension($pathToFolder, 'folder');
		
		// track the message and status of installation from dscInstaller
		if ($result) 
		{
			// update the module record if the position != left
			if (isset($mposition) && $mposition != 'left')
			{
				// set the position of the module
				$database = JFactory::getDBO();
				$query = "UPDATE #__modules SET `position` = '{$mposition}' WHERE `module` = '{$mname}';";
				$database->setQuery($query);
				$database->query();
			}
			$alt = JText::_( "Installed" );
			$mstatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		} else {
			$alt = JText::_( "Failed" );
			$error = $dscInstaller->getError();
			$mstatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$mstatus .= " - ".$error;
		}
		
		$status->modules[] = array('name'=>$mname,'client'=>$mclient->name, 'status'=>$mstatus );
	}
}


/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * PLUGIN INSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	   //MYMUSE DIRECTORY
		$name = JText::_("Making mymuse plugin directory.");
		$dir =  JPATH_ROOT.DS."plugins".DS."mymuse";
		if(!file_exists($dir)){
			if(!JFolder::create($dir)){
				$alt = JText::_( "Failed" );
				$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
				$message = JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall.")."<br />$dir";

			}else{
				$alt = JText::_( "Installed" );
				$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
				$message = JText::_("Directory created $dir.");
			}
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Directory exists.");
		}
		$status->plugins[] = array('name'=>$name,'group'=>$message, 'status'=>$astatus );
		
	foreach ($plugins->children() as $plugin)
	{
		$pname		= $plugin->attributes('plugin');
		$ppublish	= $plugin->attributes('publish');
		$pgroup		= $plugin->attributes('group');
		$pfilename  = $plugin->attributes('element');
		
		// Set the installation path
		if (!empty($pname) && !empty($pgroup)) {
			$this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.$pgroup);
		} else {
			$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('Install Plugin File Missing'));
			return false;
		}
		
		/*
		 * fire the Installer with the foldername and folder entryType
		 */
		$pathToFolder = $this->parent->getPath('source').DS.$pname;
		$dscInstaller = new dscInstaller();
		if ($ppublish) {
			$dscInstaller->set( '_publishExtension', true );
		}
		$result = $dscInstaller->installExtension($pathToFolder, 'folder');
		
		// track the message and status of installation from dscInstaller
		if ($result) {
			$alt = JText::_( "Installed" );
			$pstatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";	
		} else {
			$alt = JText::_( "Failed" );
			$error = $dscInstaller->getError();
			$pstatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
			$pstatus .= " - ".$error;	
		}

		$status->plugins[] = array('name'=>"$pname $pfilename",'group'=>$pgroup, 'status'=>$pstatus);
	}
}



/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * SETUP DEFAULTS
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/


		// add file extensions mp3,mp4a  
		$name = JText::_("Media parameters, mp3, mp4a");
		$media_params = &JComponentHelper::getParams( 'com_media' );
		$new_extensions = "mp3,mp4a,MP3,MP4A,zip,ZIP,bww,BWW,";
		$new_mimes = "audio/mpeg,audio/mp4a-latm,";
		$old_extension = $media_params->get('upload_extensions');
		$old_mimes = $media_params->get('upload_mime');
		$added = array();
		$text = '';
		$db = JFactory::getDBO();
		
		if(!preg_match("/mp3/",$old_extension)){
			$media_params->set('upload_extensions',"mp3,".$media_params->get('upload_extensions'));
			$added[] = "mp3";
		}
		if(!preg_match("/mp4a/",$old_extension)){
			$media_params->set('upload_extensions',"mp4a,".$media_params->get('upload_extensions'));
			$added[] = "mp4a";
		}
		
		if(!preg_match("/MP3/",$old_extension)){
			$media_params->set('upload_extensions',"MP3,".$media_params->get('upload_extensions'));
			$added[] = "MP3";
		}
		if(!preg_match("/MP4A/",$old_extension)){
			$media_params->set('upload_extensions',"MP4A,".$media_params->get('upload_extensions'));
			$added[] = "MP4A";
		}
		if(!preg_match("/zip/",$old_extension)){
			$media_params->set('upload_extensions',"zip,".$media_params->get('upload_extensions'));
			$added[] = "zip";
		}
		if(!preg_match("/ZIP/",$old_extension)){
			$media_params->set('upload_extensions',"ZIP,".$media_params->get('upload_extensions'));
			$added[] = "ZIP";
		}
		if(!preg_match("/bww/",$old_extension)){
			$media_params->set('upload_extensions',"bww,".$media_params->get('upload_extensions'));
			$added[] = "bww";
		}
		if(!preg_match("/BWW/",$old_extension)){
			$media_params->set('upload_extensions',"BWW,".$media_params->get('upload_extensions'));
			$added[] = "BWW";
		}
		

		// track the message and status of installation 
		if (count($added)) 
		{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message= "Added ".implode(",",$added)." file extensions to media parameters";
		} else {
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message= "Media parameters already in place.";
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		// add mimetypes audio/mpeg,audio/mp4a-latm
		$name = JText::_("Mimetypes audio/mpeg,audio/mp4a-latm");
		$added = array();
		if(!preg_match("#audio/mp4a-latm#",$old_mimes)){
			$media_params->set('upload_mime',"audio/mp4a-latm,".$media_params->get('upload_mime'));
			$added[] = "audio/mp4a-latm";
		}
		if(!preg_match("#audio/mpeg#",$old_mimes)){
			$media_params->set('upload_mime',"audio/mpeg,".$media_params->get('upload_mime'));
			$added[] = "audio/mpeg";
		}
		
		if(count($added))
		{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message= JText::_("Added ".implode(",",$added)." mime types to media parameters.");
		} else {
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message= "Mime Types already in place.";
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		// store the params
		$name = Jtext::_("Save Parameters");
		$new_params = $media_params->toString();
		$table =& JTable::getInstance('component');
		$table->loadByOption( 'com_media' );
		$table->params = $new_params;
		if($table->store()){
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message= JText::_("Saved parameters");
		}else{
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message= JText::_("Could not save parameters: "). $table->getError();
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		
		//PREVIEW DIRECTORY
		$name = JText::_("Making preview directory.");
		$preview_dir =  JPATH_ROOT.DS."images".DS."stories".DS."A_MyMusePreviews";
		if(!file_exists($preview_dir)){
			if(!JFolder::create($preview_dir)){
				$alt = JText::_( "Failed" );
				$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
				$message = JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall.")."<br />$preview_dir";

			}else{
				$alt = JText::_( "Installed" );
				$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
				$message = JText::_("Directory created $preview_dir.");
			}
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Directory exists.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		
		// DEFAULT DOWNLOAD DIRECTORY
		$name = JText::_("Making download directory.");
		$download_dir =  JPATH_ROOT.DS."images".DS."A_MyMuseDownloads";
		if(!file_exists($download_dir)){
			if(!JFolder::create($download_dir)){
				$alt = JText::_( "Failed" );
				$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
				$message = JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall.")."<br />$download_dir";
			}else{
				$alt = JText::_( "Installed" );
				$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
				$message = JText::_("Directory created $download_dir.");
			}
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Directory exists.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		

		//ARTIST DIRECTORY FOR GRAPHICS
		$name = JText::_("Making artist directory for graphics.");
		$artist_dir =  JPATH_ROOT.DS."images".DS."stories".DS."artists";
		if(!file_exists($artist_dir)){
			if(!JFolder::create($artist_dir)){
				$alt = JText::_( "Failed" );
				$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
				$message = JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall.")."<br />$artist_dir";
			}else{
				$alt = JText::_( "Installed" );
				$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
				$message = JText::_("Directory created $artist_dir.");
			}
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Directory exists.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

		//ALBUM DIRECTORY FOR GRAPHICS
		$name = JText::_("Making album directory for graphics.");
		$album_dir =  JPATH_ROOT.DS."images".DS."stories".DS."albums";
		if(!file_exists($album_dir)){
			if(!JFolder::create($album_dir)){
				$alt = JText::_( "Failed" );
				$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
				$message = JText::_("Could not make directory!
				Please uninstall, fix permissions and reinstall.")."<br />$album_dir";
			}else{
				$alt = JText::_( "Installed" );
				$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
				$message = JText::_("Directory created $album_dir.");
			}
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Directory exists.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		
		// copy index.html to Preview Dir
		$name = Jtext::_("index.html to Preview Dir");
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."index.html",
		$preview_dir.DS."index.html")){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Could not copy file.");
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("File copied.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		// copy index.html to Download Dir
		$name = Jtext::_("index.html to Download Dir");
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."index.html",
		$download_dir.DS."index.html")){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Could not copy file.");
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("File copied.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		// copy index.html to Artist Dir
		$name = Jtext::_("index.html to Artist Dir");
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."index.html",
		$artist_dir.DS."index.html")){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Could not copy file.");
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("File copied.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		// copy index.html to Album Dir
		$name = Jtext::_("index.html to Album Dir");
		if(!JFile::copy (JPATH_ROOT.DS."administrator".DS."components".DS."com_mymuse".DS."assets".DS."index.html",
		$album_dir.DS."index.html")){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Could not copy file.");
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("File copied.");
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

		
/**
 * SEE IF THERE IS A PREVIOUS INSTALLATION, IF SO, WE WILL NOT MESS WITH SECTIONS AND CATEGORIES
 */
	$already_installed = 0;
	$name = JText::_("Creating Section and Categories");
	$query = "SELECT version from #__mymuse_store";
	$db->setQuery($query);
	$version = $db->loadResult();
	if($version && $version != $VERSION){
		$already_installed = 1;
		$alt = JText::_( "Already Installed" );
		$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		$message = JText::_("MyMuse is already installed, not adding sections/categories");
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		//update 
		preg_match("/(\d)\.(\d)\.(\d+)-.*/",$version,$m);

		if($m['1']==1 && $m['2'] == 0 && $m['3'] < $RELEASE){

			$query = "UPDATE #__mymuse_store set version ='$VERSION'";
			$db->setQuery($query);
			if(!$db->query()){
				var_dump($db);
			}
			$name = JText::_("Update to latest version");
			$alt = JText::_( "Updating" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Updated to version") . " $VERSION";
			$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
		}
		
	}elseif($version && $version == $VERSION){
		//JUST UPDATING THE CURRENT VERSION WITH A NEW COPY
		// LET'S LEAVE WELL ENOUGH ALONE ;)
		$alt = JText::_( "Same Version already Installed" );
		$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		$message = JText::_("Same version of MyMuse is already installed. Just overwrite files.");
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
		
	}

	//make artist section and one category
	$name = JText::_("Creating Sections for MyMuse.");
	// see if one exists, we might be upgrading
	$query = "SELECT id from #__sections WHERE scope='com_mymuse'";
	$db->setQuery($query);
	if($id = $db->loadResult()){
		$already_installed = 1;
		$alt = JText::_( "Already Installed" );
		$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		$message = JText::_("MyMuse Section is already installed.");
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
	}else{
		$query = "INSERT into #__sections (title,alias,scope,published,ordering) VALUES
			('Artists','artists','com_mymuse',1,0)";
		$db->setQuery($query);
		if(!$db->query()){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Problem with creating section: ").$db->_errorMsg;
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Artist Section added");
			$artist_sec_id = $db->insertid();
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
			
		$query = "INSERT into #__sections (title,alias,scope,published,ordering) VALUES
			('Catalog','catalog','com_mymuse',1,0)";
		$db->setQuery($query);
		if(!$db->query()){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Problem with creating section: ").$db->_errorMsg;
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message = JText::_("Catalog Section added");
			$catalog_sec_id = $db->insertid();
		}
		$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );
	}


	//make reviews section and one category
	$name = JText::_("Creating Section for Reviews.");
	// see if one exists, we might be upgrading
	$query = "SELECT id from #__sections WHERE title='Reviews' and scope='content'";
	$db->setQuery($query);
	if($id = $db->loadResult()){
		$alt = JText::_( "Already Installed" );
		$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		$message = JText::_("Reviews Section was already installed");
		$reviews_sec_id = $id;
	}else{
		$query = "INSERT into #__sections (title,alias,scope,published,ordering) VALUES
			('Reviews','reviews','content',1,0)";
		$db->setQuery($query);
		if(!$db->query()){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Problem with creating Reviews section: ").$db->_errorMsg;
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message =  JText::_("Reviews Section added")."<br />";
			$reviews_sec_id = $db->insertid();
		}
	}
	$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

	$name = JText::_("Creating Category for Reviews.");
	// see if one exists, we might be upgrading
	$query = "SELECT id from #__categories WHERE title='Reviews' and section='$reviews_sec_id'";
	$db->setQuery($query);
	if($id = $db->loadResult()){
		$alt = JText::_( "Already Installed" );
		$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		$message = JText::_("Reviews Category was already installed");
		$reviews_cat_id = $id;
	}else{
		$query = "INSERT into #__categories (title,alias,section,published,ordering) VALUES
			('Reviews','reviews',$reviews_sec_id,1,0)";
		$db->setQuery($query);
		if(!$db->query()){
			$alt = JText::_( "Failed" );
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
			$message = JText::_("Problem with creating category: ").$db->_errorMsg;
		}else{
			$alt = JText::_( "Installed" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
			$message =  JText::_("Reviews Category added");
			$reviews_cat_id = $db->insertid();
		}
	}
	$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );



	//update store table
	$name = JText::_("Updating Store entry.");
	$query = "SELECT params FROM #__mymuse_store WHERE id='1'";
	$db->setQuery($query);
	$store_params = $db->loadResult();

    $params = new JParameter( $store_params );
    $params->set("my_download_dir",$download_dir);
    $new_params = $params->toString();

	$query = "UPDATE #__mymuse_store set ";
	if(!$already_installed){
		$query .= "my_reviews_catid='$reviews_cat_id',
		my_section_artists='$artist_sec_id',
		my_section_catalog='$catalog_sec_id', ";
	}
	$query .= "params='$new_params'
		";
	$db->setQuery($query);
	if(!$db->query()){
		$alt = JText::_( "Failed" );
		$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
		$message =  JText::_("Problem with updating store: ").$db->_errorMsg;
	}else{
		$alt = JText::_( "Installed" );
		$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		$message =  JText::_("Store updated");
	}
	$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

	
/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * OUTPUT TO SCREEN
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/
$rows = 0;
?>

<h2><?php echo JText::_('MyMuse Installation'); ?></h2>
<table width="100%">
	<tr>
		<td valign="top" width="200"><img src="components/com_mymuse/assets/images/logo325.jpg"></td>
	    <td>
	
	<table class="adminlist"  width="100%">
	<thead>
		<tr>
			<th colspan="2"><?php echo JText::_('Install'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr>
			<th><?php echo JText::_('Component'); ?></th>
			<th></th>
			<th></th>
		</tr>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo JText::_( $thisextension ); ?></td>
			<td class="key"><center><?php $alt = JText::_('Installed'); echo "<img src='images/tick.png' border='0' alt='{$alt}' />"; ?></center></td>
		</tr>
<?php if (count($status->modules)) : ?>
		<tr>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td class="key"><center><?php echo $module['status']; ?></center></td>
		</tr>
	<?php endforeach;
endif;
if (count($status->plugins)) : ?>
		<tr>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $plugin['name']; ?></td>
			<td class="key"><?php echo $plugin['group']; ?></td>
			<td class="key"><center><?php echo $plugin['status']; ?></center></td>
		</tr>
	<?php endforeach;
endif;
if (count($status->actions)) : ?>
		<tr>
			<th><?php echo JText::_('Action'); ?></th>
			<th><?php echo JText::_('Message'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->actions as $act) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $act['name']; ?></td>
			<td class="key"><?php echo $act['message']; ?></td>
			<td class="key"><center><?php echo $act['status']; ?></center></td>
		</tr>
	<?php endforeach;
endif;
?>
		<tr>
			<td colspan="3"><a href="index.php?option=com_mymuse"><?php echo JText::_('MYMUSE QUICKSTART')?></a></td>
		</tr>
		<tr>
			<td colspan="3"><a href="index.php?option=com_mymuse&task=addSampleData"><?php echo JText::_('MYMUSE ADD SAMPLE DATA')?></a></td>
		</tr>
	</tbody>
</table>

		</td>
	</tr>
</table>
