<?php
/**
 * @version		$Id: uninstall.mymuse.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author		Dioscouri Design
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca

 * Modified from Dioscouri Design, http://www.dioscouri.com
 * Tienda
 * uninstall.php
 * Copyright (C) 2007 Dioscouri Design. Arboreta Internet Services - All rights reserved.
 * http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Restricted access' );

$thisextension = strtolower( "com_mymuse" );
$thisextensionname = substr ( $thisextension, 4 );

JLoader::import( 'com_mymuse.helpers.dscinstaller', JPATH_ADMINISTRATOR.DS.'components' );

// load the component language file
$language = &JFactory::getLanguage();
$language->load( $thisextension );

$status = new JObject();
$status->modules = array();
$status->plugins = array();
$status->actions = array();


/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * MODULE UNINSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

    foreach ($modules->children() as $module)
    {
        $mname      = $module->attributes('module');
        $mpublish   = $module->attributes('publish');
        $mposition  = $module->attributes('position');
        $mclient    = JApplicationHelper::getClientInfo($module->attributes('client'), true);
        
        $package    = array();
        $package['type'] = 'module';
        $package['group'] = '';
        $package['element'] = $mname;
        $package['client'] = $module->attributes('client');
                
        // Set the installation path
        if (!empty ($mname)) {
            $this->parent->setPath('extension_root', $mclient->path.DS.'modules'.DS.$mname);
        } else {
            $this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.JText::_('Install Module File Missing'));
            return false;
        }
        
        /*
         * fire the dioscouriInstaller
         */
        $dscInstaller = new dscInstaller();
        $result = $dscInstaller->uninstallExtension($package);
        
        // track the message and status of installation from dscInstaller
        if ($result) 
        {
            $alt = JText::_( "Uninstalled" );
            $mstatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
        } 
            else 
        {
            $alt = JText::_( "Failed" );
            $error = $dscInstaller->getError();
            $mstatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' />";
            $mstatus .= " - ".$error;
        }
        
        $status->modules[] = array('name'=>$mname,'client'=>$mclient->name, 'status'=>$mstatus );
    }
}

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * PLUGIN INSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

    foreach ($plugins->children() as $plugin)
    {
        $pname      = $plugin->attributes('plugin');
        $ppublish   = $plugin->attributes('publish');
        $pgroup     = $plugin->attributes('group');

        $package    = array();
        $package['type'] = 'plugin';
        $package['group'] = $pgroup;
        $package['element'] = $plugin->attributes('element');
        $package['client'] = '';
        
        // Set the installation path
        if (!empty($pname) && !empty($pgroup)) {
            $this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.$pgroup);
        } else {
            $this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('Install Plugin File Missing'));
            return false;
        }
        
        /*
         * fire the dioscouriInstaller
         */
        $dscInstaller = new dscInstaller();
        $result = $dscInstaller->uninstallExtension($package);
        
        // track the message and status of installation from dscInstaller
        if ($result) 
        {
            $alt = JText::_( "Uninstalled" );
            $pstatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
        } 
            else 
        {
            $alt = JText::_( "Failed" );
            $error = $dscInstaller->getError();
            $pstatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
            $pstatus .= " - ".$error;   
        }

        $status->plugins[] = array('name'=>$pname,'group'=>$pgroup, 'status'=>$pstatus);
    }
}


$db = JFactory::getDBO();
    /**
     * Delete a file or recursively delete a directory
     *
     * @param string $str Path to file or directory
     */


    function recursiveDelete($str){

        if(is_file($str)){
            return @unlink($str);
        }
        elseif(is_dir($str)){
            $scan = glob(rtrim($str,'/').'/*');
            foreach($scan as $index=>$path){
                recursiveDelete($path);
            }
            return @rmdir($str);
        }
    }
    
//remove dirs that we made
		$db = &JFactory::getDBO();
		$query = "SELECT * FROM #__mymuse_store WHERE id=1";
		$db->setQuery($query);
		$store = $db->loadObject();

		
		$mparams	= &JComponentHelper::getParams( 'com_mymuse' );
		$mparams->merge( new JParameter( &$store->params ) );

		$mparams->set('my_section_catalog',$store->my_section_catalog);
		$mparams->set('my_section_artists',$store->my_section_artists);
		$mparams->set('my_reviews_catid',$store->my_reviews_catid);
		$mparams->set('my_version',$store->version);

$name = "Remove Previews";
$dir =  JPATH_ROOT.DS.$mparams->get('my_preview_dir');
if(recursiveDelete($dir))
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete preview dir: $dir "; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );


$name = "Remove Downloads";
$dir =  $mparams->get('my_download_dir');
if(recursiveDelete($dir))
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete $dir "; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );


$name = "Remove artist graphics";
$dir =  JPATH_ROOT.DS."images".DS."stories".DS."artists";
if(recursiveDelete($dir))
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete $dir "; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

$name = "Remove album graphics";
$dir =  JPATH_ROOT.DS."images".DS."stories".DS."albums";
if(recursiveDelete($dir))
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete $dir "; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );


// remove sections and categories
$name = "Delete mymuse sections";
$query = "DELETE FROM #__sections WHERE scope='com_mymuse'";
$db->setQuery($query);
if($db->query())
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
    $error = $db->_errorMsg;
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete sections $error"; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

$name = "Delete Reviews sections";
$query = "DELETE FROM #__sections WHERE title='Reviews'";
$db->setQuery($query);
if($db->query())
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
    $error = $db->_errorMsg;
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete Reviews section $error"; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

$name = "Delete Reviews category";
$query = "DELETE FROM #__categories WHERE title='Reviews'";
$db->setQuery($query);
if($db->query())
{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Uninstalled" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
}else{
	$alt = JText::_( "Failed" );
	$error = $db->_errorMsg;
    $astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
    $message = "Could not delete Reviews category $error"; 
}
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );

// remove the default shopper
$name = "Delete default shopper";
$query = "SELECT id FROM #__users WHERE email='buyertest@gordfisch.net'";
$db->setQuery($query);
if($id = $db->loadResult()){
	// find their acl id
	$query = "SELECT id FROM `#__core_acl_aro` WHERE value='$id'";
	$db->setQuery($query);
	if($aro_id = $db->loadResult()){
		$query = "DELETE FROM `#__core_acl_groups_aro_map` WHERE aro_id='$aro_id'";
		$db->setQuery($query);
		$db->query();
		
		$query = "DELETE FROM `#__core_acl_aro` WHERE value='$id'";
		$db->setQuery($query);
		$db->query();
		
		$query = "DELETE FROM #__users WHERE email='buyertest@gordfisch.net'";
		$db->setQuery($query);
		if($db->query())
		{
			$alt = JText::_( "Uninstalled" );
			$message = JText::_( "Uninstalled" );
			$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />";
		}else{
			$alt = JText::_( "Failed" );
			$error = $db->_errorMsg;
			$astatus = "<img src='images/publish_x.png' border='0' alt='{$alt}' /> ";
			$message = "Could not delete default shopper ";
		}
		
	}else{
		$alt = JText::_( "Failed" );
		$message = JText::_( "Could not find core_acl_aro id. Oh well" );
    	$astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
	}
}else{
	$alt = JText::_( "Uninstalled" );
	$message = JText::_( "Could not find default shopper. Oh well" );
    $astatus = "<img src='images/tick.png' border='0' alt='{$alt}' />"; 
	
}
$query = "DELETE FROM #__users WHERE email='buyertest@gordfisch.net'";
$db->setQuery($query);
$db->query;
$status->actions[] = array('name'=>$name,'message'=>$message, 'status'=>$astatus );




/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * OUTPUT TO SCREEN
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/
 $rows = 0;
?>

<h2><?php echo JText::_('Uninstall Results'); ?></h2>
<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('Uninstall'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo JText::_('Component'); ?></td>
			<td><center><strong><?php echo JText::_('Removed'); ?></strong></center></td>
		</tr>
<?php if (count($status->modules)) : ?>
		<tr>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td class="key"><center><?php echo $module['status']; ?></center></td>
		</tr>
	<?php endforeach;
endif;

if (count($status->plugins)) : ?>
		<tr>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td class="key"><center><?php echo $plugin['status']; ?></center></td>
		</tr>
	<?php endforeach;
endif; 
if (count($status->actions)) : ?>
		<tr>
			<th><?php echo JText::_('Action'); ?></th>
			<th><?php echo JText::_('Message'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->actions as $act) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $act['name']; ?></td>
			<td class="key"><?php echo $act['message']; ?></td>
			<td class="key"><center><?php echo $act['status']; ?></center></td>
		</tr>
	<?php endforeach;
endif;
?>
	</tbody>
</table>
