<?php
/**
 * @version		$Id: paymentpaypal.php 9 2010-07-20 00:39:10Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');
JPlugin::loadLanguage( 'plg_mymuse_payment', JPATH_SITE.DS.'language' );
/**
* MyMuse PaymnetPaypal plugin
*
* @package 		MyMuse
* @subpackage	mymuse
*/
class plgMymusePaymentPaypal extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param	object		$subject The object to observe
	  * @param 	array  		$config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgMyMusePaymentPaypal(&$subject, $config)  {
		parent::__construct($subject, $config);
		
		// loading plugin parameters
        $this->_plugin = JPluginHelper::getPlugin('mymuse', 'paymentpaypal');
        $this->_params = new JParameter($this->_plugin->params);

		//PAYMENT URL
		if($this->_params->get('my_paypal_sandbox'))
		{
			define ("PAYMENT_URL","https://www.sandbox.paypal.com/cgi-bin/webscr");
			define ("PAYMENT_HOST","www.sandbox.paypal.com");
			define ("MERCHANT_EMAIL",$this->_params->get('my_paypal_sandbox_email'));
		}
		else
		{
			define("PAYMENT_URL","https://secure.paypal.com/cgi-bin/webscr");
			define ("PAYMENT_HOST","secure.paypal.com");
		}
	}

	/**
	 * PayPal Payment method
	 * onBeforeMyMusePayment
	 */
	function onBeforeMyMusePayment($shopper, $store, $order, $params, $Itemid=1 )
	{
		global $mainframe;
		

		// Paypal wants the country_2_code
		$db		=& JFactory::getDBO();
		$query = "SELECT country_2_code from #__mymuse_country WHERE country_3_code='".$shopper->country."'";
		$db->setQuery($query);
		$shopper->country = $db->loadResult();
		
		//PayPal Account Email
		if(
			$this->_params->get('my_paypal_sandbox') &&
			$this->_params->get('my_paypal_sandbox_email')
		){
			$merchant_email = $this->_params->get('my_paypal_sandbox_email');
		}elseif(
			$this->_params->get('my_paypal_micropayments') && 
			$this->_params->get('my_paypal_micropayments_cutoff') >= $order->order_total &&
			$this->_params->get('my_paypal_micro_email') != ''
		){
			$merchant_email = $this->_params->get('my_paypal_micro_email');
		}else{

			$merchant_email = $this->_params->get('my_paypal_email');
		}
		
		//Shopper Email
		if($this->_params->get('my_paypal_sandbox') && $this->_params->get('my_paypal_sandbox_customer_email')){
			$shopper_email = $this->_params->get('my_paypal_sandbox_customer_email');
		}else{
			$shopper_email = $shopper->email;
		}
		
		
		$string = '
		<form action="'.PAYMENT_URL.'" method="post" name="adminForm" >
	    <input type="hidden" name="amount" value="'.sprintf("%.2f", $order->order_subtotal).'" />
		<input type="hidden" name="tax_cart"        value="'. $order->tax_total.'" />
		<input type="hidden" name="return"          value="'. JURI::base().'"index.php?option=com_mymuse&task=thankyou&Itemid='.$Itemid.'" />
		<input type="hidden" name="cancel_return"   value="'. JURI::base().'"index.php?option=com_mymuse&task=paypalcancel&Itemid='.$Itemid.'" />
		<input type="hidden" name="notify_url"      value="'. JURI::base().'"index.php?option=com_mymuse&task=notify" />
		
		<input type="hidden" name="cmd"             value="_cart" />
		<input type="hidden" name="business"        value="'. $merchant_email.'" />
		<input type="hidden" name="custom"          value="'. $order->order_number.'" />
		<input type="hidden" name="upload"          value="1" />
		<input type="hidden" name="currency_code"   value="'. $store->currency.'" />
		<input type="hidden" name="item_name"       value="'. $store->title.'" />
		<input type="hidden" name="item_number"     value="'. $order->order_number.'" />
		<input type="hidden" name="first_name"      value="'. $shopper->first_name.'" />
		<input type="hidden" name="last_name"       value="'. $shopper->last_name.'" />
		<input type="hidden" name="address_street"  value="'. $shopper->address_1." ".$shopper->address_2.'" />
		<input type="hidden" name="address_city"    value="'. $shopper->city.'" />
		<input type="hidden" name="address_state"   value="'. $shopper->state.'" />
		<input type="hidden" name="address_country" value="'. $shopper->country.'" />
		<input type="hidden" name="address_zip"     value="'. $shopper->zip.'" />
		<input type="hidden" name="address1"  		value="'. $shopper->address_1.'" />
		<input type="hidden" name="address2"  		value="'. $shopper->address_2.'" />
		<input type="hidden" name="city"    		value="'. $shopper->city.'" />
		<input type="hidden" name="state"   		value="'. $shopper->state.'" />
		<input type="hidden" name="country" 		value="'. $shopper->country.'" />
		<input type="hidden" name="zip"     		value="'. $shopper->zip.'" />
		<input type="hidden" name="payer_email"     value="'. $shopper_email.'" />
		

		';
		
		for ($i=0;$i<$order->idx;$i++) { 
			$j = $i+1;
			$string .= '


        	<input type="hidden" name="item_name_'. $j .'"
			value="'. $order->items[$i]->title.'" />
			<input type="hidden" name="quantity_'. $j .'"
			value="'. $order->items[$i]->quantity.'" />
			<input type="hidden" name="amount_'. $j .'"
			value="'. $order->items[$i]->product_item_price.'" />
			';
		}
		$string .= '

		<input type="hidden" name="amount" value="'.sprintf("%.2f", $order->order_subtotal).'" />
		<input type="hidden" name="tax_cart"        value="'. $order->tax_total.'" />
		<input type="hidden" name="return"          value="'. JURI::base().'"index.php?option=com_mymuse&task=thankyou&Itemid='.$Itemid.'" />
		<input type="hidden" name="cancel_return"   value="'. JURI::base().'"index.php?option=com_mymuse&task=paypalcancel&Itemid='.$Itemid.'" />
		<input type="hidden" name="notify_url"      value="'. JURI::base().'"index.php?option=com_mymuse&task=notify" />
		';

		if($params->get('my_use_shipping') && $order->order_shipping > 0){
			$string .= '<input type="hidden" name="shipping_1" value="'. $order->order_shipping.'" />
			';
		}
		$string .= '
		<div id="paypal_form">
		<input type="submit" class="button" name="paypal" value="'. JText::_('Pay at Pay Pal').'">
		</div>
		</form>
		';
		
		return $string;
	}

}

?>

