<?php
/**
 * @version		$Id: controller.php 171 2010-10-17 14:16:00Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class MyMuseController extends JController
{
		
	/**
	 * MyMuseStore object
	 *
	 * @var object
	 */
	var $MyMuseStore = null;
	
	/**
	 * MyMuseCart object
	 *
	 * @var object
	 */
	var $MyMuseCart = null;
	
	/**
	 * MyMuseCheckout object
	 *
	 * @var object
	 */
	var $MyMuseCheckout = null;
	
	/**
	 * MyMuseShopper object
	 *
	 * @var object
	 */
	var $MyMuseShopper = null;
	
	/**
	 * params object
	 *
	 * @var object
	 */
	var $params = null;
	
	/**
	 * Custom Constructor
	 */
	function __construct()
	{
		global $mainframe,$params,$store,$shopper;
		parent::__construct();

		$this->MyMuseStore	=& MyMuse::getObject('store','models');
		$store				= $this->MyMuseStore->getStore();
		
		$params				=& $mainframe->getParams('com_mymuse');
		$params->merge( new JParameter( $store->params ) );
		
		if($params->get('my_use_shipping')){
			$this->MyMuseShipping =& MyMuse::getObject('shipping','helpers');
		}
				
		$params->set('my_section_catalog',$store->my_section_catalog);
		$params->set('my_section_artists',$store->my_section_artists);
		$params->set('my_reviews_catid',$store->my_reviews_catid);
		$params->set('my_version',$store->version);
		
		$this->params= $params;
		$GLOBALS['params'] = $params;
		
		$this->MyMuseCart		=& MyMuse::getObject('cart','helpers');
		$this->MyMuseCheckout 	=& MyMuse::getObject('checkout','helpers');
		$this->MyMuseShopper 	=& MyMuse::getObject('shopper','models');
		$shopper 				=  $this->MyMuseShopper->getShopper();
		
	}

	
	/**
	 * Method to display
	 *
	 * @access	public
	 */
	function display()
	{


		// Set a default view if none exists
		if ( !JRequest::getCmd( 'view' ) ) {
			JRequest::setVar('view', 'store');
		}
		// View caching logic -- simple... are we logged in?
		$user = &JFactory::getUser();

		if ($user->get('id')) {
			parent::display(false);
		} else {
			parent::display(true);
		}
	}



	function addtocart()
	{
		if(!$this->MyMuseCart->addToCart( )){
			$msg = $this->MyMuseCart->error;
			$this->setRedirect( 'index.php?option=com_mymuse&task=showcart', $msg );
			return false;
		}

		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();
		
	}

	function updatecart()
	{
		
		if(!$this->MyMuseCart->updateCart( )){
			$msg = $this->MyMuseCart->error;
			$this->redirect( 'index.php?option=com_mymuse&task=showcart', $msg );
			return false;
		}
		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();
	}

	function cartdelete()
	{

		$product_id = JRequest::getVar('product_id',0);
		if(!$this->MyMuseCart->delete($product_id )){
			$msg = $this->MyMuseCart->error;
			$this->setRedirect( 'index.php?option=com_mymuse&task=showcart', $msg );
			return false;
		}
		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();
	}

	function showcart()
	{
		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();
	}

	function coupon()
	{
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			$this->display();
	}
	
	function checkout()
	{
		global $mainframe;
		
		$shopper =  $this->MyMuseShopper->getShopper();

		if(!$shopper->perms){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'register');
			$this->display();
		}elseif($this->params->get('my_use_shipping') && !isset($this->MyMuseCart->cart['ship_method_id']) ){
			JRequest::setVar('task', 'shipping');
			$this->shipping();
			return true;
			
		}elseif($this->MyMuseCart->cart['idx']){
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			$this->display();
		}else{
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			$this->display();
		}
	}
	
	function shipping()
	{

		$shopper =  $this->MyMuseShopper->getShopper();
		if(!isset($shopper->perms)){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'register');
			$this->display();
		}elseif($this->MyMuseCart->cart['idx']){
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			$this->display();
		}else{
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			$this->display();
		}
	}
	
	function confirm()
	{
		global $mainframe;

		$shopper =  $this->MyMuseShopper->getShopper();
		if(!$shopper->perms){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'register');
			$this->display();
			return true;
		}
		if($this->params->get('my_use_shipping')){
			$shipmethodid = JRequest::getVar('shipmethodid', 0);
			if(!$this->MyMuseShipping->validateShipMethidId($shipmethodid)){
				$msg = JText::_('MYMUSE SHIP METHOD ID IS NOT VALID');
				$this->setRedirect( 'index.php?option=com_mymuse&task=shipping', $msg );
				return false;
			}else{
				$this->MyMuseCart->cart['shipping'] = $this->MyMuseShipping->calculateShipping($this->MyMuseCart->cart);
				$this->MyMuseCart->cart['shipmethodid'] = $shipmethodid;
			}
		}

		if($this->MyMuseCart->cart['idx']){
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			// save the order
			if(!$this->MyMuseShopper->order = $this->MyMuseCheckout->save( )){
				$msg = $this->MyMuseCheckout->error;
				$this->setRedirect( 'index.php?option=com_mymuse&task=showcart', $msg );
				return false;
			}

			$this->MyMuseCart->cart['orderid'] = $this->MyMuseShopper->order->id;
			$this->display();
	
		}else{
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'cart');
			$this->display();
		}
	}

	function makepayment()
	{
		global $mainframe;
		
		$shopper =  $this->MyMuseShopper->getShopper();
		
		if(!$shopper->perms){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'register');
			$this->display();
			
		}elseif($this->MyMuseCart->cart['orderid']){
			
			$this->MyMuseShopper->order = $this->MyMuseCheckout->getOrder($this->MyMuseCart->cart['orderid']);
			
			if($this->params->get('my_shop_test')){
				JRequest::setVar('view', 'cart');
				JRequest::setVar('layout', 'cart');
				$this->display();

			}else{
				JRequest::setVar('task', 'thankyou');
				JRequest::setVar('view', 'cart');
				JRequest::setVar('layout', 'cart');
				$this->display();
			}
		}else{
			JRequest::setVar('view', 'cart');
			JRequest::setVar('layout', 'empty');
			$this->display();
		}

	}

	function thankyou()
	{
		//get order
		$db 		=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$user_id 	= $user->get('id');
		$id 		= JRequest::getVar('id', 0);
		$session 	= &JFactory::getSession();
		$order_number = $session->get("order_number",0);

		if($order_number){
			$id = $order_number;
		}
		if($order_number){
			$q = "SELECT id from #__mymuse_order WHERE order_number='".$order_number."' ORDER BY id DESC";
			$db->setQuery($q);
			$id = $db->loadResult();
		}
		
		$this->MyMuseShopper->order = $this->MyMuseCheckout->getOrder( $id );

		if($this->MyMuseShopper->order->user_id != $user_id ){
			// not the right user!!
			$msg = JText::_("MYMUSE USER ORDER OWNER MISMATCH");
			$this->setRedirect("index.php", $msg);
			return false;
		}
		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();
	}


		 
	function paypalcancel()
	{
		//get order
		$db 		=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$user_id 	= $user->get('id');
		$id 		= JRequest::getVar('id', 0);
		$session 	= &JFactory::getSession();
		$order_number = $session->get("order_number",0);

		if($order_number){
			$q = "SELECT id from #__mymuse_order WHERE order_number='".$order_number."' ORDER BY id DESC";
			$db->setQuery($q);
			$id = $db->loadResult();
		}
		
		$this->MyMuseShopper->order = $this->MyMuseCheckout->getOrder( $id );

		if($this->MyMuseShopper->order->user_id != $user_id ){
			// not the right user!!
			$msg = JText::_("MYMUSE USER ORDER OWNER MISMATCH");
			$this->setRedirect("index.php", $msg);
			return false;
		}
		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();
	}
		 
	function register()
	{
		JRequest::setVar('view', 'shopper');
		JRequest::setVar('layout', 'register');
		$this->display();
	}
	
	function shopperadd()
	{

		JRequest::setVar('task', 'save');

		if(!$this->MyMuseShopper->registerSave()){
			$message = $this->MyMuseShopper->error;
			$this->setRedirect("index.php?option=com_mymuse&task=register",$message);
			return false;
		}
		
		JRequest::setVar('view', 'shopper');
		JRequest::setVar('layout', 'register_thankyou');
		$this->display();

	}

	function shopperedit()
	{
		JRequest::setVar('view', 'shopper');
		JRequest::setVar('layout', 'edit');
		$this->display();
	}
	
	function shoppersave()
	{
		if(!$this->MyMuseShopper->save()){
			return false;
		}
		return true;
	}

	function login()
	{

		$this->MyMuseShopper->login();
		return true;
	}
		 
	function logout()
	{
		$this->MyMuseShopper->logout();
	}

	function downloads()
	{
		$shopper =  $this->MyMuseShopper->getShopper();
		if(!$shopper->perms){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'login_to_download');
			$this->display();
			return true;
		}

		JRequest::setVar('view', 'store');
		JRequest::setVar('layout', 'store');
		$this->display();
		return true;
	}
		 
	function downloadfile()
	{
		$shopper =  $this->MyMuseShopper->getShopper();
		if(!isset($shopper->perms)){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'register');
			$this->display();
			return true;
		}
		JRequest::setVar('view', 'store');
		JRequest::setVar('layout', 'store');
		$this->display();
		return true;
	}
		 
	function downloadarchive()
	{
		$shopper =  $this->MyMuseShopper->getShopper();
		if(!isset($shopper->perms)){
			JRequest::setVar('view', 'shopper');
			JRequest::setVar('layout', 'register');
			$this->display();
			return true;
		}
		JRequest::setVar('view', 'store');
		JRequest::setVar('layout', 'store');
		$this->display();
		return true;
	}
		 

	/**
	 * notify
	 * catch the IPN post from PayPal, return required responses, update orders and do mailouts
	 * 
	 * @param object $MyMuse
	 */
	function notify()
	{

		JRequest::setVar('view', 'cart');
		JRequest::setVar('layout', 'cart');
		$this->display();

	}
	


}
?>