<?php
/**
 * @version		$Id: cart.php 149 2010-10-10 19:32:41Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

class MyMuseCart {

	/**
	 * Constructor
	 *
	 */
	function __construct()
	{
		// Register the cart
		$session = &JFactory::getSession();
		if (!$session->get("cart",0)) {
			$this->cart = array();
			$this->cart["idx"] = 0;
		}else{
			$this->cart = $session->get("cart");
		}
	}
	
	/**
	 * cart
	 *
	 * array
	 */
	var $cart = null;
	
	
    /**
    * var error
    */
 	var $error = null;
 	
    /**
     * addToCart
     * 
     * @param array $cart The session cart
     * @param array $catid The category ids of the product
     * @param array $productid The product ids
     * @param array $quantity The quantities of the products
     * @param int $parentid Possible parentid
     * @return bool
     */
  
  function addToCart() {

    // Process the cart preparation plugins
    $dispatcher	=& JDispatcher::getInstance();
	JPluginHelper::importPlugin('system');
	$results = $dispatcher->trigger('onBeforeAddToCart', array (&$_POST, &$this->cart ));

	
    global $mainframe, $params;
    
    $catid = JRequest::getVar('catid',  0, '', 'int');
    $parentid = JRequest::getVar('parentid',  0, '', 'int');
    $productid = JRequest::getVar('productid',  0, '', 'array');
    $quantity = JRequest::getVar('quantity',  0, '', 'array');
    $Itemid = JRequest::getVar('Itemid',  0, '', 'int');


    if(!$productid[0]){
    	$this->error = JText::_("MYMUSE NO ITEMS CHOSEN");
    	return false;
    }
    $db	= & JFactory::getDBO();   

    if(!@$productid){
        $this->error = JText::_("MYMUSE PLEASE SELECT PRODUCT");
        return false;
    }

    if (!is_array($productid)) {
        $prod_id = $productid;
        $productid = array();
        $productid["0"] = $prod_id;

    }
    
    if(!$quantity){
        foreach($productid as $pid){
        	$quantity[$pid] = 1;
        }
    }
    
    if (!is_array($quantity)) {
        $quant = $quantity;
        $quantity = array();
        $quantity[$productid["0"]] = $quant;

    }

    if ($catid && !is_array($catid)) {
    	$c = $catid;
    	$catid = array();
    	foreach($productid as $pid){
        	$catid[$pid] = $c;
        }
    }
    reset($productid);

    // FOR EACH PRODUCT  IN ARRAY

    while(list($key,$val)=each($productid)) {
     	$product_id = $val;
     	
     	if(!isset($quantity[$val])){
         	$quantity[$val] =1;
     	}
     	$quant = $quantity[$val];
     	$category_id = $catid[$val];

     	// Check for negative quantity
     	if ($quant < 0) {
          	$this->error = JText::_('MYMUSE NEGATIVE QUANTITY');
          	return False;
     	}

     	if (!is_numeric($quant)) {
            $this->error = JText::_('MYMUSE INVALID QUANTITY');
            return False; 
     	}

		$q = "SELECT product_in_stock, product_physical ";
     	$q .= "FROM #__mymuse_product ";
     	$q .= "WHERE id= $product_id ";

     	$db->setQuery($q);
     	$res = $db->loadObject();
     	$product_physical = $res->product_physical;
     	// Check to see if checking stock quantity
     	if ($params->get('my_check_stock',0)) {
     		
     		if($res->product_physical){
     			if ($quant > $res->product_in_stock) {
     				$this->error = JText::_('MYMUSE EXCEEDS AVAILABLE STOCK');
     				$this->error .= JText::_('MYMUSE AVAILABLE STOCK')." ".$res->product_in_stock;
     				return False;
     			}
     		}
        }

        $updated = 0;
        // Check for duplicate and do not add to current quantity
        for ($i=0;$i<$this->cart["idx"];$i++) {
              if (@$this->cart[$i]["product_id"] == $product_id) {
                    $updated = 1;
                    $this->cart[$i]["quantity"] += $quantity[$val];
              }
        }
    
        // If we did not update then add the item
        if (!$updated) {
            $this->cart[$this->cart["idx"]]["quantity"] = $quant;
            $this->cart[$this->cart["idx"]]["product_id"] = $product_id;
            $this->cart[$this->cart["idx"]]["catid"] = $category_id;
            $this->cart[$this->cart["idx"]]["product_physical"] = $product_physical;
            $this->cart["idx"]++;
        }
    } // end of while loop

    return True; 
  }


    /**
     * updateCart
     * 
     * @param array $cart The session cart
     * @param array $productid The product ids
     * @param array $quantity The quantities of the products
     * @return bool
     */ 
  	function updateCart( ) 
  	{
		global $mainframe, $params;
    
    	$catid = JRequest::getVar('catid',  0, '', 'int');
    	$parentid = JRequest::getVar('parentid',  0, '', 'int');
    	$productid = JRequest::getVar('productid',  0, '', 'array');
    	$quantity = JRequest::getVar('quantity',  0, '', 'array');
    	$Itemid = JRequest::getVar('Itemid',  0, '', 'int');

 
    	$db  = & JFactory::getDBO();;
        if(!@$productid){
            $this->error = JText::_('MYMUSE CANT UPDATE CART');
            return false;
        }
    
        if (!is_array(@$productid)) {
            $prod_id = $productid;
            $productid = array();
            $productid["0"] = $prod_id;
    
        }
    
        if (!is_array(@$quantity)) {
            $quant = $quantity;
            $quantity = array();
            $quantity[$productid["0"]] = $quant;
    
        }

        reset($productid);
    
        // FOR EACH PRODUCT  IN ARRAY
    
        while(list($key,$val)=each($productid)) {
            $product_id = $val;
            $quant = $quantity[$val];
    
            // Check for negative quantity
            if ($quant < 0) {
                $this->error = JText::_('MYMUSE NEGATIVE QUANTITY');
                return False;
            }
    
            if (!preg_match("/^[0-9]*$/", $quant)) {
                $this->error = JText::_('MYMUSE INVALID QUANTITY');
                return False;
            }
    
            // Check to see if checking stock quantity
            if ($params->get('my_check_stock',0)) {
            	$q = "SELECT product_in_stock ";
            	$q .= "FROM #__mymuse_product ";
            	$q .= "WHERE pid= $product_id ";
            	$db->setQuery($q);

            	$product_in_stock = $db->loadResult();
            	if ($quant > $product_in_stock) {
            		$this->error = JText::_('MYMUSE EXCEEDS AVAILABLE STOCK');
            		$this->error .= JText::_('MYMUSE AVAILABLE STOCK')." ".$product_in_stock;
            		return False;
            	}
            }
    
            if ($quant == 0) {
                $this->delete($product_id);
            }else {
    
                for ($i=0;$i<$this->cart["idx"];$i++) {
                    if ($this->cart[$i]["product_id"] == $product_id) {
                        $this->cart[$i]["quantity"] = $quant;
                    }
                }
            }
        }

        return True;
  	}
  
    /**
     * delete remove an item from the cart
     * 
     * @param array $cart The session cart
     * @param int $product_id
     * @return bool
     */    
  	function delete($product_id) {

  		$temp = array();

  		$j = 0;
  		for ($i=0;$i<$this->cart["idx"];$i++) {

  			if ($this->cart[$i]['product_id'] != $product_id) {
  				$temp[$j++] = $this->cart[$i];
  			}
  		}
  		$temp["idx"] = $j;
  		$this->cart = $temp;
  		return True;
  	}


    /**
     * reset
     * clear the cart
     *
     * @global $cart 
     * @return bool
     */   
  	function reset() { 

    	$this->cart = array();
    	$this->cart["idx"]=0;
    	return True;
  	}
  	
  	
  	function buildOrder($edit=true )
  	{
		global $mainframe, $params;
		
		$MyMuseCheckout =& MyMuse::getObject('checkout','helpers');
		$MyMuseShopper  =& MyMuse::getObject('shopper','models');
		$shopper 		= $MyMuseShopper->getShopper(); 
		$MyMuseStore  	=& MyMuse::getObject('store','models');
		$store 			= $MyMuseStore->getStore(); 
		$MyMuseProduct 	=& MyMuse::getObject('product','models');
		

		$Itemid		= JRequest::getVar('Itemid', '');
		$db	= & JFactory::getDBO();
		require_once( MYMUSE_ADMIN_PATH.DS.'tables'.DS.'product.php');

		// just check that there is an order_item
		if ($this->cart["idx"] == 0) {
			$this->error = JText::_("MYMUSE YOUR CART IS EMPTY");
 			return false;
		}
		
	    // FOR THE ORDER
		$order = new stdClass();
		$order->order_subtotal    		= 0.00;
		$order->must_pay_now    		= 0.00;
		$order->tax_total     			= 0.00;
		$order->coupon_discount 		= 0.00;
		$order->reservation_fee 		= 0.00;
		$order->reservation_fees 		= array();
		$order->non_res_total 			= 0.00;
		$order->order_shipping 			= 0.00;
		$order->need_shipping 			= 0;
		$order->order_total 			= 0.00;
		

		$order->idx 			= $this->cart["idx"];
		$order->update_form 	= '
            <!-- update form -->
          <FORM ACTION="'.JURI::base().'" METHOD="POST" name="update">
          <input type=hidden name="option" value="com_mymuse">
          <input type=hidden name="task" value="updatecart">
          <input type=hidden name="Itemid" value="'.$Itemid.'">
          <input type=hidden name="ship_to_info_id" value="'.@$ship_to_info_id.'" >
          ';

		// FOR EACH CART ITEM
		for ($i=0;$i<$this->cart["idx"];$i++) {
			
			/**
			$item = $this->getProduct($this->cart[$i]['product_id']);
			$order->items[$i] = new stdClass;
			$order->items[$i]->id = $this->cart[$i]['product_id'];

			$order->items[$i]->category_id = $item->artist->id;
			$order->items[$i]->category_name = $item->artist->title;
			$order->items[$i]->product_sku = $item->product_sku;
			$order->items[$i]->title = $item->title;
			$order->items[$i]->section_id = $item->artist->section;
			$order->items[$i]->product_physical = $item->product_physical;
			$order->items[$i]->parentid = $item->parentid;
			$order->items[$i]->reservation_fee = $item->reservation_fee;
			*/
			$order->items[$i] = $this->getProduct($this->cart[$i]['product_id']);
			$order->items[$i]->order_item_total = 0.00;
			$order->items[$i]->not_in_total = 0;
			
			if($order->items[$i]->product_physical){
				$order->need_shipping = 1;
			}
			
			if($order->items[$i]->title == ""){
				$order->items[$i]->title = $item->parent->title;
				
			}

			
			// Get attributes
			if (isset($order->items[$i]->parentid) && $order->items[$i]->parentid > 0) {
				/**
			 	* already done adding attribute to title??
				$attributes = $MyMuseProduct->getAttributes( $order->items[$i]->id, $order->items[$i]->parentid);
				if($attributes){
					foreach ($attributes as $attribute){
						$order->items[$i]->title .= " (" . $attribute->attribute_value . ") ";
					}
				}
				*/
				if($item->parent->reservation_fee > 0){
					$order->reservation_fees[$item->parent->id] = $item->parent->reservation_fee;
					$order->items[$i]->not_in_total = 1;
					$order->must_pay_now = $item->parent->reservation_fee;
				}
				
			}
			

			$order->items[$i]->quantity = $this->cart[$i]['quantity'];

			$order->update_form .= '
            <input type=hidden name="productid['.$i.']" value="'.$order->items[$i]->id.'">
            
            ';

			// GET PRICES
			$price = MyMuseModelProduct::getPrice($order->items[$i]);
			$order->items[$i]->product_item_price = $price['product_price'];
			$order->items[$i]->product_item_subtotal = $price['product_price'] * $order->items[$i]->quantity;
			$order->items[$i]->product_item_subtotal = sprintf("%.2f", $order->items[$i]->product_item_subtotal);


			// add to order sub_total
			$order->order_subtotal += $order->items[$i]->product_item_subtotal ;
			if(!$order->items[$i]->not_in_total){
				$order->non_res_total += $order->items[$i]->product_item_subtotal;
				$order->must_pay_now += $order->items[$i]->product_item_subtotal;
			}


			$order->items[$i]->delete_url .= "index.php?option=com_mymuse";
			$order->items[$i]->delete_url .= "&task=cartdelete";
			$order->items[$i]->delete_url .= "&product_id=".$order->items[$i]->id;

			

			// Build URL 
			if ($order->items[$i]->parentid){
				$pid = $order->items[$i]->parentid;
				$aid = $order->items[$i]->parent->artistid;
			}else{
				$pid = $order->items[$i]->id;
				$aid = $order->items[$i]->artistid;
			}

			$order->items[$i]->url = myMuseHelperRoute::getProductRoute($pid, $aid);
			$order->items[$i]->cat_url = myMuseHelperRoute::getCategoryRoute($aid, $order->items[$i]->section_id, $params);

		
		
		} //end of cart items

		//RESERVATION FEES
		if(count($order->reservation_fees)){
			foreach($order->reservation_fees as $fee){
				$order->reservation_fee += $fee;
			}
		}
		//COUPONS
		if($params->get('my_use_coupons') && @$coupon_id){

			$db->setQuery("SELECT * from coupon where coupon_id='".$coupon_id."'");
			$coupon = $db->loadObject();
			$order->coupon_discount = $coupon->coupon_discount;
			$order->coupon_name = $coupon->coupon_name;
			$order->order_subtotal = $order->order_subtotal-($coupon->coupon_discount * $order->order_subtotal/100);

		}

		// SHIPPING
		if ($params->get('my_use_shipping') && isset($this->cart['shipmethodid'])
		 && isset($this->cart['shipping'])) {
				$order->order_shipping = $this->cart['shipping'];
		}

		//TAXES
		$order_tax = $MyMuseCheckout->calc_order_tax($order->order_subtotal);
		while(list($key,$val) = each($order_tax)){
			$val = round($val,2);
			$order->tax_total += $val;
			$order->tax_array[$key] = sprintf("%.2f", $val);

		}
		
		$order->update_url = '<a class="links" href="" onClick="';
		$order->update_url .= "javascript:document.update.submit(); return false;";
		$order->update_url .= '">';
			
		// SPRINT
		$order->order_subtotal = sprintf("%.2f", $order->order_subtotal);
		$order->order_total  = $order->order_subtotal + @$order->tax_total + @$order->order_shipping;
		$order->order_total = sprintf("%.2f", $order->order_total);
		$order->reservation_fee = sprintf("%.2f", $order->reservation_fee);
		$order->non_res_total = sprintf("%.2f", $order->non_res_total);
		$order->must_pay_now = sprintf("%.2f", $order->must_pay_now);

		if(!$edit){
			$order->do_html = 0;
		}else{
			$order->do_html = 1;
		}

		$order->colspan=3;
		$order->colspan2 = 1;
		if(@$order->do_html){
			$order->colspan2 = 1;
		}

		$dispatcher	=& JDispatcher::getInstance();
		$result = $dispatcher->trigger('onAfterBuildOrder', array(&$order));
		if(count($result)){
			$order = $result[0];
		}
		return $order;
	}
	
	

	
	/**
	 * getProduct
	 * 
	 * @param int $id The product id
	 * @return object The product object
	 */
	function getProduct($id=null)
	{
		global $mainframe, $params;
		
		$MyMuseShopper  =&MyMuse::getObject('shopper','models');
		$shopper = $MyMuseShopper->getShopper();
		$MyMuseProduct 	=& MyMuse::getObject('product','models');
		
		if(!$id){
			$this->error = JText::_("MYMUSE NO PRODUCT ID");
			return false;
		}
		$db	= & JFactory::getDBO();
		require_once( MYMUSE_ADMIN_PATH.DS.'tables'.DS.'product.php');
		
		$row = new TableProduct($db);
		if(!$row->load($id)){
			echo "Error: ".$db->ErrorMsg();
			return false;
		}
		
		// take out the file_contents
		$row->file_contents = null;
		
		if(isset($shopper->shopper_group_id)){
			$shopper_group_id = $shopper->shopper_group_id;
		}else{
			$shopper_group_id = $params->get("my_default_shopper_group_id");
		}

		require_once( JPATH_COMPONENT.DS.'models'.DS.'product.php');	
		$row->price = $MyMuseProduct->getPrice($row);	
		
		// get parent object
		if($row->parentid){
			$parent = new TableProduct($db);
			$parent->load($row->parentid);
			$row->parent = $parent;
			$artistid = $row->parent->artistid;
			// Get attributes

			$attributes = $MyMuseProduct->getAttributes( $row->id, $row->parentid);
			if($attributes){
				foreach ($attributes as $attribute){
					$row->title .= " (" . $attribute->attribute_value . ") ";
				}
			}

		}else{
			$artistid = $row->artistid;
		}

		
		// get the artist object
		require_once( MYMUSE_ADMIN_PATH.DS.'tables'.DS.'category.php');
		$cat = new TableCategory($db);
		$cat->load($artistid);
		$row->artist = $cat;

		return $row;
	}
}

?>
