<?php
/**
 * @version		$Id: route.php 155 2010-10-12 04:01:01Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Component Helper
jimport('joomla.application.component.helper');

/**
 * Content Component Route Helper
 *
 * @static
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class myMuseHelperRoute
{
	/**
	 * @param	int	The route of the content item
	 */
	function getProductRoute($id, $catid = 0, $sectionid = 0)
	{
		$needles = array(
			'product'  => (int) $id,

		);

		//Create the link
		$link = 'index.php?option=com_mymuse&view=product&id='. $id;

		if($catid) {
			$link .= '&catid='.$catid;
		}
		
		if($item = MyMuseHelperRoute::_findItem($needles)) {
			$link = $item->link;
			$link .= '&Itemid='.$item->id;
		};

		return $link;
	}

	function getSectionRoute($sectionid)
	{
		$needles = array(
			'section' => (int) $sectionid
		);

		//Create the link
		$link = 'index.php?option=com_mymuse&view=section&id='.$sectionid;

		if($item = MyMuseHelperRoute::_findItem($needles)) {
			$link = $item->link;
			$link .= '&Itemid='.$item->id;
		}

		return $link;
	}

	function getCategoryRoute($catid, $sectionid, $params)
	{
		$needles = array(
			'category' => (int) $catid,
			'section'  => (int) $sectionid
		);

		//Create the link
		$link = 'index.php?option=com_mymuse&view=category&id='.$catid;

		if($item = MyMuseHelperRoute::_findItem($needles)) {
			$link = $item->link;
			$link .= '&Itemid='.$item->id;
		}else{
			// add the default layout
			if($params->get('my_category_layout')) {
				$link .= '&layout='.$params->get('my_category_layout');
			}
		}


		return $link;
	}

	function _findItem($needles)
	{
		$component =& JComponentHelper::getComponent('com_mymuse');

		$menus	= &JApplication::getMenu('site', array());
		$items	= $menus->getItems('componentid', $component->id);

		$match = null;

		foreach($needles as $needle => $id)
		{
			if(count($items)){
				foreach($items as $item)
				{

					if ((@$item->query['view'] == $needle) && (@$item->query['id'] == $id)) {
						$match = $item;
						break;
					}
				}

				if(isset($match)) {
					break;
				}
			}
		}

		return $match;
	}
}
?>
