<?php
/**
 * @version		$Id: shopper.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );



class MyMuseShopper
{
	
	/**
	 * var object The shopper
	 */
	var $shopper = null;
	
	/**
	 * var string Error
	 */
	var $error = "";
	
	function __construct( $user = null)
	{
		if($user){
			$id = $user->get('id');
			if($id){
				$this->shopper = $this->getShopperByUser($user);
			}
		}
		
		
	}
	/**
	 * getShopper
	 * 
	 * @param int $id The user_info_table id
	 * @return mixed The shopper object or false
	 */
	function getShopper($shopperid=0)
	{
		$db	= & JFactory::getDBO();
		if ($shopperid){
			$shopper = new JTableMyMuseShopper($db);
			$shopper->load( $shopperid );
			return $shopper;
		}else{
			return false;
		}

	}
	
	
	/**
	 * getShopperByUser
	 * 
	 * @param object $user The user object
	 * @return mixed object The shopper object or false
	 */
	function getShopperByUser(&$user = null)
	{
		if($user){
			$db	= & JFactory::getDBO();
			$user_id = $user->get('id');
			$query = 'SELECT user_info_id'
			. ' FROM #__mymuse_user_info'
			. ' WHERE user_id = '.$user_id
			. ' AND address_type="bt" '
			;
			$db->setQuery( $query );
			$user_info_id = $db->loadResult();
			$shopper = new JTableMyMuseShopper($db);
			if ($user_info_id){
				$shopper->load( $user_info_id );
				$shopper->email = $user->email;
				return $shopper;
			}
		}
		return false;

	}


	
	

	
	function cancel()
	{
		$this->setRedirect( 'index.php' );
	}


	/**
	 * login and set up shopper object
	 * 
	 * @global $mainframe
	 */
	function login()
	{
		
		// Check for request forgeries
		//JRequest::checkToken('request') or jexit( 'Invalid Token' );

		global $mainframe;

		if ($return = JRequest::getVar('return', '')) {
			//$return = base64_decode($return);
			if (!JURI::isInternal($return)) {
				$return = '';
			}
		}

		$options = array();
		$options['remember'] = JRequest::getBool('remember', false);
		$options['return'] = $return;
		$options['entry_url'] = $return;
		
		$credentials = array();
		$credentials['username'] = JRequest::getVar('username', '', 'method', 'username');
		$credentials['password'] = JRequest::getString('passwd', '', 'post', JREQUEST_ALLOWRAW);

		//preform the login action
		$error = $mainframe->login($credentials, $options);

		//mymuse section
		$user 	=& JFactory::getUser();
		
		$this->shopper	= $this->getShopperByUser($user);
		
		/**
		$this->user_info_id = $row->user_info_id;
		$this->shopper_group_id = $row->shopper_group_id;
		$this->perms = $row->perms;
		$this->state = $row->state;
		$this->country = $row->country;
		$_SESSION["auth"] = $auth;
		*/
		if(!JError::isError($error))
		{
			// Redirect if the return url is not registration or login
			if ( ! $return ) {
				$return	= 'index.php?option=com_mymuse';
			}

			$mainframe->redirect( $return );
		}
		else
		{
			// Facilitate third party login forms
			if ( ! $return ) {
				$return	= 'index.php?option=com_mymuse&task=login';
			}

			// Redirect to a login form
			$mainframe->redirect( $return );
		}
	}

	/**
	 * logout and clear shopper object
	 * 
	 * @param $cart
	 * @global $mainframe
	 */
	function logout($cart)
	{
		global $mainframe;

		//preform the logout action
		$error = $mainframe->logout();
		$this->shopper = null;
		$_SESSION["cart"] = $cart;
		
		if(!JError::isError($error))
		{
			if ($return = JRequest::getVar('return', '')) {
				//$return = base64_decode($return);
				if (!JURI::isInternal($return)) {
					$return = '';
				}
			}

			// Redirect if the return url is not registration or login
			if ( $return && !( strpos( $return, 'login' )) ) {
				
				$mainframe->redirect( $return );
			}
		} else {
			
			$mainframe->redirect( 'index.php',$error );
		}
	}
	

	
	function forgotPassword()
	{
		// Load the form validation behavior
		JHTML::_('behavior.formvalidation');

		// Add the tooltip behavior
		JHTML::_('behavior.tooltip');
		MyMuseShopperView::forgotPassword();
	}
	
	function forgotUsername()
	{
		MyMuseShopperView::forgotUsername();
	}
	

}