<?php
/**
 * @version		$Id: shopper.php 151 2010-10-10 19:58:52Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.model' );

class mymuseModelShopper extends Jmodel
{
	/**
	 * Shopper id
	 *
	 * @var int
	 */
	var $_id = null;
	
	/**
	 * var object The shopper
	 */
	var $_shopper = null;
	
	/**
	 * var string error
	 */
	var $error = null;
	
	
	
	function __construct( )
	{

		parent::__construct();
		$user	= & JFactory::getUser();
		$this->getShopper();
	}
	
    /**
     * Method to set the shopper identifier
     *
     * @access    public
     * @param    int Product identifier
     * @return    void
     */
    function setId($id)
    {
    	// Set id and wipe data
    	$this->_id        = $id;
    	$this->_data    = null;
    }
    
	/**
	 * getShopper
	 * 
	 * @param object $user The user object
	 * @return mixed object The shopper object or false
	 */
	function getShopper()
	{
		// Lets load the data if it doesn't already exist
        if (empty( $this->_shopper ))
        {
			$user	= & JFactory::getUser();
			if($user->get('id') > 0){
				$db	= & JFactory::getDBO();
				$user_id = $user->get('id');
				$query = 'SELECT id'
				. ' FROM #__mymuse_shopper'
				. ' WHERE user_id = '.$user_id
				. ' AND address_type="BT" '
				;
				$db->setQuery( $query );
				$user_info_id = $db->loadResult();
				$shopper = new TableShopper($db);
				if ($user_info_id){
					$this->setId($user_info_id);
					$shopper->load( $user_info_id );
					$shopper->email = $user->email;
					$this->_shopper = $shopper;
				}
			}else{
				$this->_shopper->id = 0;
				$this->_shopper->shopper_group_id = 0;
				$this->_shopper->state = null;
				$this->_shopper->country = null;
				$this->_shopper->perms = null;
				
			}
			
		}

		return $this->_shopper;

	}
	/**
	 * getShopperByUser
	 * 
	 * @param object $user The user object
	 * @return mixed object The shopper object or false
	 */
	function getShopperByUser($userid = 0)
	{
		// Lets load the data if it doesn't already exist
        if ( $userid  )
        {
			$user	= & JFactory::getUser($userid);
			if($user->get('id') > 0){
				$db	= & JFactory::getDBO();
				$user_id = $user->get('id');
				$query = 'SELECT id'
				. ' FROM #__mymuse_shopper'
				. ' WHERE user_id = '.$user_id
				. ' AND address_type="BT" '
				;
				$db->setQuery( $query );
				$user_info_id = $db->loadResult();
				$shopper = new TableShopper($db);
				if ($user_info_id){
					$this->setId($user_info_id);
					$shopper->load( $user_info_id );
					$shopper->email = $user->email;
					$this->_shopper = $shopper;
				}
			}
			
		}

		return $this->_shopper;

	}
	/**
	 * Save user registration and notify users and admins if required
	 * @return void
	 */
	function registerSave()
	{
		global $mainframe;

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Get required system objects
		$user 		= clone(JFactory::getUser());
		$pathway 	=& $mainframe->getPathway();
		$config		=& JFactory::getConfig();
		$authorize	=& JFactory::getACL();
		$document   =& JFactory::getDocument();
		$first_name    	= JRequest::getVar( 'first_name', '' );
		$last_name    	= JRequest::getVar( 'last_name', '' );
		$option   		= JRequest::getCmd( 'option');
		$_POST['name'] 	= $first_name." ".$last_name;
		$db	= & JFactory::getDBO();

		// If user registration is not allowed, show 403 not authorized.
		$usersConfig = &JComponentHelper::getParams( 'com_users' );
		if ($usersConfig->get('allowUserRegistration') == '0') {
			JError::raiseError( 403, JText::_( 'MYMUSE ALERTNOTAUTH' ));
			return;
		}

		// Initialize new usertype setting
		$newUsertype = $usersConfig->get( 'new_usertype' );
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}

		// Bind the post array to the user object
		if (!$user->bind( JRequest::get('post'), 'usertype' )) {
			$this->error = $user->getError();
			return false;
		}

		// Set some initial user values
		$user->set('id', 0);
		$user->set('usertype', $newUsertype);
		$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));

		$date =& JFactory::getDate();
		$user->set('registerDate', $date->toMySQL());

		// If user activation is turned on, we need to set the activation information
		$useractivation = $usersConfig->get( 'useractivation' );
		if ($useractivation == '1')
		{
			jimport('joomla.user.helper');
			$user->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
			$user->set('block', '1');
		}

		// If there was an error with registration, set the message and display form
		if ( !$user->save() )
		{
			$this->error = $user->getError();
			return false;
		}
		
		// Let's update session!

		// Get an ACL object
		$acl = &JFactory::getACL();

		// Get the user group from the ACL
		$grp = $acl->getAroGroup($user->get('id'));

		// Mark the user as logged in
		$user->set('guest', 0);
		$user->set('aid', 1);

		// Fudge Authors, Editors, Publishers and Super Administrators into the special access group
		if ($acl->is_group_child_of($grp->name, 'Registered')      ||
		$acl->is_group_child_of($grp->name, 'Public Backend'))    {
			$user->set('aid', 2);
		}

		// Set the usertype based on the ACL group name
		$user->set('usertype', $grp->name);

		$session = &JFactory::getSession();
		$session->set('user', $user);

		
		// MyMuse Shopper Info Section 

		$_POST['user_id'] = $user->get('id');
		$_POST['id'] = null;
		$post 	= JRequest::get('post');
		$row = new TableShopper($db);
		
		if (!$row->bind($post)) {
			$this->error = $row->getError();
			return false;
		}
		$now = date('Y-m-d h:i:s');
		$row->created = $now;
		$row->modified = $now;
		
		if (!$row->check()) {
			$this->error = $row->getError();
			return false;
		}

		if (!$row->store()) {
			$this->error = $row->getError();
			return false;
		}
		$this->_shopper = $row;
	
		// Send registration confirmation mail
		$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
		// TODO: enable mailing
		//UserController::_sendMail($user, $password);

		// Everything went fine, set relevant message depending upon user activation state and display message
		if ( $useractivation == 1 ) {
			$message  = JText::_( 'MYMUSE REG_COMPLETE_ACTIVATE' );
		} else {
			$message = JText::_( 'MYMUSE REG_COMPLETE' );
		}

		return true;
	}


	/**
	 * Saves the shopper after an edit form submit
	 *
	 * @global $mainframe
	 */
	function save( )
	{
		
		global $mainframe;
		
		$id    			= JRequest::getVar( 'id', '' );
		$first_name    	= JRequest::getVar( 'first_name', '' );
		$last_name    	= JRequest::getVar( 'last_name', '' );
		$option   		= JRequest::getCmd( 'option');
		$_POST['name'] 	= $first_name." ".$last_name;
		
		
		// Initialize some variables
		$db			= & JFactory::getDBO();
		$acl		= & JFactory::getACL();
		$MailFrom	= $mainframe->getCfg('mailfrom');
		$FromName	= $mainframe->getCfg('fromname');
		$SiteName	= $mainframe->getCfg('sitename');

 		// Create a new JUser object
		$user = new JUser($id);
		$original_gid = $user->get('gid');

		
		$post = JRequest::get('post');
		$post['username']	= JRequest::getVar('username', '', 'post', 'username');
		$post['password']	= JRequest::getVar('password', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['password2']	= JRequest::getVar('password2', '', 'post', 'string', JREQUEST_ALLOWRAW);

		if (!$user->bind($post))
		{
			$mainframe->enqueueMessage(JText::_('MYMUSE CANNOT SAVE THE USER INFORMATION'), 'message');
			$this->error = JText::_('MYMUSE CANNOT SAVE THE USER INFORMATION').' '.$user->getError();
			return false;
		}

		$objectID 	= $acl->get_object_id( 'users', $user->get('id'), 'ARO' );
		$groups 	= $acl->get_object_groups( $objectID, 'ARO' );
		$this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );
		/*
	 	 * Lets save the JUser object
	 	 */
		if (!$user->save())
		{
			$this->error = JText::_('MYMUSE CANNOT SAVE THE USER INFORMATION').' '.$user->getError();
			return false;
		}


		// Let's update session!

		// Get an ACL object
		$acl = &JFactory::getACL();

		// Get the user group from the ACL
		$grp = $acl->getAroGroup($user->get('id'));

		// Mark the user as logged in
		$user->set('guest', 0);
		$user->set('aid', 1);

		// Fudge Authors, Editors, Publishers and Super Administrators into the special access group
		if ($acl->is_group_child_of($grp->name, 'Registered')      ||
		$acl->is_group_child_of($grp->name, 'Public Backend'))    {
			$user->set('aid', 2);
		}

		// Set the usertype based on the ACL group name
		$user->set('usertype', $grp->name);

		$session = &JFactory::getSession();
		$session->set('user', $user);

		
		
		
		// MyMuse User Info Section 
		$_POST['user_id'] = $user->get('id');
		$_POST['id'] = JRequest::getVar('shopperid','');;
		$post 	= JRequest::get('post');
		$row = new TableShopper($db);

		if (!$row->bind($post)) {
			JError::raiseError(500, $row->getError() );
		}
		$now = date('Y-m-d h:i:s');
		if($user_info_id < 1){
			$row->created = $now;
		}
		$row->modified = $now;
		
		if (!$row->check()) {
			JError::raiseError(500, $row->getError() );
		}

		if (!$row->store()) {
			JError::raiseError(500, $row->getError() );
		}
		$this->_shopper = $row;
				
		$msg = JText::_( 'MYMUSE CHANGES TO ACCOUNT SAVED' );
		$mainframe->redirect( 'index.php?option=com_mymuse&task=shopperedit', $msg );
	}

	
	
	function cancel()
	{
		$this->setRedirect( 'index.php' );
	}


	/**
	 * login and set up shopper object
	 * 
	 * @global $mainframe
	 */
	function login()
	{
		
		// Check for request forgeries
		//JRequest::checkToken('request') or jexit( 'Invalid Token' );

		global $mainframe;

		if ($return = JRequest::getVar('return', '')) {
			
			//$return = base64_decode($return);
			if (!JURI::isInternal($return)) {
				$return = '';
			}

		}

		$options = array();
		$options['remember'] = JRequest::getBool('remember', false);
		$options['return'] = $return;

		$credentials = array();
		$credentials['username'] = JRequest::getVar('username', '', 'method', 'username');
		$credentials['password'] = JRequest::getString('passwd', '', 'post', JREQUEST_ALLOWRAW);

		//preform the login action
		$error = $mainframe->login($credentials, $options);

		//mymuse section
		$user 	=& JFactory::getUser();
		
		$this->getShopper();
		
		if(!JError::isError($error))
		{
			// Redirect if the return url is not registration or login
			if ( ! $return ) {
				$return	= 'index.php?option=com_mymuse';
			}

			$mainframe->redirect( $return );
		}
		else
		{
			// Facilitate third party login forms
			if ( ! $return ) {
				$return	= 'index.php?option=com_mymuse&task=login';
			}

			// Redirect to a login form
			$mainframe->redirect( $return );
		}
	}

	/**
	 * logout and clear shopper object
	 * 
	 * @param $cart
	 * @global $mainframe
	 */
	function logout()
	{
		global $mainframe;

		//preform the logout action
		$error = $mainframe->logout();
		$this->shopper = null;
		$_SESSION["cart"] = array();
		
		if(!JError::isError($error))
		{
			if ($return = JRequest::getVar('return', '')) {
				//$return = base64_decode($return);
				if (!JURI::isInternal($return)) {
					$return = '';
				}
			}

			// Redirect if the return url is not registration or login
			if ( $return && !( strpos( $return, 'login' )) ) {
				
				$mainframe->redirect( $return );
			}
		} else {
			
			$mainframe->redirect( 'index.php',$error );
		}
	}
	

	function getOrders()
	{
		
		$user		=& JFactory::getUser();
		$user_id 	= $user->get('id');
		$db			= & JFactory::getDBO();
		$query = "SELECT * from #__mymuse_order WHERE user_id=$user_id ORDER BY created DESC";
		$db->setQuery($query);
		$orders = $db->loadObjectList();

		while(list($key,$order) = each($orders)){
			$orders[$key] = MyMuseCheckout::getOrder($order->id);
			$orders[$key]->url = "index.php?option=com_mymuse&task=thankyou&id=".$order->id;
		}
		
		return $orders;
		
	}
	
	
	function forgotPassword()
	{
		// Load the form validation behavior
		JHTML::_('behavior.formvalidation');

		// Add the tooltip behavior
		JHTML::_('behavior.tooltip');
		MyMuseShopperView::forgotPassword();
	}
	
	function forgotUsername()
	{
		MyMuseShopperView::forgotUsername();
	}
	

}
