<?php

/**
 * @version		$Id: mymuse.class.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

class myMuse
{


	/**
	 * Returns a reference to a global MyMuse object, only creating it if it
	 * doesn't already exist. The default is to look in the helpers directory.
	 *
	 * This method must be invoked as:
	 * 		<pre>  MyMuseShopper 	=& MyMuse::getObject('shopper','models');</pre>
	 *
	 * @access	public
	 * @param	string	$client		type of class.
	 * @param	string	$type 		An optional type, default helpers
	 * @param	array	$config 	An optional associative array of configuration settings.
	 * @return	MyMuse	The MyMuse object.
	 * @since	1.5
	 */
	function &getObject($client, $type='helpers', $config = array(), $prefix = 'MyMuse', $renew = '')
	{
		static $instances;

		if (!isset( $instances )) {
			$instances = array();
		}

		if (empty($instances[$client]) || $renew == "renew")
		{

			$path = JPATH_COMPONENT.DS.$type.DS.$client.'.php';
			if(file_exists($path))
			{
				require_once $path;

				// Create an object
				if($type == 'models'){
					$classname = $prefix.'Model'.ucfirst($client);
				}else{
					$classname = $prefix.ucfirst($client);
				}
				$instance = new $classname($config);
			}
			else
			{
				$error = JError::raiseError(500, 'Unable to load application: '.$client);
				return $error;
			}

			$instances[$client] =& $instance;
		}

		return $instances[$client];
	}
	
}
?>