<?php
/**
 * @version		$Id: view.html.php 171 2010-10-17 14:16:00Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the MyMuse Category 
 *
 * @package		Joomla
 * @subpackage MyMuse
 * @since 1.5
 */
class myMuseViewCart extends JView
{
	function __construct()       {
                parent::__construct();        
        }
        
	function display($tpl = null)
	{
		global $mainframe,$params;
		
		// check payment types
		// my_paypal_enable, my_payoffline_enable
		$choose_payment = 0;
		if($params->get('my_payoffline_enable') && $params->get('my_paypal_enable')){
			$choose_payment = 1;
		}

		$task		= JRequest::getVar('task', '');
		if($task == "notify"){
			$this->notify();
			exit;
		}
		if($task == "coupon"){
			parent::display("coupon"); //
		}
		
		$MyMuseCheckout =& MyMuse::getObject('checkout','helpers');
		$MyMuseCart 	=& MyMuse::getObject('cart','helpers');
		$cart 			=& $MyMuseCart->cart;

		$MyMuseStore	=& MyMuse::getObject('store','models');
		
		$MyMuseShopper  =& MyMuse::getObject('shopper','models');
		$shopper 		=& $MyMuseShopper->getShopper();
		
		$user			=& JFactory::getUser();
		$document		=& JFactory::getDocument();
		$dispatcher		=& JDispatcher::getInstance();
		$pathway		=& $mainframe->getPathway();
		
		$document->setTitle( JText::_('MYMUSE SHOPPING CART') );
	
		
		$Itemid		= JRequest::getVar('Itemid', 0, '', 'int');
		
    	$this->assignRef('Itemid', $Itemid);
		$this->assignRef('user'  , $user);
		$this->assignRef('params', $params);
		$this->assignRef('task', $task);
		$this->assignRef('shopper', $shopper);
		$this->assignRef('store', $MyMuseStore->_store);

		$heading 			= '';
		$footer 			= '';
		$edit 				= true;
		$currency 			= MyMuseHelper::getCurrency($MyMuseStore->_store->currency);
		
		// set the heading at the top of page
		// find the order attached to the shopper object, or build it from session cart
		switch ($task)
		{
			case "checkout":
				$order 		= $MyMuseCart->buildOrder( $edit );
				$heading 	= Jtext::_('MYMUSE CHECKOUT');
				$message 	= Jtext::_('MYMUSE MAKE ANY FINAL CHANGES');
				$order->show_checkout = 0;
				$order->show_summary  = 0;
				break;
				
			case "shipping":
				$order 		= $MyMuseCart->buildOrder( $edit );
				
				if($order->need_shipping){
					$heading 	= Jtext::_('MYMUSE SHIPPING');
					$message 	= Jtext::_('MYMUSE CHOOSE SHIPPING METHOD');
				}else{
					$heading 	= Jtext::_('MYMUSE SHIPPING');
					$message 	= Jtext::_('MYMUSE NO SHIPPING NEEDED');
				}

				$order->show_checkout = 0;
				$order->show_summary  = 0;
				break;
				
			case "confirm":

				$edit 		= false;
				$order 		= $MyMuseCheckout->getOrder($MyMuseShopper->order->id);
				if(isset($MyMuseShopper->order->id) && $order->order_total == 0.00){
					$order 		= $MyMuseCheckout->getOrder($MyMuseShopper->order->id);
					$heading 	= Jtext::_('MYMUSE CONFIRM');
					$message 	= Jtext::_('MYMUSE ACCEPT ORDER');
					$order->show_checkout = 0;
					$order->show_summary  = 0;
					$free = 1;
				}elseif(isset($MyMuseShopper->order->id)){
					
					$heading 	= Jtext::_('MYMUSE CONFIRM');

					if($params->get('my_payoffline_enable')){
						$message 	= Jtext::_('MYMUSE CLICK PAY OFFLINE BUTTON');
					}elseif($params->get('my_paypal_enable')){
						$message 	= Jtext::_('MYMUSE CLICK PAYPAL BUTTON');
					}else{
						$message 	= Jtext::_('MYMUSE CHOOSE PAYMENT METHOD');
					}
					$order->show_checkout = 0;
					$order->show_summary  = 0;
				}

				break;
				
			case "makepayment":
				$order 		= $MyMuseShopper->order;
				$currency 	= $order->order_currency;
				$edit 		= false;
				$heading 	= Jtext::_('MYMUSE THANK YOU');
				$message 	= Jtext::_('MYMUSE WE HAVE RECIEVED YOUR ORDER');
				$order->show_checkout = 0;
				$order->show_summary  = 1;
				break;
				
			case "thankyou":
				$order 		= $MyMuseShopper->order;
				$currency 	= $order->order_currency;
				$edit 		= false;
				$heading 	= Jtext::_('MYMUSE THANK YOU');
				$message 	= Jtext::_('MYMUSE HERE IS YOUR ORDER');
				if($order->downloadable && $order->order_status == "C"){
					$footer .= "<br />".$order->downloadlink;
				}
				$order->show_checkout = 0;
				$order->show_summary  = 1;
				break;
				
			case "paypalcancel":
				$edit 		= false;
				$order 		= $MyMuseCheckout->getOrder($MyMuseShopper->order->id);
				$heading 	= Jtext::_('MYMUSE CONFIRM');
				$message 	= Jtext::_('MYMUSE PAYPAL CANCEL');
				$order->show_checkout = 0;
				$order->show_summary  = 0;
				break;
				
			default:
				$order 		= $MyMuseCart->buildOrder( $edit );
				$order->show_checkout = 1;
				break;
		}

		// check for order
		if(!isset($order->items) || !count($order->items)) {
			//Hmm nothing to display...
			parent::display('empty');
			return false;
		}

		
		$this->assignRef('order', $order);
		$this->assignRef('currency', $currency);
		
		
		// show the heading
		if($heading){
			$this->assignRef('heading', $heading);
			$this->assignRef('message', $message);
			parent::display('checkout_header');
		}
		
		// do we need an order summary? Only if we already have a saved order
		if($task == "makepayment" || $task == "thankyou"){
			parent::display('order_summary');
		}
		
		// display the cart part!
		parent::display(); 
		
		//display the shopper info, if we have one
		if($heading && $user->get('id') > 0){
			parent::display("shopper_info"); //
		}
		

		if($task == "checkout"){
			if($params->get('my_use_shipping')){
				$task = "shipping";
				$button = JText::_("MYMUSE SHIPPING");
			}else{
				$task = "confirm";
				$button  = JText::_("MYMUSE CONFIRM");
			}
			$this->assignRef('button', $button);
			parent::display("next_form");
			
		}elseif($task== "shipping"){
			$db	= & JFactory::getDBO();
			$query = "SELECT * from #__mymuse_shipping WHERE state=1 ORDER BY ordering";
			$db->setQuery($query);
			$shipMethods = $db->loadObjectList();
			$MyMuseShipping =& MyMuse::getObject('shipping','helpers');
			foreach($shipMethods as $sm){
				$MyMuseShipping->shipMethodId = $sm->id;
				$sm->cost = $MyMuseShipping->calculateShipping($cart);
			}
			$this->assignRef('shipMethods', $shipMethods);
			
			
			/* TODO: shipping plugins 

			JPluginHelper::importPlugin('mymuse');
			$results = $dispatcher->trigger('onBeforeMyMuseShipping', 
			array($this->shopper, $this->store, $this->order, $params, $Itemid) );
			$this->assignRef('shipMethods', $results);
			*/
			parent::display("shipping_form");
			
		}elseif($task == "confirm" || $task == "paypalcancel"){
			
			if(isset($free) && $free == 1){
				$task = "makepayment";
				$button = JText::_("MYMUSE ACCEPT");
				$this->assignRef('button', $button);
				parent::display("next_form");
			}
			
			elseif($params->get('my_shop_test')){
				$task = "makepayment";
				$button = JText::_("MYMUSE TEST STORE");
				$this->assignRef('button', $button);
				parent::display("next_form");
			}
			
			else{
				

				 /* payment plugins */

				JPluginHelper::importPlugin('mymuse');
				$results = $dispatcher->trigger('onBeforeMyMusePayment', 
				array($this->shopper, $this->store, $this->order, $params, $Itemid) );
				$this->assignRef('results', $results);
				parent::display("payment_form");


				
			}
			

		}
		
		// show the footer
		if($footer){
			$this->assignRef('footer', $footer);
			parent::display('checkout_footer');
		}

	}
	
	/**
	 * notify
	 * catch the IPN post from PayPal, return required responses, update orders and do mailouts
	 * 
	 */
	function notify()
	{
		global $mainframe, $params;

        header("HTTP/1.0 200 OK");
        
        require_once( MYMUSE_ADMIN_PATH.DS.'helpers'.DS.'helper.php' );
        
		/* plugins should set the PAYMENT_URL */
		JPluginHelper::importPlugin('mymuse');

        $MyMuseStore	=& MyMuse::getObject('store','models');
        $store = $MyMuseStore->_store;
        $db	= & JFactory::getDBO();
        $date = date('Y-m-d h:i:s');
        
  		if($params->get('my_debug')){
        	MyMuseHelper::logMessage( "################################################ \n $date: PayPal notify.php" );
  		}
        $post_msg = "";
        foreach ($_POST as $ipnkey => $ipnval) {
            $post_msg .= "$ipnkey=$ipnval&amp;";
        }
	  	if($params->get('my_debug')){
        	MyMuseHelper::logMessage( "2. Received this POST: $post_msg" );
  		}

  		$order_number = $_POST['custom'];
  		$payer_email = urldecode($_POST['payer_email']);
  		$payment_status = $_POST['payment_status'];
  		$order_status = $_POST['order_status'];
  		
  		$fromname = $store->contact_first_name." ".$store->contact_last_name;
     	$mailfrom = $store->contact_email;
    
        /**
        * Read post from PayPal system and create reply
        * starting with: 'cmd=_notify-validate'...
        * then repeating all values sent: that's our VALIDATION.
        **/
        $workstring = 'cmd=_notify-validate'; // Notify validate
        $i = 1;
        foreach ($_POST as $ipnkey => $ipnval) {
            if (get_magic_quotes_gpc())
                // Fix issue with magic quotes
                $ipnval = stripslashes ($ipnval);
                
            if (!preg_match("^[_0-9a-z-]{1,30}$",$ipnkey)  || !strcasecmp ($ipnkey, 'cmd'))  { 
                // ^ Antidote to potential variable injection and poisoning
                unset ($ipnkey); 
                unset ($ipnval); 
            } 
            // Eliminate the above
            // Remove empty keys (not values)
            if (@$ipnkey != '') { 
            	$workstring.='&'.@$ipnkey.'='.urlencode(@$ipnval); 
            }
        } // Notify string
        
        
        $paypal_receiver_email = $mailfrom;
        $txn_id = trim(stripslashes($_POST['txn_id']));


        /**--------------------------------------------
        * Create message to post back to PayPal...
        * Open a socket to the PayPal server...
        *--------------------------------------------*/


        $paypalpath = "/cgi-bin/webscr";
  
        $header = "POST $paypalpath HTTP/1.0\r\n";
        //$header.= "User-Agent: PHP/".phpversion()."\r\n";
        //$header.= "Referer: ".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].@$_SERVER['QUERY_STRING']."\r\n";
        //$header.= "Server: ".$_SERVER['SERVER_SOFTWARE']."\r\n";
        //$header.= "Host: ".PAYMENT_HOST.":80\r\n";
        $header.= "Content-Type: application/x-www-form-urlencoded\r\n";
        $header.= "Content-Length: ".strlen($workstring)."\r\n";
        $header.= "Accept: */*\r\n\r\n";
        
        $fp = fsockopen ( 'ssl://'.PAYMENT_HOST, 443, $errno, $errstr, 30);
        
		if($params->get('my_debug')){
        	MyMuseHelper::logMessage( "3. Connecting to: ".PAYMENT_HOST.$paypalpath."
        	
                    Using these http Headers: 
                    
                    $header
                    
                    and this String:
                    
                    $workstring");
  		}

        //----------------------------------------------------------------------
        // Check HTTP connection made to PayPal OK, If not, print an error msg
        //----------------------------------------------------------------------
        if (!$fp) {
            $error_description = "$errstr ($errno)
            Status: FAILED";
            
            if($params->get('my_debug')){
        		MyMuseHelper::logMessage("4. Connection failed: $error_description" );
            }
            
            $res = "FAILED";
            
            $subject = "PayPal IPN Fatal Error on your Site";
            $message = "Hello,
            A fatal error occured while processing a paypal transaction.
            ----------------------------------
            Hostname: ".PAYMENT_HOST."
            URI: $paypalpath
            $error_description";
            
            JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
        	if($params->get('my_cc_webmaster')){
        		$webmaster_email = $params->get('my_webmaster');
        		JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        	}
            
        }
        
        //--------------------------------------------------------
        // If connected OK, write the posted values back, then...
        //--------------------------------------------------------
        else {

        	if($params->get('my_debug')){
        		MyMuseHelper::logMessage("4. Connection successful. Now posting to ".PAYMENT_HOST."$paypalpath" );
        	}

        	fwrite($fp, $header . $workstring);
        	$res = '';
        	while (!feof($fp)) {
        		$res .= fgets ($fp, 1024);
        	}
        	fclose ($fp);

        	$error_description = "Response from ".PAYMENT_HOST.": " . $res."\n";

        	if($params->get('my_debug')){
        		MyMuseHelper::logMessage( "5. Response: $error_description ");
        	}

        	// Get the Order Details from the database
        	$query = "SELECT * FROM `#__mymuse_order`
                    WHERE `order_number`='".$order_number."'  ORDER BY id DESC
                    ";
        	if($params->get('my_debug')){
        		MyMuseHelper::logMessage( "6. $query ");
        	}
        	$db->setQuery($query);
        	if(!$this_order = $db->loadObject()){
        		if($params->get('my_debug')){
        			MyMuseHelper::logMessage( "!!!!Error: ".$db->_errorMsg);
        		}

        	}
        	$order_id 		= $this_order->id;
        	$user_id 		= $this_order->user_id;
        	$user 			=& JFactory::getUser($user_id);


        	$MyMuseCheckout =& MyMuse::getObject('checkout','helpers');
        	$MyMuseShopper  =& MyMuse::getObject('shopper','models');

        	$shopper 		=& $MyMuseShopper->getShopperByUser($user_id );
        	$user_email 	= $user->email;
        	$order 			= $MyMuseCheckout->getOrder($order_id);
        	$currency 		= $order->order_currency;
        	$heading 		= Jtext::_('MYMUSE THANK YOU');
        	$message 		= Jtext::_('MYMUSE HERE IS YOUR ORDER');

        	$this->assignRef('user'  , $user);
        	$this->assignRef('params', $params);
        	$this->assignRef('task', $task);
        	$this->assignRef('shopper', $shopper);
        	$this->assignRef('store', $MyMuseStore->_store);
        	$this->assignRef('order', $order);
        	$this->assignRef('currency', $currency);
        	$this->assignRef('heading', $heading);
        	$this->assignRef('message', $message);
        		

        	$notify_customer = "Y";
        	if($params->get('my_debug')){
        		MyMuseHelper::logMessage( "6.1 order_id = $order_id  user_email = $user_email payment_status = $payment_status");
        	}

        	// remove post headers if present.
        	$res = preg_replace("'Content-type: text/plain'si","",$res);

        	//-------------------------------------------
        	// ...read the results of the verification...
        	// If VERIFIED = continue to process the TX...
        	//-------------------------------------------
            if (preg_match ( "VERIFIED", $res) ) {
                //----------------------------------------------------------------------
                // If the payment_status is Completed... Get the password for the product
                // from the DB and email it to the customer.
                //----------------------------------------------------------------------
                if (preg_match ("Completed", $payment_status) || preg_match ("Pending", $payment_status)) {
                    
                    if (empty($order_id)) {
                        $subject = "PayPal IPN Transaction on your site: Order ID not found";
                        $message = "The right order_id wasn't found during a PayPal transaction on your website.
                        The Order Number received was: $order_number";
                        
                    	if($params->get('my_debug')){
        					MyMuseHelper::logMessage( "7.1 ERROR = $message");
        				}
        				JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
                    	if($params->get('my_cc_webmaster')){
        					$webmaster_email = $params->get('my_webmaster');
        					JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        				}
                        exit();
                    }


                    MyMuseHelper::orderStatusUpdate($order_id, "C");
                	if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.1 Updated Status order_id = $order_id 
        				order number = $order_number to Complete");
        			}
 
                    $subject = "PayPal IPN txn on your site";
                    $message = "Hello,\n\n";
                    $message .= "a PayPal transaction for you has been made on your website!\n";
                    $message .= "-----------------------------------------------------------\n";
                    $message .= "Transaction ID: $txn_id\n";
                    $message .= "Payer Email: $payer_email\n";
                    $message .= "Order ID: $order_id\n";
                    $message .= "Order Number: $order_number\n";
                    $message .= "Payment Status returned by PayPal: $payment_status\n";
                    $message .= "Order Status Code: ".$order_status;

                    JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
                    $message = '';
                    
                    // SEND MAIL TO BUYER WITH PASSWORD
                    $subject = Jtext::_('MYMUSE ORDER CONFIRMED AT')." ".$store->title;
     				$subject = html_entity_decode($subject, ENT_QUOTES,'UTF-8');
                    $downloadable = 0;
                    $download_header = '';
                    
                    foreach($order->items as $item){
                    	
                    	if($item->file_name != ''){
                    		$downloadable++;
                    	}
                    }
                    
                    include_once( JPATH_COMPONENT.DS.'templates'.DS.'mail_html_header.php' );

     				ob_start();
     				parent::display('checkout_header');
     				parent::display('order_summary');
					parent::display();
     				$contents .= ob_get_contents();
					ob_end_clean();
					
					if($downloadable){
						include_once( JPATH_COMPONENT.DS.'templates'.DS.'mail_downloads.php' );
					}
					
     				$message = $header.$download_header.$contents.$footer;
                    
     				JUtility::sendMail($mailfrom, $fromname, $user_email, $subject, $message, 1);
                	if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.2 Sent mail to  $user_email");
        			}
        			
        			if($params->get('my_cc_webmaster')){
        				$webmaster_email = $params->get('my_webmaster');
        				JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        			}
                    
                }
                elseif (preg_match ("Refunded", $payment_status)){
                    //----------------------------------------------------------------------
                    // If the payment_status is Refunded
                    //----------------------------------------------------------------------
                    // UPDATE THE ORDER STATUS to 'Refunded'

                    MyMuseHelper::orderStatusUpdate($order_id, "R");
                    
                    $subject = "PayPal IPN Transaction on your site";
                    $message = "Hello,
                    a PayPal Transaction on ".$store->name." was refunded.
                    -----------------------------------------------------------
                    Order ID: ".$order_id."
                    User ID: ".$user_id."
                    Payment Status returned by PayPal: $payment_status 
                    ";
                    JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
                	if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.1 Update Status order_id = $order_id  to Refunded");
        			}
            		if($params->get('my_cc_webmaster')){
        				$webmaster_email = $params->get('my_webmaster');
        				JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        			}
            }
                else { 
                    //----------------------------------------------------------------------
                    // If the payment_status is not Completed... do nothing but mail
                    //----------------------------------------------------------------------
                    // UPDATE THE ORDER STATUS to 'INVALID'

                    MyMuseHelper::orderStatusUpdate($order_id, "I");
                    
                    $subject = "PayPal IPN Transaction on your site";
                    $message = "Hello,
                    a Failed PayPal Transaction on ".$store->name." requires your attention.
                    -----------------------------------------------------------
                    Order ID: ".$order_id."
                    User ID: ".$user_id."
                    Payment Status returned by PayPal: $payment_status 
                    
                    $error_description";
                    JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
                	if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.1 Update Status order_id = $order_id  to INVALID");
        			}
                	if($params->get('my_cc_webmaster')){
        				$webmaster_email = $params->get('my_webmaster');
        				JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        			}
                    
                }
            }
            //----------------------------------------------------------------
            // ..If INVALID - It's 'Suspicious' and needs investigating!
            // Send an email to yourself so you investigate it.
            //----------------------------------------------------------------
            elseif (preg_match ("INVALID", $res)) {
                    $subject = "Invalid PayPal IPN Transaction on your site";
                    $message = "Hello,\n\n";
                    $message .= "An Invalid PayPal Transaction requires your attention.\n";
                    $message .= "-----------------------------------------------------------\n";
                    $message .= "REMOTE IP ADDRESS: ".$_SERVER['REMOTE_ADDR']."\n";
                    $message .= "REMOTE HOST NAME: $remote_hostname\n";
                    $message .= "Order ID: ".$order_id."\n";
                    $message .= "User ID: ".$user_id."\n";
                    $message .= $error_description;
                    JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
            		if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.1 SUSPICIOUS");
        			}
            		if($params->get('my_cc_webmaster')){
        				$webmaster_email = $params->get('my_webmaster');
        				JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        			}
    
            }
            elseif (preg_match ("Refunded", $payment_status)){
                    //----------------------------------------------------------------------
                    // If the payment_status is Refunded
                    //----------------------------------------------------------------------
                    // UPDATE THE ORDER STATUS to 'Refunded'

                    MyMuseHelper::orderStatusUpdate($order_id, "R");
                    
                    $subject = "PayPal IPN Transaction on your site";
                    $message = "Hello,
                    a PayPal Transaction on ".$store->name." was refunded.
                    -----------------------------------------------------------
                    Order ID: ".$order_id."
                    User ID: ".$user_id."
                    Payment Status returned by PayPal: $payment_status 
                    
                    $error_description";
                    JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
                	if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.1 Update Status order_id = $order_id  to Refunded");
        			}
            		if($params->get('my_cc_webmaster')){
        				$webmaster_email = $params->get('my_webmaster');
        				JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        			}
            }
            else {
                    $subject = "PayPal IPN Transaction on your Site";
                    $message = "Hello,
                    An error occured while processing a paypal transaction.
                    ----------------------------------
                    $error_description";
                    JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject, $message);
            		if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "7.1 ERROR $message");
        			}
            		if($params->get('my_cc_webmaster')){
        				$webmaster_email = $params->get('my_webmaster');
        				JUtility::sendMail($mailfrom, $fromname, $webmaster_email, $subject, $message,1);
        			}
            }

        }
		if($params->get('my_debug')){
        				MyMuseHelper::logMessage( "8 finished");
        }
		exit;
			
		
	}
}
?>