<?php
/**
 * @version		$Id: view.html.php 115 2010-09-23 03:18:21Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the MyMuse Category 
 *
 * @package		Joomla
 * @subpackage MyMuse
 * @since 1.5
 */
class myMuseViewProduct extends JView
{
	function __construct()       {
                 
        parent::__construct();   
    }
        
        
	function display($tpl = null)
	{
		global $mainframe,$params;
		
		$this->setLayout('product'); 
		$user		=& JFactory::getUser();
		$document	=& JFactory::getDocument();
		$dispatcher	=& JDispatcher::getInstance();
		$pathway	=& $mainframe->getPathway();

		// Initialize variables
		
		$product	=& $this->get('Product');
		$params->merge(new JParameter($product->attribs));

		if (($product->id == 0))
		{
			$id = JRequest::getVar( 'id', '', 'default', 'int' );
			return JError::raiseError( 404, JText::sprintf( 'MYMUSE PRODUCT NOT FOUND', $id ) );
		}

		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		
		if (!$params->get('intro_only') && ($this->getLayout() == 'default') && ($limitstart == 0))
		{
			$model =& $this->getModel();
			$model->hit();
		}

		// Create a user access object for the current user
		$access = new stdClass();
		$access->canEdit	= $user->authorize('com_product', 'edit', 'product', 'all');
		$access->canEditOwn	= $user->authorize('com_product', 'edit', 'product', 'own');
		$access->canPublish	= $user->authorize('com_product', 'publish', 'product', 'all');

		// Check to see if the user has access to view the full product
		$aid	= $user->get('aid');

		if ($product->access <= $aid) {
			$product->readmore_link = JRoute::_(myMuseHelperRoute::getProductRoute($product->slug, $product->catslug, $product->sectionid));
		} else {
			if ( ! $aid )
			{
				// Redirect to login
				$uri		= JFactory::getURI();
				$return		= $uri->toString();

				$url  = 'index.php?option=com_user&view=login';
				$url .= '&return='.base64_encode($return);;

				//$url	= JRoute::_($url, false);
				$mainframe->redirect($url, JText::_('MYMUSE YOU MUST LOGIN FIRST') );
			}
			else{
				JError::raiseWarning( 403, JText::_('MYMUSE ALERTNOTAUTH') );
				return;
			}
		}


		/*
		 * Handle the metadata
		 */
		// because the application sets a default page title, we need to get it
		// right from the menu item itself
		// Get the menu item object
		$menus = &JSite::getMenu();
		$menu  = $menus->getActive();

		if (is_object( $menu ) && isset($menu->query['view']) && $menu->query['view'] == 'product' && isset($menu->query['id']) && $menu->query['id'] == $product->id) {
			$menu_params = new JParameter( $menu->params );
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$product->title);
			}
		} else {
			$params->set('page_title',	$product->title);
		}
		$document->setTitle( $params->get( 'page_title' ) );

		if ($product->metadesc) {
			$document->setDescription( $product->metadesc );
		}
		if ($product->metakey) {
			$document->setMetadata('keywords', $product->metakey);
		}

		if ($mainframe->getCfg('MetaTitle') == '1') {
			$mainframe->addMetaTag('title', $product->title);
		}
		if ($mainframe->getCfg('MetaAuthor') == '1') {
			$mainframe->addMetaTag('author', $product->author);
		}

		$mdata = new JParameter($product->metadata);
		$mdata = $mdata->toArray();
		foreach ($mdata as $k => $v)
		{
			if ($v) {
				$document->setMetadata($k, $v);
			}
		}

		// If there is a pagebreak heading or title, add it to the page title
		if (!empty($product->page_title))
		{
			$product->title = $product->title .' - '. $product->page_title;
			$p = $limitstart + 1;
			$document->setTitle($product->page_title.' - '.JText::_('MYMUSE PAGE')." $p");
		}

		/*
		 * Handle the breadcrumbs
		 */
		if($menu && $menu->query['view'] != 'product')
		{
			switch ($menu->query['view'])
			{
				case 'section':
					$pathway->addItem($product->category, 'index.php?view=category&id='.$product->catslug);
					$pathway->addItem($product->title, '');
					break;
				case 'category':
					$pathway->addItem($product->title, '');
					break;
			}
		}

		$print = JRequest::getBool('print');
		if ($print) {
      		$document->setMetaData('robots', 'noindex, nofollow');
    	}
    	$Itemid	= JRequest::getVar('Itemid', 0, '', 'int');
    	$view	= JRequest::getVar('view', 0, '', 'string');
  	
    	$this->assignRef('view', $view);
    	$this->assignRef('Itemid', $Itemid);
		$this->assignRef('product', $product);
		$this->assignRef('params' , $params);
		$this->assignRef('user'   , $user);
		$this->assignRef('print', $print);

		parent::display($tpl);
	}
}
?>
