<?php
/**
 * @version		$Id: view.html.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');
/**
 * HTML View class for the MyMuse component
 *
 * @static
 * @package		Joomla
 * @subpackage	MyMuse
 * @since 1.5
 */
class MyMuseViewSection extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option, $params;

		// Initialize some variables
		$user		=& JFactory::getUser();
		$document	=& JFactory::getDocument();

		// Request variables
		$limit		= JRequest::getVar('limit', $params->get('display_num'), '', 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');
		$filter 	= JRequest::getString('filter', '', 'request');
		$Itemid		= JRequest::getString('Itemid', '', 'request');
		JRequest::setVar('limit', (int) $limit);

		// Get some data from the model
		$items		= & $this->get( 'Products');
		$total		= & $this->get( 'Total');
		$categories	= & $this->get( 'Categories' );
		$section	= & $this->get( 'Section' );

		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();

		// because the application sets a default page title, we need to get it
		// right from the menu item itself
		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$section->title);
			}
		} else {
			$params->set('page_title',	$section->title);
		}
		$document->setTitle( $params->get( 'page_title' ) );
		$params->merge($menu->params);

		//if no section was chosen
		if(is_array($section)){
			$this->assignRef('old_layout',	JRequest::getVar('layout','list'));
			$this->setLayout('list');
			$this->assignRef('items',		$items);
			$this->assignRef('section',		$section);
			$this->assignRef('categories',	$categories);
			$this->assignRef('params',		$params);
			$this->assignRef('user',		$user);
			$this->assignRef('access',		$access);
			$this->assignRef('pagination',	$pagination);

			parent::display($tpl);
			return true;
		}
		
		// Prepare section description
		$section->description = JHTML::_('content.prepare', $section->description);

		// make links for categories
		for($i = 0; $i < count($categories); $i++)
		{
			$category =& $categories[$i];
			$category->link = JRoute::_(MyMuseHelperRoute::getCategoryRoute($category->slug, $category->section, $params));

			// Prepare category description
			$category->description = JHTML::_('content.prepare', $category->description);
		}
		
		// make links for items
		for($i = 0; $i < count($items); $i++)
		{
			$item =& $items[$i];
			$item->link = JRoute::_(MyMuseHelperRoute::getProductRoute($item->id));

		}

		if ($total == 0) {
			$params->set('show_categories', false);
		}

		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		$layout = JRequest::getVar('layout','list');

		$this->assign('total',			$total);
		$this->assign('limit',			$limit);
		$this->assignRef('items',		$items);
		$this->assignRef('section',		$section);
		$this->assignRef('categories',	$categories);
		$this->assignRef('params',		$params);
		$this->assignRef('user',		$user);
		$this->assignRef('access',		$access);
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('layout',		$layout);
		$this->assign('filter',			$filter);
		$this->assign('Itemid',			$Itemid);

		parent::display($tpl);
	}

	function &getItem( $index = 0, &$params)
	{
		global $mainframe;

		// Initialize some variables
		$user		=& JFactory::getUser();
		$dispatcher	=& JDispatcher::getInstance();

		$SiteName	= $mainframe->getCfg('sitename');

		$task		= JRequest::getCmd('task');

		$linkOn		= null;
		$linkText	= null;

		$item =& $this->items[$index];
		$item->text = $item->introtext;

		// Get the page/component configuration and article parameters
		$item->params = clone($params);
		$aparams = new JParameter($item->attribs);

		// Merge article parameters into the page configuration
		$item->params->merge($aparams);

		// Process the content preparation plugins
		JPluginHelper::importPlugin('content');
		$results = $dispatcher->trigger('onPrepareContent', array (& $item, & $item->params, 0));

		// Build the link and text of the readmore button
		if (($item->params->get('show_readmore') && @ $item->readmore) || $item->params->get('link_titles'))
		{
			// checks if the item is a public or registered/special item
			if ($item->access <= $user->get('aid', 0))
			{
				//$item->readmore_link = JRoute::_("index.php?view=article&id=".$item->slug);
				$item->readmore_link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug, $item->sectionid));
				$item->readmore_register = false;
			}
			else
			{
				$item->readmore_link = JRoute::_("index.php?option=com_user&view=login");
				$returnURL = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug, $item->sectionid),false);
				$fullURL = new JURI($item->readmore_link);
				$fullURL->setVar('return', base64_encode($returnURL));
				$item->readmore_link = $fullURL->toString();
				$item->readmore_register = true;
			}
		}

		$item->event = new stdClass();
		$results = $dispatcher->trigger('onAfterDisplayTitle', array (& $item, & $item->params,0));
		$item->event->afterDisplayTitle = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onBeforeDisplayContent', array (& $item, & $item->params, 0));
		$item->event->beforeDisplayContent = trim(implode("\n", $results));

		$results = $dispatcher->trigger('onAfterDisplayContent', array (& $item, & $item->params, 0));
		$item->event->afterDisplayContent = trim(implode("\n", $results));

		return $item;
	}
}
