<?php
/**
 * @version		$Id: view.html.php 111 2010-09-22 16:56:17Z gfisch $
 * @package		mymuse
 * @copyright	Copyright © 2010 - Arboreta Internet Services - All rights reserved.
 * @license		GNU/GPL
 * @author		Gordon Fisch
 * @author mail	info@mymuse.ca
 * @website		http://www.mymuse.ca
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view' );

class myMuseViewStore extends Jview
{
	function display($tpl = null){
		global $mainframe,$params;
		
		$task = JRequest::getVar('task','');
		
		// Present a list of downloadable files
        if($task == "downloads"){
        	// make sure we have an id
        	$id = JRequest::getVar('id',0);
        	if(!$id){
        		$message = JText::_('MYMUSE NO DOWNLOAD KEY');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}

        	$db	= & JFactory::getDBO();
        	$query = "SELECT * FROM #__mymuse_order WHERE order_number = '$id'";
        	$db->setQuery($query);
        	$row = $db->loadObject();

        	//Make sure we have an order
        	if(!$row){
        		$message = JText::_('MYMUSE NO MATCHING ORDER');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}
        	
        	// make sure it's the same person who ordered!
        	$MyMuseShopper 	=& MyMuse::getObject('shopper','models');

        	if($row->user_id != $MyMuseShopper->_shopper->user_id){
        		$message = JText::_('MYMUSE USER ORDER OWNER MISMATCH');
        		if($params->get('my_debug')){
        				$message .= $row->user_id.' : '.$MyMuseShopper->_shopper->user_id;
        		}
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}
        	
        	//if it is a reload, update the database
        	$item_id = JRequest::getVar('item_id',0);
        	if($item_id){
        		// update the database
        		$query = "SELECT * FROM #__mymuse_order_item WHERE id=$item_id";
        		$db->setQuery($query);
        		$item = $db->loadObject();
        		
        		if($item->downloads == 0){
        			$query = "UPDATE #__mymuse_product SET file_downloads = file_downloads +1 WHERE id=".$item->product_id;
        			$db->setQuery($query);
        			$db->query();
        		}
        		
        		$query = "UPDATE #__mymuse_order_item SET downloads = downloads +1 WHERE id=$item_id";
        		$db->setQuery($query);
        		$db->query();
        	}

			$MyMuseCheckout 		=& MyMuse::getObject('checkout','helpers');
			$MyMuseCart 			=& MyMuse::getObject('cart','helpers');
        	$MyMuseShopper->order 	= $MyMuseCheckout->getOrder($row->id);

        	for($i = 0; $i < count($MyMuseShopper->order->items); $i++){
        		if($MyMuseShopper->order->items[$i]->file_name == ''){
        			// see if it's an 'ALL FILES
        			$query = "SELECT product_allfiles from #__mymuse_product 
        			WHERE id='".$MyMuseShopper->order->items[$i]->product_id."'";
        			$db->setQuery($query);
        			$all_files = $db->loadResult();
        			if($all_files){
        				unset($MyMuseShopper->order->items[$i]);
        			}
        		}
        	}
        	
        	$uri = &JFactory::getURI();
			$current =  $uri->current()."?option=com_mymuse&task=downloads&id=".$id."&item_id=";
			$this->assignRef( 'current', $current );
        	$this->assignRef( 'order', $MyMuseShopper->order );
        	$this->assignRef( 'params', $params );
        	$this->assignRef( 'id', $id );
        	
        	$tpl = "downloads";
        	parent::display($tpl);
        	return true;
        }
        
        // trying to download a file!!
        if($task == "downloadfile"){
        	
        	// make sure we have a download key
        	$id = JRequest::getVar('id',0);
        	if(!$id){
        		$message = JText::_('MYMUSE NO DOWNLOAD KEY');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}
        	
        	// make sure we have an order item id
        	$item_id = JRequest::getVar('item_id',0);
        	if(!$item_id){
        		$message = JText::_('MYMUSE NO ORDERITEM ID');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}

        	
        	$db	= & JFactory::getDBO();
			$query = "SELECT * FROM #__mymuse_order WHERE order_number = '$id'";
			$db->setQuery($query);
			$row = $db->loadObject();
		
			//Make sure we have an order
        	if(!$row){
        		$message = JText::_('MYMUSE NO MATCHING ORDER ');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}
        	
        	// make sure it's the same person who ordered!
        	$MyMuseShopper 	=& MyMuse::getObject('shopper','models');

        	if($row->user_id != $MyMuseShopper->_shopper->user_id){
        		$message = JText::_('MYMUSE USER ORDER OWNER MISMATCH');
        		//$row->user_id.' : '.$MyMuseShopper->_shopper->user_id;
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}
        	
        	$MyMuseCheckout =& MyMuse::getObject('checkout','helpers');
			$MyMuseCart 	=& MyMuse::getObject('cart','helper');
			
        	$order = $MyMuseCheckout->getOrder($row->id);
        	for($i = 0; $i < count($order->items); $i++){
        		if($order->items[$i]->id == $item_id){
        			$order_item = $order->items[$i];
        		}
        	}
        			
        	$filename = stripslashes($order_item->file_name);
        	
        	// check number of downloads
        	if(intval($order_item->downloads) >= $params->get('my_download_max')){
        		$message = JText::_('MYMUSE MAX NUMBER OF DOWNLOADS REACHED');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}
        			
        	// check expiry date
        	if($order_item->end_date <= time()){
        		$message = JText::_('MYMUSE DOWNLOAD EXPIRED');
        		$this->assignRef( 'message', $message );
        		$tpl = "message";
        		parent::display($tpl);
        		return false;
        	}

			$query = "SELECT * FROM #__mymuse_product WHERE id = '".$order_item->product_id."'";
			//echo $query;
			$db->setQuery($query);
			$product = $db->loadObject();

        	$object	=& MyMuse::getObject('httpdownload','helpers');
        	
        	// download data from the database
        	if($params->get('my_use_database')){
        		if(!$object->set_bydata($product->file_contents)){
        			$message = JText::_('MYMUSE DOWNLOAD UNABLE TO LOAD DATA');
        			if($params->get('my_debug')){
        				$message .= $product->file_name;
        			}
        			$this->assignRef( 'message', $message );
        			$tpl = "message";
        			parent::display($tpl);
        			return false;

        		}else{

        			$object->use_resume = true; //Enable Resume Mode
        			$object->set_filename(stripslashes($product->file_name)); //Set download name
        			//$mime = $product->file_type;
        			if($product->file_type == 'application/zip'){
        				$mime = "application/zip";
        			}else{
        				$mime = "application/otect-stream";
        			}

        			$object->set_mime($mime); //File MIME (Default: application/otect-stream)
        			$object->download(); //Download File

        		}
        	}else{
        		//download a physical file
        		if(!$filename){
        			$message = JText::_('MYMUSE NO FILENAME FOUND');
        			if($params->get('my_debug')){
        				$message .= $filename;
        			}
        			$this->assignRef( 'message', $message );
        			$tpl = "message";
        			parent::display($tpl);
        			return false;
        		}
				$artist_alias = MyMuseHelper::getArtistAlias($product->parentid,$params);
				$album_alias = MyMuseHelper::getAlbumAlias($product->parentid);
        	    if($params->get('my_encode_filenames')){
        			$name = $product->title_alias;
        		}else{
        			$name = $filename;
        		}
        		$full_filename = $params->get('my_download_dir').DS.$artist_alias.DS.$album_alias.DS.$name;
        		$full_filename1 = $full_filename;
        		if(!file_exists($full_filename)){
        			//try with the root
        			$full_filename = JPATH_ROOT.DS.$params->get('my_download_dir').DS.$artist_alias.DS.$album_alias.DS.$name;
        		}
        		if(!file_exists($full_filename)){
        			$message = JText::_('MYMUSE NO FILE FOUND');
        			if($params->get('my_debug')){
        				$message .= $name;
        			}
        			$this->assignRef( 'message', $message );
        			$tpl = "message";
        			parent::display($tpl);
        			return false;
        		}
        		
        		if(!$object->set_byfile($full_filename,$filename)){ //Download from a file
        			$message = JText::_('MYMUSE DOWNLOAD UNABLE TO LOAD FILE');
        			if($params->get('my_debug')){
        				$message .= $name;
        			}
        			$this->assignRef( 'message', $message );
        			$tpl = "message";
        			parent::display($tpl);
        			return false;
        		}else{
        			$object->use_resume = true; //Enable Resume Mode
        			$object->download(); //Download File
        			// update the database
        			$query = "UPDATE #__mymuse_order_item SET downloads = downloads +1 WHERE id=$item_id";
        			$db->setQuery($query);
        			$db->query();
        		}
        	}

        	exit;
        	
        }
        
		$model =& $this->getModel();
		$row = $model->getStore();
        $this->assignRef( 'row', $row );
		parent::display($tpl);

	}

}
?>